package MayLib;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;


public class FileEncoding
{

	/**
	 * Gibt die Kodierung einer angegebenen Datei durch berprfung der
	 *  Byte Order Mark (BOM) zurck.
	 * @param Filename
	 * 		- Der Name der zu berprfenden Datei.
	 * @return
	 * 		- Kodierung: UTF-8, UTF-16 oder die Standardkodierung des Systems. 
	 */
	public static String getEnCoding(String Filename)
	{
		BufferedReader reader = null;
		String encoding = System.getProperty("file.encoding");
		char buffer[] = new char[3];		
		int length;
		
		try
		{
			reader = new BufferedReader(new InputStreamReader(new FileInputStream(Filename)));
			length = reader.read(buffer);
			
			if (length >=2)
			{
				
				if ((buffer[0] == (char)0xff && buffer[1] == (char)0xfe) /* UTF-16, little endian */ ||
						(buffer[0] == (char)0xfe && buffer[1] == (char)0xff) /* UTF-16, big endian    */)
						encoding = "UTF-16";
				
//				if (buffer[0] == (char)0xff && buffer[1] == (char)0xfe) /* UTF-16, little endian */ 
//					encoding = "UTF-16LE";
//				
//				if (buffer[0] == (char)0xfe && buffer[1] == (char)0xff) /* UTF-16, big endian    */
//						encoding = "UTF-16BE";
			}

			if (length >=3)
			{
				
				if (buffer[0] == (char)0xef && buffer[1] == (char)0xbb && buffer[2] == (char)0xbf) /* UTF-8 */ 
					encoding = "UTF-8";
			}
			
		}
		catch (Exception ex) {}
		
		try
		{
			reader.close();
		}
		catch (IOException e){}
		
		return encoding;
		
	}
	
	
}
