/**
 * 
 */
package MayLib;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author Dr. Andreas May, email: may_devonian at yahoo.es
 *
 */

public class Libref implements Comparable<Libref>
{
	private String Author_1, Author_2, Author_3, Author_4, Year, Editor, Title, In_Book_title, 
	Volume, Pages, Figures, Number_of_tables, Plates, Bibliographic_data, Editorial, Type, 
	Keyword_1, Keyword_2, Keyword_3, Catalogue_Number, Storing_place, Remarks, Date_Entry, ISBN, Abstract; 

	private final String lineFeed = System.getProperty("line.separator");
	
	public static int getAttributeLength(String Attribute)
	{
		if (Attribute.equalsIgnoreCase("Author_1"))
			return 70;
		else if (Attribute.equalsIgnoreCase("Author_2"))
			return 70;
		else if (Attribute.equalsIgnoreCase("Author_3"))
			return 70;
		else if (Attribute.equalsIgnoreCase("Author_4"))
			return 400;
		else if (Attribute.equalsIgnoreCase("Year"))
			return 20;
		else if (Attribute.equalsIgnoreCase("Editor"))
			return 20;
		else if (Attribute.equalsIgnoreCase("Title"))
			return 400;
		else if (Attribute.equalsIgnoreCase("In_Book_title"))
			return 400;
		else if (Attribute.equalsIgnoreCase("Volume"))
			return 70;
		else if (Attribute.equalsIgnoreCase("Pages"))
			return 70;
		else if (Attribute.equalsIgnoreCase("Figures"))
			return 20;
		else if (Attribute.equalsIgnoreCase("Number_of_tables"))
			return 10;
		else if (Attribute.equalsIgnoreCase("Plates"))
			return 40;
		else if (Attribute.equalsIgnoreCase("Bibliographic_data"))
			return 400;
		else if (Attribute.equalsIgnoreCase("Editorial"))
			return 200;
		else if (Attribute.equalsIgnoreCase("Type"))
			return 40;
		else if (Attribute.equalsIgnoreCase("Keyword_1"))
			return 40;
		else if (Attribute.equalsIgnoreCase("Keyword_2"))
			return 40;
		else if (Attribute.equalsIgnoreCase("Keyword_3"))
			return 40;
		else if (Attribute.equalsIgnoreCase("Catalogue_Number"))
			return 40;
		else if (Attribute.equalsIgnoreCase("Storing_place"))
			return 60;
		else if (Attribute.equalsIgnoreCase("Remarks"))
			return 400;
		else if (Attribute.equalsIgnoreCase("Date_Entry"))
			return 20;
		else if (Attribute.equalsIgnoreCase("ISBN"))
			return 20;
		else if (Attribute.equalsIgnoreCase("Abstract"))
			return 95000;
		else
			return 1000;				
	}

	/*Length & Tooltip in Access DB: 
	 Author_1: 50, 1. Author --  OBLIGATORY FIELD (Must be filled)!
	 Author_2: 50, 
	 Author_3: 50,
	 Author_4: 70 , 
	 Year: 10, Year of Publication --  OBLIGATORY FIELD (Must be filled)!
	 Editor: 8, Field will be filled with "Eds." if necessary.
	 Title: 255, 
	 In_Book_title: 255, If the publication is an article in a book, is this the place for the title of the book.
	Volume: 50, Volume (and Number)
	Pages: 40, First and last page;
	Figures 10, Number of figures
	Number_of_tables: 4, Number of Tables
	Plates 20, First and last plate
	Bibliographic_data: 255, Place of Publication (IF NOT IN A PERIODICAL) and further bibliographic data
	Editorial: 100, 
	Type 25, Is it a book, a reprint, a PDF file, xerocopies, etc.?
	Keyword_1: 25 1. Keyword --  OBLIGATORY FIELD (Must be filled)!, 
	Keyword_2: 25 , 
	Keyword_3: 25, 
	Catalogue_Number 17 , The catalogue number given by the owner --  OBLIGATORY FIELD (Must be filled)! 
	Storing_place: 50,  Where is the publication stored now?, 
	Remarks: 255,   Default value:"Bibliographic Data Incomplete! / Abstract in field Abstract"
	Date_Entry (originally date)
	ISBN: 15 
	Abstract: (95.000), Abstract, Summary, or List of Contents of the Publication; 
	*/
	public static String getAttributeTooltip(String Attribute)
	{
		if (Attribute.equalsIgnoreCase("Author_1"))
			return "1st Author - OBLIGATORY FIELD (Must be filled)!";
		else if (Attribute.equalsIgnoreCase("Author_2"))
			return "2nd Author";
		else if (Attribute.equalsIgnoreCase("Author_3"))
			return "3rd Author";
		else if (Attribute.equalsIgnoreCase("Author_4"))
			return "4th Author and all further authors";
		else if (Attribute.equalsIgnoreCase("Year"))
			return "Year of publication - OBLIGATORY FIELD (Must be filled)";
		else if (Attribute.equalsIgnoreCase("Editor"))
			return "Field will be filled with \"Eds.\" if necessary";
		else if (Attribute.equalsIgnoreCase("Title"))
			return "Title of the publication";
		else if (Attribute.equalsIgnoreCase("In_Book_title"))
			return "If the publication is an article in a book, is this the place for the title of the book";
		else if (Attribute.equalsIgnoreCase("Volume"))
			return "Volume (and number)";
		else if (Attribute.equalsIgnoreCase("Pages"))
			return "First and last page";
		else if (Attribute.equalsIgnoreCase("Figures"))
			return "Number of figures";
		else if (Attribute.equalsIgnoreCase("Number_of_tables"))
			return "Number of tables";
		else if (Attribute.equalsIgnoreCase("Plates"))
			return "First and last plate";
		else if (Attribute.equalsIgnoreCase("Bibliographic_data"))
			return "Place of Publication (IF NOT IN A PERIODICAL) and further bibliographic data";
		else if (Attribute.equalsIgnoreCase("Editorial"))
			return "Editorial (in reports normally not used). In doubt use field \"Bibliographic_data\"!";
		else if (Attribute.equalsIgnoreCase("Type"))
			return "Is it a book, a reprint, a PDF file, xerocopies, etc.?";
		else if (Attribute.equalsIgnoreCase("Keyword_1"))
			return "1st Keyword - OBLIGATORY FIELD (Must be filled)!";
		else if (Attribute.equalsIgnoreCase("Keyword_2"))
			return "2nd Keyword";
		else if (Attribute.equalsIgnoreCase("Keyword_3"))
			return "3rd Keyword";
		else if (Attribute.equalsIgnoreCase("Catalogue_Number"))
			return "The catalogue number given by the owner - OBLIGATORY FIELD (Must be filled)!";
		else if (Attribute.equalsIgnoreCase("Storing_place"))
			return "Where is the publication stored now? (In case of PDF files: file name)";
		else if (Attribute.equalsIgnoreCase("Remarks"))
			return "Remarks";
		else if (Attribute.equalsIgnoreCase("Date_Entry"))
			return "Date of the entry of the reference in the data base in the format YYYYMMDD_HH:min";
		else if (Attribute.equalsIgnoreCase("ISBN"))
			return "ISBN number of the book";
		else if (Attribute.equalsIgnoreCase("Abstract"))
			return "Abstract, Summary, or List of Contents of the Publication";
		else
			return "";
				
	}
	
	//If it is published in a periodical, than here the connection to Title and Place of the periodical.
	private Periodical Periodical;
	
	// Now they are filling all related to "implements Comparable<Periodical>"
	// compareValue = Standardwert fr den Vergleich
	private String compareValue;

	public String getCompareValue() 
	{
		return this.compareValue;
	}

	// makeCompareValue permits to construct the value of compareValue,
	// which has the function as kind of primary key.
	// In this way it can be proven, that a given combination exists only one
	// time.
	public static String makeCompareValue(String Author_1, String Author_2, String Author_3, String Author_4, String Year) 
	{
		String s = "Error";
		
		s = Author_1;
		
		if (Author_2.length() > 0)
			s += "; " + Author_2;
		
		if (Author_3.length() > 0)
			s += "; " + Author_3;
		
		if (Author_4.length() > 0)
			s += "; " + Author_4;
		
		s += " " + Year;
		
		// to Lower Case to allow that the Treemap orders correctly
		return s.toLowerCase();
	}
	
	
	public String toString()
	{
		StringBuilder sb = new StringBuilder();
		sb.append(Author_1);
		
		if (Author_2.length() > 0)
			sb.append(" & ").append(Author_2);
		
		if (Author_3.length() > 0)
			sb.append(" & ").append(Author_3);
		
		if (Author_4.length() > 0)
			sb.append(" & ").append(Author_4);
		
		if (Editor.length() > 0)
			sb.append(" [").append(Editor).append("]");
		
		sb.append(" (").append(Year).append(")");
		
		if (Title.length() > 0)
		{
			sb.append(": ").append(Title);
			if (!Title.endsWith("."))
				sb.append(".");
		}
		
		if (In_Book_title.length() > 0)
		{
			sb.append(" In: ").append(In_Book_title);
			if (!In_Book_title.endsWith("."))
				sb.append(".");
		}
		
		
		if (this.Periodical != null)
			sb.append(" - ").append(this.Periodical.getName()).append(", ");
		
		if (Volume.length() > 0)
			sb.append(Volume).append(": ");
		
		if (this.Periodical == null)
			sb.append(" - ");
		
			sb.append(Pages);
		
		if (this.Periodical != null)
		{
			if (this.Periodical.getPlace().length() > 0)
				sb.append("; ").append(this.Periodical.getPlace()).append(".");
			else 
				sb.append(".");
		}
		else
		{
			if (this.Bibliographic_data.length() > 0)
			{
				sb.append("; ").append(this.Bibliographic_data);
				if (!Bibliographic_data.endsWith("."))
					sb.append(".");
			}
			else 
				sb.append(".");
		}
						
		return sb.toString();
	}

	// Implementierung Comparable-Schnittstelle um eine aufsteigende Sortierung
	// zu erreichen.
	// compareToIgnoreCase fr die Sortierungen, da sonst die
	// Grossbuchstaben vor die Kleinbuchstaben sortiert werden.
	@Override
	public int compareTo(Libref that)
	{
		
		// Aufsteigend sortieren
		return this.compareValue.compareToIgnoreCase(that.compareValue);
		// Absteigend absteigend
		//	return this.compareValue.compareToIgnoreCase(that.compareValue) * -1;
	}
	
	
	// Wenn equals() nicht sinnvoll berschrieben wird verhlt es sich wie ==
	// also werden Referenzen verglichen und keine Werte.
	
	@Override
	public boolean equals(Object that)
	{
		
		// Wenn auf das gleiche Objekt verwiesen wird
		if (this == that) return true;
		
		// Wenn der Argumenttyp ungltig (kein Vergleich von pfel mit Birnen)
		if (!(that instanceof Libref)) return false;
				
		return (this.compareValue.compareTo(((Libref)that).compareValue) == 0);
	
	}

	// Eine Klasse die 'equals() berschreibt muss auch die Methode 
	// hashCode() berschreiben.
	@Override
	public int hashCode()
	{
		
		if (this.compareValue == null)
			return 0;
		
		return this.compareValue.hashCode();
		
	}
	
	public void setAuthorsYear(String Author_1, String Author_2, String Author_3, String Author_4, String Year)
	{
		this.Author_1 = Author_1;
		this.Author_2 = Author_2;
		this.Author_3 = Author_3;
		this.Author_4 = Author_4;
		this.Year = Year;
		this.compareValue = makeCompareValue(this.Author_1, this.Author_2, this.Author_3, this.Author_4, this.Year);
	}
	
	public Libref (String Author_1, String Author_2, String Author_3, String Author_4, String Year)
	{
		this.setAuthorsYear(Author_1, Author_2, Author_3, Author_4, Year);
		this.Catalogue_Number ="0";	
		
		Date date = new Date(); 
	    SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HH:mm");		
		this.Date_Entry = sdf.format(date);
	}
	
	public Periodical getPeriodical()
	{
		return this.Periodical;
	}
	
	public void setPeriodical(Periodical Periodical)
	{
		this.Periodical = Periodical;
	}
	
	public String getAuthor_1()
	{
		return this.Author_1;
	}
	
	public String getAuthor_2()
	{
		return this.Author_2;
	}
	
	public String getAuthor_3()
	{
		return this.Author_3;
	}
	
	public String getAuthor_4()
	{
		return this.Author_4;
	}
	
	public String getYear()
	{
		return this.Year;
	}
	
	public String getEditor()
	{
		return this.Editor;
	}
	
	public String getTitle()
	{
		return this.Title;
	}
	
	public String getIn_Book_title()
	{
		return this.In_Book_title;
	}
	
	public String getVolume()
	{
		return this.Volume;
	}
	
	public String getPages()
	{
		return this.Pages;
	}
	
	public String getFigures()
	{
		return this.Figures;
	}	
	
	public String getNumber_of_tables()
	{
		return this.Number_of_tables;
	}	
	
	public String getPlates()
	{
		return this.Plates;
	}	
	
	public String getBibliographic_data()
	{
		return this.Bibliographic_data;
	}	
	
	public String getEditorial()
	{
		return this.Editorial;
	}		
	
	public String getType()
	{
		return this.Type;
	}		
	
	public String getKeyword_1()
	{
		return this.Keyword_1;
	}		
	
	public String getKeyword_2()
	{
		return this.Keyword_2;
	}		
	
	public String getKeyword_3()
	{
		return this.Keyword_3;
	}		
	
	public String getCatalogue_Number()
	{
		return this.Catalogue_Number;
	}		
	
	public String getStoring_place()
	{
		return this.Storing_place;
	}		
	
	public String getRemarks()
	{
		return this.Remarks;
	}		
	
	public String getDate_Entry()
	{
		return this.Date_Entry;
	}		
	
	public String getISBN()
	{
		return this.ISBN;
	}		
	
	public String getAbstract()
	{
		return this.Abstract;
	}	
	
	public void setEditor(String Editor)
	{
		this.Editor = Editor;
	}
	
	public void setTitle(String Title)
	{
		this.Title = Title;
	}
	
	public void setIn_Book_title(String In_Book_title)
	{
		this.In_Book_title = In_Book_title;
	}
	
	public void setVolume(String Volume)
	{
		this.Volume = Volume;
	}
	
	public void setPages(String Pages)
	{
		this.Pages = Pages;
	}
	
	public void setFigures(String Figures)
	{
		this.Figures = Figures;
	}
	
	public void setNumber_of_tables(String Number_of_tables)
	{
		this.Number_of_tables = Number_of_tables;
	}
	
	public void setPlates(String Plates)
	{
		this.Plates = Plates;
	}
	
	public void setBibliographic_data(String Bibliographic_data)
	{
		this.Bibliographic_data = Bibliographic_data;
	}
	
	public void setEditorial(String Editorial)
	{
		this.Editorial = Editorial;
	}
	
	public void setType(String Type)
	{
		this.Type = Type;
	}
	
	public void setKeyword_1(String Keyword_1)
	{
		this.Keyword_1 = Keyword_1;
	}
	
	public void setKeyword_2(String Keyword_2)
	{
		this.Keyword_2 = Keyword_2;
	}
	
	public void setKeyword_3(String Keyword_3)
	{
		this.Keyword_3 = Keyword_3;
	}
	
	public void setCatalogue_Number(String Catalogue_Number)
	{
		// It is incialized and will be filled only with values, never with null
		
		if (Catalogue_Number.trim().length() > 0)
				this.Catalogue_Number = Catalogue_Number;
	}
	
	public void setStoring_place(String Storing_place)
	{
		this.Storing_place = Storing_place;
	}
	
	public void setRemarks(String Remarks)
	{
		this.Remarks = Remarks;
	}
	
	public void setDate_Entry(String Date_Entry)
	{
		// It is incialized and will be filled only with values, never with null
		if (Date_Entry.trim().length() > 0)
		this.Date_Entry = Date_Entry;
	}
	
	public void setISBN(String ISBN)
	{
		this.ISBN = ISBN;
	}
	
	public void setAbstract(String Abstract)
	{
		this.Abstract = Abstract;
	}
	
	/*	
	0 Author_1 
	1 Author_2 
	2 Author_3 
	3 Author_4 
	4 Year 
	5 Editor
	6 Title 
	7 In_Book_title 
	8 Volume 
	9 Pages 
	10 Figures 
	11 Number_of_tables 
	12 Plates 
	13 Bibliographic_data 
	14 Editorial 
	15 Type 
	16 Keyword_1 
	17 Keyword_2 
	18 Keyword_3 
	19 Name 
	20 Place 
	21 Abreviated_Name 
	22 ISSN 
	23 Language
	24 Catalogue_Number 
	25 Storing_place 
	26 Remarks 
	27 Date_Entry 
	28 ISBN 
	29 Abstract	
	
	*/

	
	public String expComplete()
	{
		// Exporting all of a Libref to a String, for a Report, without the abstract
		
		StringBuilder sb = new StringBuilder();
		sb.append(Author_1);
		
		if (Author_2.length() > 0)
			sb.append(" & ").append(Author_2);
		
		if (Author_3.length() > 0)
			sb.append(" & ").append(Author_3);
		
		if (Author_4.length() > 0)
			sb.append(" & ").append(Author_4);
		
		if (Editor.length() > 0)
			sb.append(" [").append(Editor).append("]");
		
		sb.append(" (").append(Year).append(")");
		
		if (Title.length() > 0)
		{
			sb.append(": ").append(Title);
			if (!Title.endsWith("."))
				sb.append(".");
		}
		
		if (In_Book_title.length() > 0)
		{
			sb.append(" In: ").append(In_Book_title);
			if (!In_Book_title.endsWith("."))
				sb.append(".");
		}
		
		if (this.Periodical != null)
			sb.append(" - ").append(this.Periodical.getName()).append(", ");
		
		if (Volume.length() > 0)
			sb.append("vol. ").append(Volume).append(": ");
		
		if (this.Periodical == null)
			sb.append(" - ");
		
		sb.append("p. ").append(Pages);
		
		if (Figures.length() > 0)
			sb.append(", ").append(Figures).append(" figs.");
		
		if (Number_of_tables.length() > 0)
			sb.append(", ").append(Number_of_tables).append(" tabs.");
		
		if (Plates.length() > 0)
			sb.append(", pl. ").append(Plates);
		
		if (this.Periodical != null)
		{
			if (this.Periodical.getPlace().length() > 0)
				sb.append("; ").append(this.Periodical.getPlace()).append(".");
			else 
				sb.append(".");
		}
		else
		{
			if (this.Bibliographic_data.length() > 0)
			{
				sb.append("; ").append(this.Bibliographic_data);
				if (!Bibliographic_data.endsWith("."))
					sb.append(".");
			}
			else 
				sb.append(".");
		}
		
		sb.append(lineFeed).append("--- Additional data ---").append(lineFeed);
		
		if (Type.length() > 0)
			sb.append("Type: ").append(Type).append("; ");
		
		if (Storing_place.length() > 0)
			sb.append("Storing place: ").append(Storing_place).append("; ");
		
		sb.append("Keyword_1: ").append(Keyword_1).append("; ");
		
		if (Keyword_2.length() > 0)
			sb.append("Keyword_2: ").append(Keyword_2).append("; ");
		
		if (Keyword_3.length() > 0)
			sb.append("Keyword_3: ").append(Keyword_3).append("; ");
		
		sb.append("Catalogue number: ").append(Catalogue_Number).append("; ");
		
		sb.append("Entry date: ").append(Date_Entry).append("; ");
		
		if (ISBN .length() > 0)
			sb.append("ISBN : ").append(ISBN).append("; ");
		
		if (Editorial.length() > 0)
			sb.append("Editorial: ").append(Editorial).append("; ");
		
		if (this.Periodical != null)
		{
			if (this.Periodical.getLanguage().length() > 0)
				sb.append("Language of the periodical: ").append(Periodical.getLanguage()).append(".");
		}
		
		if (Remarks.length() > 0)
			sb.append(lineFeed).append("Remarks: ").append(Remarks).append(".");
		
		sb.append(lineFeed);
						
		return sb.toString();
	}
	

	public String showComplete()
	{
		// Exporting all of a Libref to a String, for a textwindow, with the abstract
		
		StringBuilder sb = new StringBuilder();
		sb.append(Author_1);
		
		if (Author_2.length() > 0)
			sb.append(" & ").append(Author_2);
		
		if (Author_3.length() > 0)
			sb.append(" & ").append(Author_3);
		
		if (Author_4.length() > 0)
			sb.append(" & ").append(Author_4);
		
		if (Editor.length() > 0)
			sb.append(" [").append(Editor).append("]");
		
		sb.append(" (").append(Year).append(")");
		
		if (Title.length() > 0)
		{
			sb.append(": ").append(Title);
			if (!Title.endsWith("."))
				sb.append(".");
		}
		
		if (In_Book_title.length() > 0)
		{
			sb.append(" In: ").append(In_Book_title);
			if (!In_Book_title.endsWith("."))
				sb.append(".");
		}
		
		if (this.Periodical != null)
			sb.append(" - ").append(this.Periodical.getName()).append(", ");
		
		if (Volume.length() > 0)
			sb.append("vol. ").append(Volume).append(": ");
		
		if (this.Periodical == null)
			sb.append(" - ");
		
		sb.append("p. ").append(Pages);
		
		if (Figures.length() > 0)
			sb.append(", ").append(Figures).append(" figs.");
		
		if (Number_of_tables.length() > 0)
			sb.append(", ").append(Number_of_tables).append(" tabs.");
		
		if (Plates.length() > 0)
			sb.append(", pl. ").append(Plates);
		
		if (this.Periodical != null)
		{
			if (this.Periodical.getPlace().length() > 0)
				sb.append("; ").append(this.Periodical.getPlace()).append(".");
			else 
				sb.append(".");
		}
		else
		{
			if (this.Bibliographic_data.length() > 0)
			{
				sb.append("; ").append(this.Bibliographic_data);
				if (!Bibliographic_data.endsWith("."))
					sb.append(".");
			}
			else 
				sb.append(".");
		}
		
		sb.append(lineFeed).append(lineFeed);
		
		if (Type.length() > 0)
			sb.append("Type: ").append(Type).append("; ");
		
		if (Storing_place.length() > 0)
			sb.append("Storing place: ").append(Storing_place).append("; ");
		
		sb.append("Keyword_1: ").append(Keyword_1).append("; ");
		
		if (Keyword_2.length() > 0)
			sb.append("Keyword_2: ").append(Keyword_2).append("; ");
		
		if (Keyword_3.length() > 0)
			sb.append("Keyword_3: ").append(Keyword_3).append("; ");
		
		sb.append("Catalogue number: ").append(Catalogue_Number).append("; ");
		
		sb.append("Entry date: ").append(Date_Entry).append("; ");
		
		if (ISBN .length() > 0)
			sb.append("ISBN : ").append(ISBN).append("; ");
		
		if (Editorial.length() > 0)
			sb.append("Editorial: ").append(Editorial).append("; ");
		
		if (this.Periodical != null)
		{
			if (this.Periodical.getLanguage().length() > 0)
				sb.append("Language of the periodical: ").append(Periodical.getLanguage()).append(".");
		}
		
		if (Remarks.length() > 0)
			sb.append(lineFeed).append("Remarks: ").append(Remarks).append(".");
		
		if (Abstract.length() > 0)
		sb.append(lineFeed).append(lineFeed).append(Abstract);
						
		return sb.toString();
	}

	public String expGermanStandard()
	{
		// Exporting all of a Libref to a String, for a Report, without the abstract
		
		StringBuilder sb = new StringBuilder();
		sb.append(Author_1);
		
		if (Author_2.length() > 0)
			sb.append(", & ").append(Author_2);
		
		if (Author_3.length() > 0)
			sb.append(", & ").append(Author_3);
		
		if (Author_4.length() > 0)
			sb.append(", & ").append(Author_4);

		if (Editor.length() > 0)
			sb.append(" [").append(Editor).append("]");
		
		sb.append(" (").append(Year).append(")");
		
		
		if (Title.length() > 0)
		{
			sb.append(": ").append(Title);
			if (!Title.endsWith("."))
				sb.append(".");
		}
		
		sb.append(" - ");
		
		if (In_Book_title.length() > 0)
		{
			sb.append("In: ").append(In_Book_title);
			
			if (this.Periodical != null && (!In_Book_title.endsWith(",")))
				sb.append("; ");

			if (this.Periodical == null && this.Volume.length() > 0 && (!In_Book_title.endsWith(",")))
				sb.append(", ");
		}
		
		if (this.Periodical != null)
			sb.append(this.Periodical.getName()).append(", ");
		
		if (Volume.length() > 0)
		{
			if (this.Periodical == null)
			sb.append("vol. ");
			
			sb.append(Volume);
		}
		
		if (this.Periodical != null || In_Book_title.length() > 0 || Volume.length() > 0)
			sb.append(": ");
		
		sb.append(Pages);
		
		if (Figures.length() > 0)
			sb.append(", ").append(Figures).append(" figs.");
		
		if (Number_of_tables.length() > 0)
			sb.append(", ").append(Number_of_tables).append(" tabs.");
		
		if (Plates.length() > 0)
			sb.append(", pl. ").append(Plates);
		
		if (this.Periodical != null)
		{
			if (this.Periodical.getPlace().length() > 0)
				sb.append("; ").append(this.Periodical.getPlace()).append(".");
			else 
				sb.append(".");
		}
		else
		{
			if (this.Bibliographic_data.length() > 0)
			{
				sb.append("; ").append(this.Bibliographic_data);
				if (!Bibliographic_data.endsWith("."))
					sb.append(".");
			}
			else 
				sb.append(".");
		}
						
		return sb.toString();
	}


	public String expPalaeontology()
	{
		// Exporting all of a Libref to a String, for a Report, without the abstract
		
		StringBuilder sb = new StringBuilder();
		sb.append(Author_1);
		
		if (Author_4.length() > 0)
			sb.append(", ").append(Author_2).append(", ").append(Author_3).append(" and ").append(Author_4);		
		else if (Author_3.length() > 0)
			sb.append(", ").append(Author_2).append(" and ").append(Author_3);
		else if (Author_2.length() > 0)
			sb.append(" and ").append(Author_2);

		if (Editor.length() > 0)
			sb.append(" (").append(Editor).append(")");
		
		sb.append(" ").append(Year).append(".");
		
		
		if (Title.length() > 0)
		{
			sb.append(" ").append(Title);
			if (!Title.endsWith("."))
				sb.append(".");
		}
		
		sb.append(" ");
		
		if (In_Book_title.length() > 0)
		{
			sb.append("In ").append(In_Book_title);
			
			if (!In_Book_title.endsWith(","))
				sb.append(", ");
		}
		
		if (this.Periodical != null)
			sb.append(this.Periodical.getName()).append(", ");
		
		if (Volume.length() > 0)
		{			
			sb.append(Volume).append(", ");
		}
		
		if (this.Bibliographic_data.length() > 0)
			sb.append(this.Bibliographic_data).append(", ");
		
		sb.append(Pages);
		sb.append(".");
		
						
		return sb.toString();
	}
	

	public String expBullGeoscPrague()
	{
		// Exporting all of a Libref to a String, for a Report, without the abstract
		
		StringBuilder sb = new StringBuilder();
		sb.append(Author_1);
		
		if (Author_4.length() > 0)
			sb.append(", ").append(Author_2).append(", ").append(Author_3).append(" & ").append(Author_4);		
		else if (Author_3.length() > 0)
			sb.append(", ").append(Author_2).append(" & ").append(Author_3);
		else if (Author_2.length() > 0)
			sb.append(" & ").append(Author_2);

		if (Editor.length() > 0)
			sb.append(" (").append(Editor).append(")");
		
		sb.append(" ").append(Year).append(".");
		
		
		if (Title.length() > 0)
		{
			if (Title.endsWith("."))
				sb.append(" ").append(Title.substring(0, Title.length()-1));
			else
				sb.append(" ").append(Title);
		}
		
		
		if (this.Periodical != null)
		{
			if (In_Book_title.length() > 0)
			{
				sb.append(". In ").append(In_Book_title);
			}
			
			sb.append(", ");
			
			sb.append(this.Periodical.getName()).append(" ");
	
				sb.append(Volume).append(", ").append(Pages).append(".");
		}
		
		else if (this.Periodical == null)
		{
			if (In_Book_title.length() == 0)
			{
				if (Volume.length() > 0)
					sb.append(", ").append(Volume);

				sb.append(", ").append(Pages).append(" pp");
			}

			if (In_Book_title.length() > 0)
			{
				sb.append(", p. ").append(Pages);
				sb.append(". In ").append(In_Book_title);

				if (Volume.length() > 0)
				{
					if (!In_Book_title.endsWith(","))
						sb.append(", ");
					
					sb.append(Volume);
				}
			}
			
			sb.append(".");
		}
		
		if (this.Bibliographic_data.length() > 0)
		{
			sb.append(" ").append(this.Bibliographic_data);
		
			if (!Bibliographic_data.endsWith(","))
				sb.append(".");
		}

								
		return sb.toString();
	}
	
	public static Libref copyLibref(Libref OriginalLibref)
	{
		if (OriginalLibref==null) return null;
		
		Libref LibrefCopy;
		String modYear = "C-"+OriginalLibref.getYear(); 
		
		if (modYear.length() > 20) modYear = modYear.substring(0, 20); 
		
		LibrefCopy = new Libref (OriginalLibref.getAuthor_1(), OriginalLibref.getAuthor_2(), 
				OriginalLibref.getAuthor_3(), OriginalLibref.getAuthor_4(), modYear);
		
		if (OriginalLibref.getPeriodical() != null) LibrefCopy.setPeriodical(OriginalLibref.getPeriodical());
		
		LibrefCopy.setBibliographic_data(OriginalLibref.getBibliographic_data());
		LibrefCopy.setCatalogue_Number(OriginalLibref.getCatalogue_Number());
		LibrefCopy.setEditor(OriginalLibref.getEditor());
		LibrefCopy.setEditorial(OriginalLibref.getEditorial());
		LibrefCopy.setFigures(OriginalLibref.getFigures());
		LibrefCopy.setIn_Book_title(OriginalLibref.getIn_Book_title());
		LibrefCopy.setISBN(OriginalLibref.getISBN());
		LibrefCopy.setKeyword_1(OriginalLibref.getKeyword_1());
		LibrefCopy.setKeyword_2(OriginalLibref.getKeyword_2());
		LibrefCopy.setKeyword_3(OriginalLibref.getKeyword_3());
		LibrefCopy.setNumber_of_tables(OriginalLibref.getNumber_of_tables());
		LibrefCopy.setPages(OriginalLibref.getPages());
		LibrefCopy.setPlates(OriginalLibref.getPlates());
		LibrefCopy.setRemarks(OriginalLibref.getRemarks());
		LibrefCopy.setStoring_place(OriginalLibref.getStoring_place());
		LibrefCopy.setTitle(OriginalLibref.getTitle());
		LibrefCopy.setType(OriginalLibref.getType());
		LibrefCopy.setVolume(OriginalLibref.getVolume());
		
		return LibrefCopy; 
		
	}
	
	
}
