package MayLib;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Insets;
import java.awt.KeyboardFocusManager;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class LibrefDialog extends AbstractDialog implements ActionListener, 
KeyListener, WindowListener, FocusListener, ItemListener, ComponentListener
{
	private static final long serialVersionUID = 1L;
	private Font Plainfont, Boldfont; 

	private JMenuBar	       menuBar;
	private JMenu	           menuFile, menuEdit, submenuSaveAs;
	private JMenuItem	       miNewLibref, miNewPeriodical, miClose, miSave, miSaveAsOther, 
								miEditPeriodical, miSaveAsUCF, miSaveAsUnknown, miQuitApp;
	private JMenu	           menuSearch, menuCboBehaviour;
	private JMenuItem		miSearchAbstract, miMaxCatalogNo; 
	
	private JMenu	              submenuCboAutocomplete, submenuCboCase, submenuCboFree;
	private JRadioButtonMenuItem  miCboAutocYes, miCboAutocNo, miCboCaseYes, miCboCaseNo, miCboFreeYes, miCboFreeNo;
	private ButtonGroup		      bgCboAutocomplete, bgCboCase, bgCboFree;
	
	// Menue Report
	private JMenu menuReport, submenuAbstract, submenuReportType;
	private JMenuItem miReportAllLibrefs, miReportAllPeriodicals, miReportSelObjects;
	private JRadioButtonMenuItem miWithoutAbstract, mi1000Abstract, miFullAbstract, miBasicReport, miCompleteReport;
	private JRadioButtonMenuItem  mi2000Abstract, mi4000Abstract;
	private ButtonGroup bgAbstract, bgReportType;
	//Addition to menue Report
	private JMenu	              submenuRepCharacterset;
	private JRadioButtonMenuItem  miRepUnicode, miRepDefault, miRepUnknown;
	private ButtonGroup		      bgRepCharacterset;

	//Addition to menue Report
	private JRadioButtonMenuItem  miGermanStandardReport, miPalaeontologyReport, miBullGeosciencesPragueReport;
	
	private JLabel	     jlabelAuthor_1, jlabelAuthor_2, jlabelAuthor_3;
	private JLabel	     jlabelAuthor_4, jlabelYear, jlabelEditor, jlabelTitle, jlabelIn_Book_title,
							jlabelVolume, jlabelPages, jlabelFigures, jlabelNumber_of_tables,
							jlabelPlates, jlabelBibliographic_data, jlabelPeriodical, jlabelEditorial,
							jlabelType, jlabelKeyword_1, jlabelKeyword_2, jlabelKeyword_3,
							jlabelCatalogue_Number, jlabelStoring_place, jlabelDate_Entry, jlabelISBN, jlabelRemarks;
	
	//private JTextField	tfPeriodical;
	
	private JTextField	  tfYear, tfEditor, tfTitle, tfIn_Book_title;
	private JTextField	  tfVolume, tfPages,
						tfFigures, tfNumber_of_tables, tfPlates, tfBibliographic_data,
						tfEditorial, tfCatalogue_Number, tfStoring_place, tfDate_Entry, tfISBN, tfRemarks;
	
	private JButton	     btnOK, btnCancel, btnNewLibref, btnPeriodical, btnReport, btnQuitApp,
						btnSave1, btnSave2;
	
	private JPanel		pnlTextfield, pnlBottom;
	
	private JTextArea txarAbstract;
	private JScrollPane txarAbstractScrollPane;
	
	//For the combobox
	private JComboBox						 cboPeriodical;
	private DefaultComboBoxModel			 cboPeriodicalModel;
	
	private KeyboardFocusManager kbFocusManager;
	private Libref myLibref;
	private MayLibTable Periodical_MayLibTable, Libref_MayLibTable;
	private MayLib_Start Father;
	private Periodical	mySelectedPeriodical;
	private LibrefSplitPane myLibrefSplitPane;
	private String oldCompareValue;
	
	private String 	cboPeriodicalPreselection;
	
	private DefaultComboBoxModel cboTypeModel, cboAuthor1Model, cboKeyword1Model,
		cboAuthor2Model, cboKeyword2Model, cboAuthor3Model, cboKeyword3Model, cboAuthor4Model;
	
	private JComboBox	cboAuthor_4, cboAuthor_1, cboAuthor_2, cboAuthor_3, cboType, cboKeyword_1, cboKeyword_2, cboKeyword_3;
	
	// this is necessesary to avoid that all times that eingabeOK() is false or
	// something is copied, the comboboxes are newly populated
	private boolean supressPopCombwindowActiv = true;
	
	public LibrefDialog(Libref myLibref, MayLib_Start Father, MayLibTable Periodical_MayLibTable, 
			MayLibTable Libref_MayLibTable, LibrefSplitPane myLibrefSplitPane)
	{
		this.myLibrefSplitPane = myLibrefSplitPane;
		this.myLibref = myLibref;
		this.Father = Father;
		this.Periodical_MayLibTable = Periodical_MayLibTable;
		this.Libref_MayLibTable = Libref_MayLibTable;
		// THis construction Periodical_MayLibTable -Father is necessary to be able to be called from different
		// dialog frames which are called from MayLib_Start
		this.Plainfont = this.Father.Plainfont;
		this.Boldfont = this.Father.Boldfont;
		this.setFont(Plainfont);
		
		if (this.myLibref != null)
			this.mySelectedPeriodical = myLibref.getPeriodical(); 
		
		initializeComponents();
	}
	

	private void setmyFontChild()
	{	
	
		this.getJMenuBar().setFont(Boldfont);	
		
		txarAbstract.setFont(Plainfont);
		
		for (int i = 0; i < menuBar.getMenuCount(); i++)
		{
			menuBar.getMenu(i).setFont(Boldfont);
			setFontMenuItems(menuBar.getMenu(i));
		}
		
		setFontComponents(this.getContentPane());
	}
	
	private void setFontMenuItems(JMenu m)
	{
		for (Component c : m.getMenuComponents())
		{
			// Der Separator hat keinen Text und keine Elemente
			if (c instanceof JMenuItem)
			{
				((JMenuItem)c).setFont(Boldfont);
				if (((JMenuItem) c).getSubElements().length > 0)
					setFontMenuItems((JMenu) c);
			}
		}
	}

	private void setFontComponents(Container container)
	{
		for (Component c : container.getComponents())
		{
			if (c instanceof JLabel)
				((JLabel) c).setFont(Boldfont);
			else if (c instanceof JTextField)
				((JTextField) c).setFont(Plainfont);
			else if (c instanceof JComboBox)
				((JComboBox) c).setFont(Plainfont);
			else if (c instanceof JTextArea)
				((JTextArea) c).setFont(Plainfont);
			else if (c instanceof JButton)
				((JButton) c).setFont(Boldfont);
			else if (c instanceof JPanel)
			{
				// Prfen, ob das Panel einen TitledBorder hat, dessen Text
				// dann ebenfalls bersetzt werden muss.
				Border b = ((JPanel) c).getBorder();
				if (b instanceof TitledBorder)
					((TitledBorder) b).setTitleFont(Plainfont);

				// Ein Panel ist ein Container und enthlt in aller Regel
				// Komponenten
				setFontComponents((JPanel) c);
			}

		}
	}

	private void createMenu()
	{
		menuBar = new JMenuBar();
		this.setJMenuBar(menuBar);

		menuFile = this.createMenu(menuBar, "File", "menuFile", 'F');
		miSave = this.createMenuItem(menuFile, "miSave", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Save opened MayLib file (*.ucf)", null, 'S',
				"Saves the opened MayLib as MayLib file (*.ucf) under the same name");
		submenuSaveAs = this.createSubMenue(menuFile, "Save opened MayLib as...", "submenuSaveAs", 'a');
		miSaveAsUCF = this.createMenuItem(submenuSaveAs, "miSaveAsUCF", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "MayLib file (*.ucf)", null, 'b',
				"Saves the opened MayLib as MayLib file (*.ucf) under another name");
		miSaveAsOther = this.createMenuItem(submenuSaveAs, "miSaveAsOther", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "System default character set", null,
				'y', "Saves the opened MayLib as a file with the system default character set under another name");
		miSaveAsUnknown = this.createMenuItem(submenuSaveAs, "miSaveAsUnknown", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Unknown character set", null, 0,
				"Saves the opened MayLib as a file with the character set for opened files with an unknown character set");
		menuFile.addSeparator();
		miClose = this.createMenuItem(menuFile, null, AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Close", null, 'C', "Closes this window");
		miQuitApp = this.createMenuItem(menuFile, null, AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Quit application", null, 'Q', "Quit application");

		menuEdit = this.createMenu(menuBar, "Edit", null, 'E');
		miNewLibref = this.createMenuItem(menuEdit, "miNewLibref", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "New Literature reference", null, 'L',
				"Opens window to create a new literature reference");
		miEditPeriodical = this.createMenuItem(menuEdit, "miEditPeriodical", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Edit Periodical", null, 'd',
				"Opens window to edit the actually used Periodical");
		miNewPeriodical = this.createMenuItem(menuEdit, "miNewPeriodical", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "New Periodical", null, 'P',
				"Opens window to create a new Periodical");
		
		menuSearch = this.createMenu(menuBar, "Search", "menuSearch", 'h');
		miSearchAbstract = this.createMenuItem(menuSearch, "miSearchAbstract", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Search abstract", null, 'a', "Searches the abstract for a word or a part of a word/phrase");
		miMaxCatalogNo = this.createMenuItem(menuSearch, "miMaxCatalogNo", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Highest catalogue number", null, 'a', "Shows the highest catalogue number");
		
		menuReport = this.createMenu(menuBar, "Report", "menuReport", 'R');
		miReportAllLibrefs = this.createMenuItem(menuReport, "miReportAllLibrefs", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Report all literature", null,
				'l', "Creates a report of all literature references");
		miReportAllPeriodicals = this.createMenuItem(menuReport, "miReportAllPeriodicals", AbstractDialog.MenuItemType.ITEM_PLAIN, this,
				"Report all periodicals", null, 'p', "Creates a report of all periodicals");
		miReportSelObjects = this.createMenuItem(menuReport, "miReportSelObjects", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Report visible object",
				null, 'v', "Creates a report of the visible object");
		menuReport.addSeparator();
		submenuAbstract = this.createSubMenue(menuReport, "Include Abstract?", "submenuAbstract", 'i');
		miWithoutAbstract = (JRadioButtonMenuItem) this.createMenuItem(submenuAbstract, "miWithoutAbstract", AbstractDialog.MenuItemType.ITEM_RADIO, this,
				"Without abstract", null, 'W', "The resulting report does not contain any abstract");
		mi1000Abstract = (JRadioButtonMenuItem) this.createMenuItem(submenuAbstract, "mi1000Abstract", AbstractDialog.MenuItemType.ITEM_RADIO, this,
				"1000 characters", null, '1', "The resulting report contains the first 1000 characters of the abstract, if it is a literature references report");
		mi2000Abstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "mi2000Abstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "2000 characters", null, '2', "The resulting report contains the first 2000 characters of the abstract, if it is a literature references report");
		mi4000Abstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "mi4000Abstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "4000 characters", null, '4', "The resulting report contains the first 4000 characters of the abstract, if it is a literature references report");
		miFullAbstract = (JRadioButtonMenuItem) this.createMenuItem(submenuAbstract, "miFullAbstract", AbstractDialog.MenuItemType.ITEM_RADIO, this,
				"Full abstract", null, 'F', "The resulting report contains the full abstract, if it is a literature references report");
		submenuReportType = this.createSubMenue(menuReport, "Type of Report", "submenuReportType", 'T');
		miBasicReport = (JRadioButtonMenuItem) this.createMenuItem(submenuReportType, "miBasicReport", AbstractDialog.MenuItemType.ITEM_RADIO, this,
				"Basic report", null, 'B', "A short report with the most relevant information");
		miCompleteReport = (JRadioButtonMenuItem) this.createMenuItem(submenuReportType, "miCompleteReport", AbstractDialog.MenuItemType.ITEM_RADIO, this,
				"Complete report", null, 'C', "A complete report with all information");
		bgAbstract = new ButtonGroup();
		bgAbstract.add(miWithoutAbstract);
		bgAbstract.add(mi1000Abstract);
		bgAbstract.add(mi2000Abstract);
		bgAbstract.add(mi4000Abstract);
		bgAbstract.add(miFullAbstract);
		bgReportType = new ButtonGroup();
		bgReportType.add(miBasicReport);
		bgReportType.add(miCompleteReport);
		//Addition to menue Report
		miGermanStandardReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miGermanStandardReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "German Standard report", null, 'G', "Detailed literature reference in German style");
		miPalaeontologyReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miPalaeontologyReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Palaeontology report", null, 'P', "Literature reference in 'Palaeontology (London)' style");
		miBullGeosciencesPragueReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miBullGeosciencesPragueReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Bulletin Geosciences Prague report", null, 'u', "Literature reference in 'Bulletin of Geosciences (Prague)' style");
		bgReportType.add(miBullGeosciencesPragueReport);
		bgReportType.add(miGermanStandardReport);
		bgReportType.add(miPalaeontologyReport);
		//Addition to menue Report
		submenuRepCharacterset = this.createSubMenue(menuReport, "Characterset of the report",  "submenuRepCharacterset", 'h');
		miRepUnicode = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepUnicode", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Unicode (*.RPU)", null, 'U', "The resulting report will be written with Unicode character set. The default file extension is *.RPU");
		miRepDefault = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepDefault", AbstractDialog.MenuItemType.ITEM_RADIO, this, "System default character set (*.RPT)", null, 'y', "The resulting report will be written with the default system character set. The default file extension is *.RPT");
		miRepUnknown = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepUnknown", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Unknown character set (*.RPT)", null, 0, "The resulting report will be written with the character set used by the last file imported with UNKNOWN character set. The default file extension is *.RPT");
		bgRepCharacterset = new ButtonGroup();
		bgRepCharacterset.add(miRepUnicode);
		bgRepCharacterset.add(miRepDefault);
		bgRepCharacterset.add(miRepUnknown);	
		
		menuCboBehaviour = this.createMenu(menuBar, "Combobox behaviour", "menuCboBehaviour", 'C');
		submenuCboFree = this.createSubMenue(menuCboBehaviour, "Free edition", "submenuCboFree", 'F');
		miCboFreeYes = (JRadioButtonMenuItem) this.createMenuItem(submenuCboFree, "miCboFreeYes", AbstractDialog.MenuItemType.ITEM_RADIO, this,
				"Yes", null, 'Y', "Within the editable comboboxes the text can be edited freely. Select this if the NO-option makes problems.");
		miCboFreeNo = (JRadioButtonMenuItem) this.createMenuItem(submenuCboFree, "miCboFreeNo", AbstractDialog.MenuItemType.ITEM_RADIO, this,
				"No", null, 'N', "Within the editable comboboxes helps for the edition of the text will be given. This is in most cases the most comfortable behaviour.");
		bgCboFree = new ButtonGroup();
		bgCboFree.add(miCboFreeYes);
		bgCboFree.add(miCboFreeNo);
		menuCboBehaviour.addSeparator();
		submenuCboAutocomplete = this.createSubMenue(menuCboBehaviour, "Complete text automatically", "submenuCboAutocomplete", 'a');
		miCboAutocYes = (JRadioButtonMenuItem) this.createMenuItem(submenuCboAutocomplete, "miCboAutocYes", AbstractDialog.MenuItemType.ITEM_RADIO, this,
				"Yes", null, 'Y', "Within the editable comboboxes the text will be completed automatically. This is in most cases the most comfortable behaviour.");
		miCboAutocNo = (JRadioButtonMenuItem) this.createMenuItem(submenuCboAutocomplete, "miCboAutocNo", AbstractDialog.MenuItemType.ITEM_RADIO, this,
				"No", null, 'N', "Within the editable comboboxes the text will NOT be completed automatically. Select this if the YES-option makes problems.");
		bgCboAutocomplete = new ButtonGroup();
		bgCboAutocomplete.add(miCboAutocYes);
		bgCboAutocomplete.add(miCboAutocNo);
		submenuCboCase = this.createSubMenue(menuCboBehaviour, "Distinguish upper/lower case ", "submenuCboCase", 'D');
		miCboCaseYes = (JRadioButtonMenuItem) this.createMenuItem(submenuCboCase, "miCboCaseYes", AbstractDialog.MenuItemType.ITEM_RADIO, this,
				"Yes", null, 'Y', "Within the editable comboboxes the typed letters will distinguish upper/lower case. Select this if the NO-option makes problems.");
		miCboCaseNo = (JRadioButtonMenuItem) this.createMenuItem(submenuCboCase, "miCboCaseNo", AbstractDialog.MenuItemType.ITEM_RADIO, this,
				"No", null, 'N', "Within the editable comboboxes the typed letters will NOT distinguish upper/lower case. This is in most cases the most comfortable behaviour.");
		bgCboCase = new ButtonGroup();
		bgCboCase.add(miCboCaseYes);
		bgCboCase.add(miCboCaseNo);
		
	}
	
	private void fillFields()
	{
		tfYear.setText(myLibref.getYear());
		tfEditor.setText(myLibref.getEditor());
		tfYear.setCaretPosition(0);
		tfEditor.setCaretPosition(0);
		tfTitle.setText(myLibref.getTitle());
		tfIn_Book_title.setText(myLibref.getIn_Book_title());
		tfTitle.setCaretPosition(0);
		tfIn_Book_title.setCaretPosition(0);
		
		tfEditorial.setText(myLibref.getEditorial());
		tfEditorial.setCaretPosition(0);
		tfVolume.setText(myLibref.getVolume());
		tfVolume.setCaretPosition(0);
		tfPages.setText(myLibref.getPages());
		tfPages.setCaretPosition(0);
		tfFigures.setText(myLibref.getFigures());
		tfFigures.setCaretPosition(0);
		tfNumber_of_tables.setText(myLibref.getNumber_of_tables());
		tfNumber_of_tables.setCaretPosition(0);
		tfPlates.setText(myLibref.getPlates());
		tfPlates.setCaretPosition(0);
		tfBibliographic_data.setText(myLibref.getBibliographic_data());
		tfBibliographic_data.setCaretPosition(0);
		
		tfCatalogue_Number.setText(myLibref.getCatalogue_Number());
		tfCatalogue_Number.setCaretPosition(0);
		tfStoring_place.setText(myLibref.getStoring_place());
		tfStoring_place.setCaretPosition(0);
		tfDate_Entry.setText(myLibref.getDate_Entry());
		tfDate_Entry.setCaretPosition(0);
		tfISBN.setText(myLibref.getISBN());
		tfISBN.setCaretPosition(0);
		tfRemarks.setText(myLibref.getRemarks());
		tfRemarks.setCaretPosition(0);

		txarAbstract.setText(myLibref.getAbstract());
		txarAbstract.setCaretPosition(0);
	}
	

	@Override
	public void initializeComponents()
	{
		this.setTitle("Literature reference");
		this.setLayout(new BorderLayout());
		this.setModalityType(DEFAULT_MODALITY_TYPE);
		this.setBounds(10, 10, 800, 480);
		this.setDefaultCloseOperation(AbstractDialog.DO_NOTHING_ON_CLOSE);
		this.addWindowListener(this);
		this.addComponentListener(this); // for resizing some fields
		
		// Panel
		pnlTextfield = new JPanel(null);
		pnlTextfield.setPreferredSize(new Dimension(790, 348));
		this.add(pnlTextfield,  BorderLayout.PAGE_START);
		
		pnlBottom = new JPanel(null);
		pnlBottom.setPreferredSize(new Dimension(790, 40));
		this.add(pnlBottom,  BorderLayout.PAGE_END);
		
		
		createMenu();
		
		jlabelAuthor_1 = new JLabel("1st Author");
		jlabelAuthor_1.setBounds(5, 10, 80, 25);
		jlabelAuthor_1.setName("Author_1");
		pnlTextfield.add(jlabelAuthor_1);

		cboAuthor1Model = new DefaultComboBoxModel();
		cboAuthor_1 = new JComboBox(cboAuthor1Model);
		cboAuthor_1.addItemListener(this);
		cboAuthor_1.setEditable(true);
		cboAuthor_1.setBounds(85, 10, 300, 25);
		cboAuthor_1.setToolTipText(myLibref.getAttributeTooltip("Author_1"));
		cboAuthor_1.setName("Author_1");
		cboAuthor_1.getEditor().getEditorComponent().addKeyListener(this);
		cboAuthor_1.addFocusListener(this);
		pnlTextfield.add(cboAuthor_1);

		jlabelAuthor_2 = new JLabel("2nd Author");
		jlabelAuthor_2.setBounds(400, 10, 80, 25);
		jlabelAuthor_2.setName("Author_2");
		pnlTextfield.add(jlabelAuthor_2);

		cboAuthor2Model = new DefaultComboBoxModel();
		cboAuthor_2 = new JComboBox(cboAuthor2Model);
		cboAuthor_2.addItemListener(this);
		cboAuthor_2.setEditable(true);
		cboAuthor_2.setBounds(480, 10, 300, 25);
		cboAuthor_2.setName("Author_2");
		cboAuthor_2.setToolTipText(myLibref.getAttributeTooltip("Author_2"));
		cboAuthor_2.getEditor().getEditorComponent().addKeyListener(this);
		cboAuthor_2.addFocusListener(this);
		pnlTextfield.add(cboAuthor_2);
		
		jlabelAuthor_3 = new JLabel("3rd Author");
		jlabelAuthor_3.setBounds(5, 38, 80, 25);
		jlabelAuthor_3.setName("Author_3");
		pnlTextfield.add(jlabelAuthor_3);

		cboAuthor3Model = new DefaultComboBoxModel();
		cboAuthor_3 = new JComboBox(cboAuthor3Model);
		cboAuthor_3.addItemListener(this);
		cboAuthor_3.setEditable(true);
		cboAuthor_3.setBounds(85, 38, 300, 25);
		cboAuthor_3.setName("Author_3");
		cboAuthor_3.setToolTipText(myLibref.getAttributeTooltip("Author_3"));
		cboAuthor_3.getEditor().getEditorComponent().addKeyListener(this);
		cboAuthor_3.addFocusListener(this);
		pnlTextfield.add(cboAuthor_3);

		jlabelAuthor_4 = new JLabel("more Authors");
		jlabelAuthor_4.setBounds(400, 38, 100, 25);
		jlabelAuthor_4.setName("Author_4");
		pnlTextfield.add(jlabelAuthor_4);

		cboAuthor4Model = new DefaultComboBoxModel();
		cboAuthor_4 = new JComboBox(cboAuthor4Model);
		cboAuthor_4.addItemListener(this);
		cboAuthor_4.setEditable(true);
		cboAuthor_4.setBounds(500, 38, 280, 25);
		cboAuthor_4.setName("Author_4");
		cboAuthor_4.setToolTipText(myLibref.getAttributeTooltip("Author_4"));
		cboAuthor_4.getEditor().getEditorComponent().addKeyListener(this);
		cboAuthor_4.addFocusListener(this);
		pnlTextfield.add(cboAuthor_4);
		
		jlabelYear = new JLabel("Year");
		jlabelYear.setBounds(5, 66, 45, 25);
		jlabelYear.setName("Year");
		pnlTextfield.add(jlabelYear);

		tfYear = new JTextField();
		tfYear.setBounds(50, 66, 150, 25);
		tfYear.setName("Year");
		tfYear.setMargin(new Insets(1, 1, 1, 1));
		tfYear.setToolTipText(myLibref.getAttributeTooltip("Year"));
		tfYear.addKeyListener(this);
		tfYear.addFocusListener(this);
		pnlTextfield.add(tfYear);
	
		jlabelEditor = new JLabel("Editor");
		jlabelEditor.setBounds(210, 66, 50, 25);
		jlabelEditor.setName("Editor");
		pnlTextfield.add(jlabelEditor);

		tfEditor = new JTextField();
		tfEditor.setBounds(260, 66, 125, 25);
		tfEditor.setName("Editor");
		tfEditor.setMargin(new Insets(1, 1, 1, 1));
		tfEditor.setToolTipText(myLibref.getAttributeTooltip("Editor"));
		tfEditor.addKeyListener(this);
		tfEditor.addFocusListener(this);
		pnlTextfield.add(tfEditor);

		jlabelEditorial = new JLabel("Editorial");
		jlabelEditorial.setBounds(600, 66, 80, 25);
		jlabelEditorial.setName("Editorial");
		jlabelEditorial.setForeground(Color.GRAY);
		pnlTextfield.add(jlabelEditorial);

		tfEditorial = new JTextField();
		tfEditorial.setBounds(675, 66, 105, 25);
		tfEditorial.setName("Editorial");
		tfEditorial.setMargin(new Insets(1, 1, 1, 1));
		tfEditorial.setToolTipText(myLibref.getAttributeTooltip("Editorial"));
		tfEditorial.addKeyListener(this);
		tfEditorial.addFocusListener(this);
		pnlTextfield.add(tfEditorial);

		jlabelDate_Entry = new JLabel("Entry date");
		jlabelDate_Entry.setBounds(400, 66, 75, 25);
		jlabelDate_Entry.setName("Date_Entry");
		jlabelDate_Entry.setForeground(Color.GRAY);
		pnlTextfield.add(jlabelDate_Entry);

		tfDate_Entry = new JTextField();
		tfDate_Entry.setBounds(475, 66, 105, 25);
		tfDate_Entry.setName("Date_Entry");
		tfDate_Entry.setMargin(new Insets(1, 1, 1, 1));
		tfDate_Entry.setForeground(Color.GRAY);
		tfDate_Entry.setToolTipText(myLibref.getAttributeTooltip("Date_Entry"));
		tfDate_Entry.addKeyListener(this);
		tfDate_Entry.addFocusListener(this);
		pnlTextfield.add(tfDate_Entry);

		jlabelTitle = new JLabel("Title");
		jlabelTitle.setBounds(5, 94, 45, 25);
		jlabelTitle.setName("Title");
		pnlTextfield.add(jlabelTitle);

		tfTitle = new JTextField();
		tfTitle.setBounds(50, 94, 730, 25);
		tfTitle.setName("Title");
		tfTitle.setMargin(new Insets(1, 1, 1, 1));
		tfTitle.setToolTipText(myLibref.getAttributeTooltip("Title"));
		tfTitle.addKeyListener(this);
		tfTitle.addFocusListener(this);
		pnlTextfield.add(tfTitle);
		
		jlabelIn_Book_title = new JLabel("In_Book_title");
		jlabelIn_Book_title.setBounds(5, 122, 100, 25);
		jlabelIn_Book_title.setName("In_Book_title");
		pnlTextfield.add(jlabelIn_Book_title);

		tfIn_Book_title = new JTextField();
		tfIn_Book_title.setBounds(105, 122, 675, 25);
		tfIn_Book_title.setName("In_Book_title");
		tfIn_Book_title.setMargin(new Insets(1, 1, 1, 1));
		tfIn_Book_title.setToolTipText(myLibref.getAttributeTooltip("In_Book_title"));
		tfIn_Book_title.addKeyListener(this);
		tfIn_Book_title.addFocusListener(this);
		pnlTextfield.add(tfIn_Book_title);
		
		jlabelPeriodical = new JLabel("Periodical");
		jlabelPeriodical.setBounds(5, 150, 80, 25);
		jlabelPeriodical.setName("Periodical");
		pnlTextfield.add(jlabelPeriodical);

//		tfPeriodical = new JTextField();
//		tfPeriodical.setBounds(85, 150, 695, 25);
//		tfPeriodical.setName("Periodical");
//		tfPeriodical.setMargin(new Insets(1, 1, 1, 1));
//		tfPeriodical.setToolTipText(myLibref.getAttributeTooltip("Periodical"));
//		tfPeriodical.addKeyListener(this);
//		tfPeriodical.addFocusListener(this);
//		pnlTextfield.add(tfPeriodical);

		jlabelVolume = new JLabel("Volume");
		jlabelVolume.setBounds(5, 178, 80, 25);
		jlabelVolume.setName("Volume");
		pnlTextfield.add(jlabelVolume);

		tfVolume = new JTextField();
		tfVolume.setBounds(85, 178, 135, 25);
		tfVolume.setName("Volume");
		tfVolume.setMargin(new Insets(1, 1, 1, 1));
		tfVolume.setToolTipText(myLibref.getAttributeTooltip("Volume"));
		tfVolume.addKeyListener(this);
		tfVolume.addFocusListener(this);
		pnlTextfield.add(tfVolume);

		jlabelPages = new JLabel("Pages");
		jlabelPages.setBounds(235, 178, 60, 25);
		jlabelPages.setName("Pages");
		pnlTextfield.add(jlabelPages);

		tfPages = new JTextField();
		tfPages.setBounds(295, 178, 140, 25);
		tfPages.setName("Pages");
		tfPages.setMargin(new Insets(1, 1, 1, 1));
		tfPages.setToolTipText(myLibref.getAttributeTooltip("Pages"));
		tfPages.addKeyListener(this);
		tfPages.addFocusListener(this);
		pnlTextfield.add(tfPages);

		jlabelFigures = new JLabel("Figures");
		jlabelFigures.setBounds(450, 178, 70, 25);
		jlabelFigures.setName("Figures");
		pnlTextfield.add(jlabelFigures);

		tfFigures = new JTextField();
		tfFigures.setBounds(520, 178, 90, 25);
		tfFigures.setName("Figures");
		tfFigures.setMargin(new Insets(1, 1, 1, 1));
		tfFigures.setToolTipText(myLibref.getAttributeTooltip("Figures"));
		tfFigures.addKeyListener(this);
		tfFigures.addFocusListener(this);
		pnlTextfield.add(tfFigures);

		jlabelNumber_of_tables = new JLabel("Tables");
		jlabelNumber_of_tables.setBounds(620, 178, 55, 25);
		jlabelNumber_of_tables.setName("Number_of_tables");
		pnlTextfield.add(jlabelNumber_of_tables);

		tfNumber_of_tables = new JTextField();
		tfNumber_of_tables.setBounds(675, 178, 105, 25);
		tfNumber_of_tables.setName("Number_of_tables");
		tfNumber_of_tables.setMargin(new Insets(1, 1, 1, 1));
		tfNumber_of_tables.setToolTipText(myLibref.getAttributeTooltip("Number_of_tables"));
		tfNumber_of_tables.addKeyListener(this);
		tfNumber_of_tables.addFocusListener(this);
		pnlTextfield.add(tfNumber_of_tables);
		
		jlabelPlates = new JLabel("Plates");
		jlabelPlates.setBounds(5, 206, 80, 25);
		jlabelPlates.setName("Plates");
		pnlTextfield.add(jlabelPlates);

		tfPlates = new JTextField();
		tfPlates.setBounds(85, 206, 80, 25);
		tfPlates.setName("Plates");
		tfPlates.setMargin(new Insets(1, 1, 1, 1));
		tfPlates.setToolTipText(myLibref.getAttributeTooltip("Plates"));
		tfPlates.addKeyListener(this);
		tfPlates.addFocusListener(this);
		pnlTextfield.add(tfPlates);

		jlabelBibliographic_data = new JLabel("Bibliographic_data");
		jlabelBibliographic_data.setBounds(170, 206, 140, 25);
		jlabelBibliographic_data.setName("Bibliographic_data");
		pnlTextfield.add(jlabelBibliographic_data);

		tfBibliographic_data = new JTextField();
		tfBibliographic_data.setBounds(310, 206, 470, 25);
		tfBibliographic_data.setName("Bibliographic_data");
		tfBibliographic_data.setMargin(new Insets(1, 1, 1, 1));
		tfBibliographic_data.setToolTipText(myLibref.getAttributeTooltip("Bibliographic_data"));
		tfBibliographic_data.addKeyListener(this);
		tfBibliographic_data.addFocusListener(this);
		pnlTextfield.add(tfBibliographic_data);

		jlabelType = new JLabel("Type");
		jlabelType.setBounds(5, 234, 80, 25);
		jlabelType.setName("Type");
		pnlTextfield.add(jlabelType);

		cboTypeModel = new DefaultComboBoxModel();
		cboType = new JComboBox(cboTypeModel);
		cboType.addItemListener(this);
		cboType.setEditable(true);
		cboType.setBounds(85, 234, 300, 25);
		cboType.setName("Type");
		cboType.setToolTipText(myLibref.getAttributeTooltip("Type"));
		cboType.getEditor().getEditorComponent().addKeyListener(this);
		cboType.addFocusListener(this);
		pnlTextfield.add(cboType);

		jlabelKeyword_1 = new JLabel("1st Keyword");
		jlabelKeyword_1.setBounds(400, 234, 90, 25);
		jlabelKeyword_1.setName("Keyword_1");
		pnlTextfield.add(jlabelKeyword_1);

		cboKeyword1Model = new DefaultComboBoxModel();
		cboKeyword_1 = new JComboBox(cboKeyword1Model);
		cboKeyword_1.addItemListener(this);
		cboKeyword_1.setEditable(true);
		cboKeyword_1.setBounds(490, 234, 290, 25);
		cboKeyword_1.setName("Keyword_1");
		cboKeyword_1.setToolTipText(myLibref.getAttributeTooltip("Keyword_1"));
		cboKeyword_1.getEditor().getEditorComponent().addKeyListener(this);
		cboKeyword_1.addFocusListener(this);
		pnlTextfield.add(cboKeyword_1);
		
		jlabelKeyword_2 = new JLabel("2nd Keyword");
		jlabelKeyword_2.setBounds(5, 262, 100, 25);
		jlabelKeyword_2.setName("Keyword_2");
		pnlTextfield.add(jlabelKeyword_2);

		cboKeyword2Model = new DefaultComboBoxModel();
		cboKeyword_2 = new JComboBox(cboKeyword2Model);
		cboKeyword_2.addItemListener(this);
		cboKeyword_2.setEditable(true);
		cboKeyword_2.setBounds(105, 262, 280, 25);
		cboKeyword_2.setName("Keyword_2");
		cboKeyword_2.setToolTipText(myLibref.getAttributeTooltip("Keyword_2"));
		cboKeyword_2.getEditor().getEditorComponent().addKeyListener(this);
		cboKeyword_2.addFocusListener(this);
		pnlTextfield.add(cboKeyword_2);

		jlabelKeyword_3 = new JLabel("3rd Keyword");
		jlabelKeyword_3.setBounds(400, 262, 90, 25);
		jlabelKeyword_3.setName("Keyword_3");
		pnlTextfield.add(jlabelKeyword_3);

		cboKeyword3Model = new DefaultComboBoxModel();
		cboKeyword_3 = new JComboBox(cboKeyword3Model);
		cboKeyword_3.addItemListener(this);
		cboKeyword_3.setEditable(true);
		cboKeyword_3.setBounds(490, 262, 290, 25);
		cboKeyword_3.setName("Keyword_3");
		cboKeyword_3.setToolTipText(myLibref.getAttributeTooltip("Keyword_3"));
		cboKeyword_3.getEditor().getEditorComponent().addKeyListener(this);
		cboKeyword_3.addFocusListener(this);
		pnlTextfield.add(cboKeyword_3);
		
		jlabelCatalogue_Number = new JLabel("Catalogue No.");
		jlabelCatalogue_Number.setBounds(5, 290, 100, 25);
		jlabelCatalogue_Number.setName("Catalogue_Number");
		pnlTextfield.add(jlabelCatalogue_Number);

		tfCatalogue_Number = new JTextField();
		tfCatalogue_Number.setBounds(105, 290, 95, 25);
		tfCatalogue_Number.setName("Catalogue_Number");
		tfCatalogue_Number.setMargin(new Insets(1, 1, 1, 1));
		tfCatalogue_Number.setToolTipText(myLibref.getAttributeTooltip("Catalogue_Number"));
		tfCatalogue_Number.addKeyListener(this);
		tfCatalogue_Number.addFocusListener(this);
		pnlTextfield.add(tfCatalogue_Number);

		jlabelStoring_place = new JLabel("Storing place");
		jlabelStoring_place.setBounds(220, 290, 95, 25);
		jlabelStoring_place.setName("Storing_place");
		pnlTextfield.add(jlabelStoring_place);

		tfStoring_place = new JTextField();
		tfStoring_place.setBounds(315, 290, 310, 25);
		tfStoring_place.setName("Storing_place");
		tfStoring_place.setMargin(new Insets(1, 1, 1, 1));
		tfStoring_place.setToolTipText(myLibref.getAttributeTooltip("Storing_place"));
		tfStoring_place.addKeyListener(this);
		tfStoring_place.addFocusListener(this);
		pnlTextfield.add(tfStoring_place);
		
		jlabelISBN = new JLabel("ISBN");
		jlabelISBN.setBounds(635, 290, 40, 25);
		jlabelISBN.setName("ISBN");
		pnlTextfield.add(jlabelISBN);

		tfISBN = new JTextField();
		tfISBN.setBounds(675, 290, 105, 25);
		tfISBN.setName("ISBN");
		tfISBN.setMargin(new Insets(1, 1, 1, 1));
		tfISBN.setToolTipText(myLibref.getAttributeTooltip("ISBN"));
		tfISBN.addKeyListener(this);
		tfISBN.addFocusListener(this);
		pnlTextfield.add(tfISBN);
		
		btnSave1 = new JButton("Save");
		btnSave1.setBounds(1, 290, 4, 25);
		btnSave1.setMargin(new Insets(2, 2, 2, 2));
		btnSave1.setName("Save");
		btnSave1.setBackground(Color.GREEN);
		btnSave1.addActionListener(this);
		btnSave1.addKeyListener(this);
		btnSave1.setVisible(false);
		pnlTextfield.add(btnSave1);
		
		jlabelRemarks = new JLabel("Remarks");
		jlabelRemarks.setBounds(5, 318, 80, 25);
		jlabelRemarks.setName("Remarks");
		pnlTextfield.add(jlabelRemarks);

		tfRemarks = new JTextField();
		tfRemarks.setBounds(85, 318, 695, 25);
		tfRemarks.setName("Remarks");
		tfRemarks.setMargin(new Insets(1, 1, 1, 1));
		tfRemarks.setToolTipText(myLibref.getAttributeTooltip("Remarks"));
		tfRemarks.addKeyListener(this);
		tfRemarks.addFocusListener(this);
		pnlTextfield.add(tfRemarks);

		// For the combobox
		// Periodical
		cboPeriodicalModel = new DefaultComboBoxModel();
		cboPeriodical = new JComboBox(cboPeriodicalModel);
		cboPeriodical.setBounds(85, 150, 695, 25);
		cboPeriodical.addItemListener(this);
		cboPeriodical.addKeyListener(this);
		cboPeriodical.addFocusListener(this);
		pnlTextfield.add(cboPeriodical);

		//Textarea

		txarAbstract = new JTextArea();
		txarAbstractScrollPane = new JScrollPane(txarAbstract);
		txarAbstractScrollPane.setPreferredSize(new Dimension(775, 85));
		// Vertikale Laufleiste immer sichtbar
		txarAbstractScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		
		// Automatischer Zeilenumbruch
		txarAbstract.setLineWrap(true);
		
		// Automatischer Umbruch auf Wortgrenze
		// wenn autom. Zeilenumbruch gesetzt wurde.
		txarAbstract.setWrapStyleWord(true);
				
		// Freien Bereich zwischen Rahmen und dem Text definieren.
		txarAbstract.setMargin(new Insets(2, 2, 2, 2));
		
		txarAbstract.setName("Abstract");
		txarAbstract.setToolTipText(myLibref.getAttributeTooltip("Abstract"));
		txarAbstract.addFocusListener(this);
		txarAbstract.addKeyListener(this);
		this.add(txarAbstractScrollPane, BorderLayout.CENTER);
		
		
	    //Buttons
		btnNewLibref = new JButton("New Literature");
		btnNewLibref.setBounds(10, 5, 120, 25);
		btnNewLibref.setMargin(new Insets(3, 3, 3, 3));
		btnNewLibref.setName("New Literature");
		btnNewLibref.addKeyListener(this);
		btnNewLibref.addActionListener(this);
		pnlBottom.add(btnNewLibref);
		
		btnSave2 = new JButton("Save");
		btnSave2.setBounds(1, 5, 4, 25);
		btnSave2.setMargin(new Insets(2, 2, 2, 2));
		btnSave2.setName("Save");
		btnSave2.setBackground(Color.GREEN);
		btnSave2.addActionListener(this);
		btnSave2.addKeyListener(this);
		btnSave2.setVisible(false);
		pnlBottom.add(btnSave2);

		btnPeriodical = new JButton("Edit Periodical");
		btnPeriodical.setName("Edit Periodical");
		btnPeriodical.setBounds(140, 5, 120, 25);
		btnPeriodical.setMargin(new Insets(2, 2, 2, 2));
		btnPeriodical.addActionListener(this);
		btnPeriodical.addKeyListener(this);
		pnlBottom.add(btnPeriodical);

		btnReport = new JButton("Report");
		btnReport.setName("Report");
		btnReport.setBounds(270, 5, 120, 25);
		btnReport.setMargin(new Insets(2, 2, 2, 2));
		btnReport.addActionListener(this);
		btnReport.addKeyListener(this);
		pnlBottom.add(btnReport);
		
		btnOK = new JButton("Save & Close");
		btnOK.setBounds(400, 5, 120, 25);
		btnOK.setMargin(new Insets(2, 2, 2, 2));
		btnOK.setName("Save");
		btnOK.addActionListener(this);
		btnOK.addKeyListener(this);
		pnlBottom.add(btnOK);

		btnCancel = new JButton("Cancel & Close");
		btnCancel.setName("Cancel");
		btnCancel.setBounds(530, 5, 120, 25);
		btnCancel.setMargin(new Insets(2, 2, 2, 2));
		btnCancel.addActionListener(this);
		btnCancel.addKeyListener(this);
		pnlBottom.add(btnCancel);

		btnQuitApp = new JButton("Quit application");
		btnQuitApp.setName("Quit");
		btnQuitApp.setBounds(660, 5, 120, 25);
		btnQuitApp.setMargin(new Insets(2, 2, 2, 2));
		btnQuitApp.addActionListener(this);
		btnQuitApp.addKeyListener(this);
		pnlBottom.add(btnQuitApp);
		
	}

	private boolean saveEntry()
	{
		if (!Father.hasChanged) return true;
		
		// If all fields are empty, we do not construct a new element
		if ((cboAuthor_1.getSelectedIndex() != 0) || (cboAuthor_2.getSelectedIndex() != 0)
				|| (cboAuthor_3.getSelectedIndex() != 0) || (cboAuthor_4.getSelectedIndex() != 0)
				|| (cleanEntry(tfYear.getText()).length() > 0) || (cleanEntry(tfTitle.getText()).length() > 0)
				|| (cleanEntry(tfIn_Book_title.getText()).length() > 0) || (cleanEntry(tfVolume.getText()).length() > 0)
				|| (cleanEntry(tfPages.getText()).length() > 0) || (cleanEntry(tfBibliographic_data.getText()).length() > 0)
			    || (cboType.getSelectedIndex() != 0) || (cboKeyword_1.getSelectedIndex() != 0)
			    || (cboKeyword_2.getSelectedIndex() != 0) || (cleanEntry(tfCatalogue_Number.getText()).length() > 0)
		    || (cleanEntry(tfStoring_place.getText()).length() > 0) || (cleanEntry(tfRemarks.getText()).length() > 0)
		    || (cleanEntry(txarAbstract.getText()).length() > 0) || this.mySelectedPeriodical != null)
		{
			// As a first step, we have to clean the old comparevalue
				this.oldCompareValue = null;
			
			if (!eingabeOK())
				return false;

			// Now myLibref contains the actual data
			// and !Father.hasChanged = TRUE
			// We actualize the data in the other frames
			
			//We eliminate the old entry
			if (this.oldCompareValue != null)
				Father.LibrefTree.remove(oldCompareValue);	

			Father.LibrefTree.put(myLibref.getCompareValue(), myLibref);
			
			if (Libref_MayLibTable != null)			
				Libref_MayLibTable.MyTableTreeSet.add(myLibref);
			
			if (this.myLibrefSplitPane !=null)
				Father.QueriedLibrefSet.add(myLibref);
		}

		if (!Father.hasChanged) return true;
		
		String fileExtension = "UCF", Characterset = "UTF-16";
		String Dateiname = Father.MayLibFile;

		return Father.saveMayLib(Dateiname, fileExtension, Characterset);
	}
	
	
	private String cleanEntry(String EntryString)
	{
		return EntryString.replace(";", ",").replace("\n", " ").replace("\r", " ").replace("\t", " ").trim();
	}
	
	private boolean eingabeOK()
	{	
		// if nothing has been changed we do nothing
		if (!Father.hasChanged) return true;
		
//		System.out.println("cboAuthor_1.getSelectedIndex()" +cboAuthor_1.getSelectedIndex());
//		System.out.println("cboAuthor_3.getSelectedIndex()" +cboAuthor_3.getSelectedIndex());
//		System.out.println("cboAuthor_3.getEditor().getItem().toString()" +cboAuthor_3.getEditor().getItem().toString());
	
		if (cboAuthor_1.getSelectedIndex()==0 || cleanEntry(cboAuthor_1.getEditor().getItem().toString().replace("(none)", "")).length() == 0)
		{
			supressPopCombwindowActiv = true;
			JOptionPane.showMessageDialog(this, "The field \"1st Author\" must be filled", "Missing data", JOptionPane.ERROR_MESSAGE);
			cboAuthor_1.requestFocusInWindow();
			return false;
		}
		
		if (cleanEntry(tfYear.getText()).length() == 0)
		{
			supressPopCombwindowActiv = true;
			JOptionPane.showMessageDialog(this, "The field \"Year\" must be filled", "Missing data", JOptionPane.ERROR_MESSAGE);
			tfYear.requestFocusInWindow();
			return false;
		}
		
		if (cboKeyword_1.getSelectedIndex()==0 || cleanEntry(cboKeyword_1.getEditor().getItem().toString().replace("(none)", "")).length() == 0)
		{
			supressPopCombwindowActiv = true;
			JOptionPane.showMessageDialog(this, "The field \"1st Keyword\" must be filled", "Missing data", JOptionPane.ERROR_MESSAGE);
			cboKeyword_1.requestFocusInWindow();
			return false;
		}
				
		//Clean and shorten if necessary the entries
				String S_Author_1 = cleanEntry(cboAuthor_1.getEditor().getItem().toString().replace("(none)", ""));
				if (S_Author_1.length() > Libref.getAttributeLength("Author_1"))
					S_Author_1 =S_Author_1.substring(0, Libref.getAttributeLength("Author_1"));
				
				String S_Author_2 = cleanEntry(cboAuthor_2.getEditor().getItem().toString().replace("(none)", ""));
				if (S_Author_2.length() > Libref.getAttributeLength("Author_2"))
					S_Author_2 = S_Author_2.substring(0, Libref.getAttributeLength("Author_2"));
				
				String S_Author_3 = cleanEntry(cboAuthor_3.getEditor().getItem().toString().replace("(none)", ""));
				if (S_Author_3.length() > Libref.getAttributeLength("Author_3"))
					S_Author_3 = S_Author_3.substring(0, Libref.getAttributeLength("Author_3"));
				
				String S_Author_4 = cleanEntry(cboAuthor_4.getEditor().getItem().toString().replace("(none)", ""));
				if (S_Author_4.length() > Libref.getAttributeLength("Author_4"))
					S_Author_4 = S_Author_4.substring(0, Libref.getAttributeLength("Author_4"));
				
				String S_Year = cleanEntry(tfYear.getText());
				if (S_Year.length() > Libref.getAttributeLength("Year"))
					S_Year =S_Year.substring(0, Libref.getAttributeLength("Year"));
							
				String S_Editor = cleanEntry(tfEditor.getText());
				if (S_Editor.length() > Libref.getAttributeLength("Editor"))
					S_Editor =S_Editor.substring(0, Libref.getAttributeLength("Editor"));
				
				String S_Title = cleanEntry(tfTitle.getText());
				if (S_Title.length() > Libref.getAttributeLength("Title"))
					S_Title =S_Title.substring(0, Libref.getAttributeLength("Title"));
				
				String S_In_Book_title = cleanEntry(tfIn_Book_title.getText());
				if (S_In_Book_title.length() > Libref.getAttributeLength("In_Book_title"))
					S_In_Book_title =S_In_Book_title.substring(0, Libref.getAttributeLength("In_Book_title"));

				// Periodical!!
				
				String S_Editorial = cleanEntry(tfEditorial.getText());
				if (S_Editorial.length() > Libref.getAttributeLength("Editorial"))
					S_Editorial =S_Editorial.substring(0, Libref.getAttributeLength("Editorial"));
				
				String S_Volume = cleanEntry(tfVolume.getText());
				if (S_Volume.length() > Libref.getAttributeLength("Volume"))
					S_Volume =S_Volume.substring(0, Libref.getAttributeLength("Volume"));
				
				String S_Pages = cleanEntry(tfPages.getText());
				if (S_Pages.length() > Libref.getAttributeLength("Pages"))
					S_Pages =S_Pages.substring(0, Libref.getAttributeLength("Pages"));
				
				String S_Figures = cleanEntry(tfFigures.getText());
				if (S_Figures.length() > Libref.getAttributeLength("Figures"))
					S_Figures =S_Figures.substring(0, Libref.getAttributeLength("Figures"));
				
				String S_Number_of_tables = cleanEntry(tfNumber_of_tables.getText());
				if (S_Number_of_tables.length() > Libref.getAttributeLength("Number_of_tables"))
					S_Number_of_tables =S_Number_of_tables.substring(0, Libref.getAttributeLength("Number_of_tables"));
				
				String S_Plates = cleanEntry(tfPlates.getText());
				if (S_Plates.length() > Libref.getAttributeLength("Plates"))
					S_Plates =S_Plates.substring(0, Libref.getAttributeLength("Plates"));
				
				String S_Bibliographic_data = cleanEntry(tfBibliographic_data.getText());
				if (S_Bibliographic_data.length() > Libref.getAttributeLength("Bibliographic_data"))
					S_Bibliographic_data =S_Bibliographic_data.substring(0, Libref.getAttributeLength("Bibliographic_data"));
				
				String S_Type = cleanEntry(cboType.getEditor().getItem().toString().replace("(none)", ""));
				if (S_Type.length() > Libref.getAttributeLength("Type"))
					S_Type =S_Type.substring(0, Libref.getAttributeLength("Type"));
				
				String S_Keyword_1 = cleanEntry(cboKeyword_1.getEditor().getItem().toString().replace("(none)", ""));
				if (S_Keyword_1.length() > Libref.getAttributeLength("Keyword_1"))
					S_Keyword_1 =S_Keyword_1.substring(0, Libref.getAttributeLength("Keyword_1"));
				
				String S_Keyword_2 = cleanEntry(cboKeyword_2.getEditor().getItem().toString().replace("(none)", ""));
				if (S_Keyword_2.length() > Libref.getAttributeLength("Keyword_2"))
					S_Keyword_2 =S_Keyword_2.substring(0, Libref.getAttributeLength("Keyword_2"));
				
				String S_Keyword_3 = cleanEntry(cboKeyword_3.getEditor().getItem().toString().replace("(none)", ""));
				if (S_Keyword_3.length() > Libref.getAttributeLength("Keyword_3"))
					S_Keyword_3 =S_Keyword_3.substring(0, Libref.getAttributeLength("Keyword_3"));
				
				String S_Catalogue_Number = cleanEntry(tfCatalogue_Number.getText());
				if (S_Catalogue_Number.length() > Libref.getAttributeLength("Catalogue_Number"))
					S_Catalogue_Number =S_Catalogue_Number.substring(0, Libref.getAttributeLength("Catalogue_Number"));
				
				String S_Storing_place = cleanEntry(tfStoring_place.getText());
				if (S_Storing_place.length() > Libref.getAttributeLength("Storing_place"))
					S_Storing_place =S_Storing_place.substring(0, Libref.getAttributeLength("Storing_place"));
				
				String S_Date_Entry = cleanEntry(tfDate_Entry.getText());
				if (S_Date_Entry.length() > Libref.getAttributeLength("Date_Entry"))
					S_Date_Entry =S_Date_Entry.substring(0, Libref.getAttributeLength("Date_Entry"));
				
				String S_ISBN = cleanEntry(tfISBN.getText());
				if (S_ISBN.length() > Libref.getAttributeLength("ISBN"))
					S_ISBN =S_ISBN.substring(0, Libref.getAttributeLength("ISBN"));

				String S_Remarks = cleanEntry(tfRemarks.getText());
				if (S_Remarks.length() > Libref.getAttributeLength("Remarks"))
					S_Remarks =S_Remarks.substring(0, Libref.getAttributeLength("Remarks"));

				String S_Abstract = cleanEntry(txarAbstract.getText());
				if (S_Abstract.length() > Libref.getAttributeLength("Abstract"))
					S_Abstract =S_Abstract.substring(0, Libref.getAttributeLength("Abstract"));

				
				//Prove on duplicates
				String Teststring = Libref.makeCompareValue(S_Author_1, S_Author_2, S_Author_3, S_Author_4, S_Year);
				
				if (Father.LibrefTree.containsKey(Teststring))
				{
					if (myLibref == null)
					{

						JOptionPane.showMessageDialog(this, "A literature reference with this combination of authors and year already exists.", "Conflict with existing data",
								JOptionPane.ERROR_MESSAGE);
						cboAuthor_1.requestFocusInWindow();
						return false;
					}

					else
					{
						Libref ParentLibref = Father.LibrefTree.get(Teststring);

						if (ParentLibref != myLibref)
						{
							JOptionPane.showMessageDialog(this, "Another literature reference with this combination of authors and year already exists.",
									"Conflict with existing data", JOptionPane.ERROR_MESSAGE);
							cboAuthor_1.requestFocusInWindow();
							return false;
						}
					}

				}
				
				// Now we know that it is o.k.
				// We construct a new Libref
				
				// As a first step, we have to actualize the old comparevalue with the comparevalue of the old myLibref
				if (this.myLibref != null)
					this.oldCompareValue = myLibref.getCompareValue();
				else
					this.oldCompareValue = null;
				
				if (myLibref == null)
				{
					myLibref = new Libref(S_Author_1, S_Author_2, S_Author_3, S_Author_4, S_Year);
				}
				else
				{
					myLibref.setAuthorsYear(S_Author_1, S_Author_2, S_Author_3, S_Author_4, S_Year);
				}
				
				myLibref.setPeriodical(mySelectedPeriodical);
				
				myLibref.setEditor(S_Editor);
				myLibref.setTitle(S_Title);
				myLibref.setIn_Book_title(S_In_Book_title);
				myLibref.setVolume(S_Volume);
				myLibref.setPages(S_Pages);
				myLibref.setFigures(S_Figures);
				myLibref.setNumber_of_tables(S_Number_of_tables);
				myLibref.setPlates(S_Plates);
				myLibref.setBibliographic_data(S_Bibliographic_data);
				myLibref.setEditorial(S_Editorial);
				myLibref.setType(S_Type);
				myLibref.setKeyword_1(S_Keyword_1);
				myLibref.setKeyword_2(S_Keyword_2);
				myLibref.setKeyword_3(S_Keyword_3);
				myLibref.setCatalogue_Number(S_Catalogue_Number);
				myLibref.setStoring_place(S_Storing_place);
				myLibref.setRemarks(S_Remarks);
				myLibref.setDate_Entry(S_Date_Entry);
				myLibref.setISBN(S_ISBN);
				myLibref.setAbstract(S_Abstract);
				
				//The auxiliary TreeSets are filled
				if (S_Type.length()>0)
					Father.LibrefTypeSet.add(S_Type);

				Father.LibrefYearSet.add(S_Year);

				if (!S_Author_1.contains("&"))
					Father.LibrefAuthorSet.add(S_Author_1);
				else
					Father.LibrefOtherAuthorsSet.add(S_Author_1);
				
				if (S_Author_2.length() > 0)
				{
					if (!S_Author_2.contains("&"))
						Father.LibrefAuthorSet.add(S_Author_2);
					else
						Father.LibrefOtherAuthorsSet.add(S_Author_2);
				}

				if (S_Author_3.length() > 0)
				{
					if (!S_Author_3.contains("&"))
						Father.LibrefAuthorSet.add(S_Author_3);
					else
						Father.LibrefOtherAuthorsSet.add(S_Author_3);
				}
				
				if (S_Author_4.length()>0)
					Father.LibrefOtherAuthorsSet.add(S_Author_4);

				Father.LibrefKeywordSet.add(S_Keyword_1);

				if (S_Keyword_2.length() > 0)
					Father.LibrefKeywordSet.add(S_Keyword_2);

				if (S_Keyword_3.length() > 0)
					Father.LibrefKeywordSet.add(S_Keyword_3);					

	
				// assure that the change is notified
				Father.hasChanged = true; 
				Father.needpopulateCboOther = true;
				miReportSelObjects.setEnabled(true);
				btnReport.setEnabled(true);
				fillFields();
				 //fill Combobox
				populateComboboxes();
				
				return true;
			}	

	
	private boolean queryExit()
	{
			
		// Benutzerdefinierten Button Text
		Object[] options = {"Yes", "No", "Cancel"};
		
		if (!Father.hasChanged) return true;
		
		int retValue = JOptionPane.showOptionDialog(this, "The literature data have been changed.\nDo you want to save the changes?", "Save the changes?", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[2]);
		
		// Abbrechen ?
		if (retValue == 2) return false;
		
		// Ja - Speichern ?
		if (retValue == 0)
		{
			boolean result = saveEntry();
			
			if (result==true)
			{
				JOptionPane.showMessageDialog(null, "Changes in opened MayLib database saved (File: " + Father.lastWrittenFile +").", "Data saved",
						JOptionPane.INFORMATION_MESSAGE);	
			}
			
			return result;
		}
		
		// Nein - Nicht speichern
		return true;			
	}
	

	@Override
	public void initDialog()
	{


		this.getContentPane().setBackground(Father.BackGroundColor);
		this.pnlBottom.setBackground(Father.BackGroundColor);
		this.pnlTextfield.setBackground(Father.BackGroundColor);
		
		//Windowsize
		if (Father.LibrefDialog_Width > 0 && Father.LibrefDialog_Height > 0)
			this.setBounds(Father.LibrefDialog_X, Father.LibrefDialog_Y, 
					Father.LibrefDialog_Width, Father.LibrefDialog_Height);
		else
		{
			if (Father.MaximizeWindow.equalsIgnoreCase("big") || Father.MaximizeWindow.equalsIgnoreCase("all"))
				makeFrameFullSize();
		}
		
		kbFocusManager = KeyboardFocusManager.getCurrentKeyboardFocusManager();
		
		setmyFontChild();
		
		miSave.setEnabled(Father.hasChanged);
		btnSave1.setEnabled(Father.hasChanged);
		btnSave2.setEnabled(Father.hasChanged);	

		// activate /deactivate Report Menu
		menuReport.setEnabled(true);
		submenuAbstract.setEnabled(Father.LibrefTree.size() > 0);
		submenuReportType.setEnabled(true);
		miReportAllLibrefs.setEnabled(Father.LibrefTree.size() > 0);
		miReportAllPeriodicals.setEnabled(Father.PeriodicalTree.size() > 0);
		miReportSelObjects.setEnabled(myLibref != null);
		miWithoutAbstract.setEnabled(Father.LibrefTree.size() > 0);
		mi1000Abstract.setEnabled(Father.LibrefTree.size() > 0);
		mi2000Abstract.setEnabled(Father.LibrefTree.size() > 0);
		mi4000Abstract.setEnabled(Father.LibrefTree.size() > 0);
		miFullAbstract.setEnabled(Father.LibrefTree.size() > 0);
		miBasicReport.setEnabled(true);
		miCompleteReport.setEnabled(true);
		miGermanStandardReport.setEnabled(Father.LibrefTree.size() > 0);
		miPalaeontologyReport.setEnabled(Father.LibrefTree.size() > 0);
		miBullGeosciencesPragueReport.setEnabled(Father.LibrefTree.size() > 0);
		
		miWithoutAbstract.setSelected(true);
		miBasicReport.setSelected(true);
		miCboFreeNo.setSelected(true);
		miCboAutocYes.setSelected(true);
		miCboCaseNo.setSelected(true);
		//miRepUnicode.setSelected(true);
		btnReport.setEnabled(myLibref != null);
		
		// Defines charset of report
		if (Father.strexecRepCharset.equalsIgnoreCase("Default"))
		{
			this.miRepDefault.setSelected(true);
		}
		else if (Father.strexecRepCharset.equalsIgnoreCase("Unknown"))
		{
			this.miRepUnknown.setSelected(true);
		}
		else
		{
			this.miRepUnicode.setSelected(true);
		}

	
		if (myLibref != null) 
		{
			fillFields();
		}
		
		 //fill Combobox
		populateComboboxes();
	}


	
	@Override
	public void focusGained(FocusEvent e)
	{
		// TODO Auto-generated method stub
	}

	@Override
	public void focusLost(FocusEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowActivated(WindowEvent arg0)
	{
		if (supressPopCombwindowActiv == false)
			populateComboboxes();
		
		supressPopCombwindowActiv = true;
	}

	@Override
	public void windowClosed(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowClosing(WindowEvent arg0)
	{
		// berprfen, ob nderungen noch gespeichert werden mssen
		if (queryExit())
			execSizeDispose();
		else
			cboAuthor_1.requestFocusInWindow();
		
	}

	@Override
	public void windowDeactivated(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowDeiconified(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowIconified(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowOpened(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void keyPressed(KeyEvent e)
	{
		
		if (e.getKeyCode() == KeyEvent.VK_ENTER)
		{

			if (e.getSource().equals(cboAuthor_1) && (cboAuthor_1.getSelectedIndex()==0 
					|| cleanEntry(cboAuthor_1.getEditor().getItem().toString().replace("(none)", "")).length() == 0))
				return;
			
			else if (e.getSource().equals(tfYear) && cleanEntry(tfYear.getText()).length() == 0)
				return;
			
			else if (e.getSource().equals(cboKeyword_1) && (cboKeyword_1.getSelectedIndex()==0 || cleanEntry(cboKeyword_1.getEditor().getItem().toString().replace("(none)", "")).length() == 0))
				return;

			else if (e.getSource().equals(btnCancel))
				windowClosing(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));

			else if (e.getSource().equals(btnOK))
			{
				if (Father.hasChanged && !saveEntry())
					return;
				windowClosing(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
			}

			else if (e.getSource().equals(btnNewLibref))
				clickmiNewLibref();
			else if (e.getSource().equals(btnPeriodical))
				clickEditPeriodical();

			else if (e.getSource().equals(btnReport))
			{	
				TreeSet<Object> ReportTreeSet = new TreeSet<Object>();
				ReportTreeSet.add(this.myLibref);
				
				Father.createReport(ReportTreeSet, "Libref", this.getTitle(), "full", "complete", "RPU", "UTF-16");
			}		
			
			else if (e.getSource().equals(btnQuitApp))
			{
				clickmiQuitApp();
			}
			
			else if (e.getSource().equals(btnSave1))
			{
				saveEntry();
				btnSave1.setEnabled(Father.hasChanged);
				btnSave2.setEnabled(Father.hasChanged);	
			}
			
			else if (e.getSource().equals(btnSave2))
			{
				saveEntry();
				btnSave1.setEnabled(Father.hasChanged);
				btnSave2.setEnabled(Father.hasChanged);	
			}


			else

				kbFocusManager.focusNextComponent();
		}
		
	}

	@Override
	public void keyReleased(KeyEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void keyTyped(KeyEvent e)
	{
		if (!(e.getSource() instanceof JButton))
		{
			Father.hasChanged = true;
			miSave.setEnabled(true);
			btnSave1.setEnabled(Father.hasChanged);
			btnSave2.setEnabled(Father.hasChanged);	
		}

		if (e.getSource().equals(txarAbstract))
		{

			if (((JTextArea) e.getSource()).getText().length() >= Libref.getAttributeLength(((JTextArea) e.getSource()).getName()))
			{
				Toolkit.getDefaultToolkit().beep();
				e.consume();
				return;
			}
		}

		else if (e.getSource().equals(tfYear) || e.getSource().equals(tfEditor) || e.getSource().equals(tfTitle) 
				|| e.getSource().equals(tfIn_Book_title) || e.getSource().equals(tfVolume) 
				|| e.getSource().equals(tfPages) || e.getSource().equals(tfFigures) 
				|| e.getSource().equals(tfNumber_of_tables) || e.getSource().equals(tfPlates) 
				|| e.getSource().equals(tfBibliographic_data) || e.getSource().equals(tfEditorial) 
				|| e.getSource().equals(tfCatalogue_Number) || e.getSource().equals(tfStoring_place) 
				|| e.getSource().equals(tfDate_Entry) || e.getSource().equals(tfISBN) || e.getSource().equals(tfRemarks))
		{
			if (((JTextField) e.getSource()).getText().length() >= Libref.getAttributeLength(((JTextField) e.getSource()).getName()))
			{
				Toolkit.getDefaultToolkit().beep();
				e.consume();
				return;
			}
		}

		else if (e.getSource().equals(cboPeriodical))
		{
			cboPeriodicalPreselection += e.getKeyChar();
			e.consume();
			cboPeriodical.hidePopup();
			populateCboPeriodical();
			cboPeriodical.showPopup();
		}

		else if (e.getKeyChar() == '&'
				&& (e.getSource().equals(cboAuthor_1.getEditor().getEditorComponent()) || e.getSource().equals(cboAuthor_2.getEditor().getEditorComponent()) || e
						.getSource().equals(cboAuthor_3.getEditor().getEditorComponent())))
		{
			Toolkit.getDefaultToolkit().beep();
			JOptionPane
					.showMessageDialog(
							this,
							"The fields \"1st, 2nd, 3rd Author\" do not accept the character '&'. \nIn each of these fields only one author should be placed. \nAdditional authors should be written in the field \"More Authors\"!",
							"Wrong input", JOptionPane.ERROR_MESSAGE);
			e.consume();
			return;
		}

		// Treating of the editable comboboxes
		else if (miCboFreeNo.isSelected() == true)
		{

			if (e.getSource().equals(cboAuthor_1.getEditor().getEditorComponent()))
			{
				String EditorContent = cboAuthor_1.getEditor().getItem().toString();

				if (EditorContent.contains("(none)"))
					EditorContent = "";

				EditorContent += e.getKeyChar();

				if (EditorContent.trim().length() == 0)
					EditorContent = "";

				if (e.getKeyChar() < 32)
					EditorContent = EditorContent.trim();

				cboAuthor_1.removeItemListener(this);
				cboAuthor_1.hidePopup();
				cboAuthor1Model.removeAllElements();
				cboAuthor1Model.addElement("  (none) ");

				Iterator<String> i4t = Father.LibrefAuthorSet.iterator();
				while (i4t.hasNext())
				{
					String DisplayObj = i4t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboAuthor1Model.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboAuthor1Model.addElement(DisplayObj);
					}

				}

				Iterator<String> i5t = Father.LibrefOtherAuthorsSet.iterator();
				while (i5t.hasNext())
				{
					String DisplayObj = i5t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboAuthor1Model.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboAuthor1Model.addElement(DisplayObj);
					}
				}

				cboAuthor_1.showPopup();

				if ((cboAuthor1Model.getSize() == 2) && ((String) cboAuthor_1.getItemAt(1)).length() > EditorContent.length() && miCboAutocYes.isSelected()
						&& (Character.isLetterOrDigit(e.getKeyChar()) || e.getKeyChar() == '-' || e.getKeyChar() == ',' || e.getKeyChar() == '.'))
					cboAuthor_1.setSelectedIndex(1);
				else
					cboAuthor_1.getEditor().setItem(EditorContent);

				cboAuthor_1.addItemListener(this);
				e.consume();
			}

			else if (e.getSource().equals(cboAuthor_2.getEditor().getEditorComponent()))
			{
				String EditorContent = cboAuthor_2.getEditor().getItem().toString();

				if (EditorContent.contains("(none)"))
					EditorContent = "";

				EditorContent += e.getKeyChar();

				if (EditorContent.trim().length() == 0)
					EditorContent = "";

				if (e.getKeyChar() < 32)
					EditorContent = EditorContent.trim();

				cboAuthor_2.removeItemListener(this);
				cboAuthor_2.hidePopup();
				cboAuthor2Model.removeAllElements();
				cboAuthor2Model.addElement("  (none) ");

				Iterator<String> i4t = Father.LibrefAuthorSet.iterator();
				while (i4t.hasNext())
				{
					String DisplayObj = i4t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboAuthor2Model.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboAuthor2Model.addElement(DisplayObj);
					}
				}

				Iterator<String> i5t = Father.LibrefOtherAuthorsSet.iterator();
				while (i5t.hasNext())
				{
					String DisplayObj = i5t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboAuthor2Model.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboAuthor2Model.addElement(DisplayObj);
					}
				}

				cboAuthor_2.showPopup();

				if ((cboAuthor2Model.getSize() == 2) && ((String) cboAuthor_2.getItemAt(1)).length() > EditorContent.length() && miCboAutocYes.isSelected()
						&& (Character.isLetterOrDigit(e.getKeyChar()) || e.getKeyChar() == '-' || e.getKeyChar() == ',' || e.getKeyChar() == '.'))
					cboAuthor_2.setSelectedIndex(1);
				else
					cboAuthor_2.getEditor().setItem(EditorContent);

				cboAuthor_2.addItemListener(this);
				e.consume();
			}

			else if (e.getSource().equals(cboAuthor_3.getEditor().getEditorComponent()))
			{
				String EditorContent = cboAuthor_3.getEditor().getItem().toString();

				if (EditorContent.contains("(none)"))
					EditorContent = "";

				EditorContent += e.getKeyChar();

				if (EditorContent.trim().length() == 0)
					EditorContent = "";

				if (e.getKeyChar() < 32)
					EditorContent = EditorContent.trim();

				cboAuthor_3.removeItemListener(this);
				cboAuthor_3.hidePopup();
				cboAuthor3Model.removeAllElements();
				cboAuthor3Model.addElement("  (none) ");

				Iterator<String> i4t = Father.LibrefAuthorSet.iterator();
				while (i4t.hasNext())
				{
					String DisplayObj = i4t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboAuthor3Model.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboAuthor3Model.addElement(DisplayObj);
					}
				}

				Iterator<String> i5t = Father.LibrefOtherAuthorsSet.iterator();
				while (i5t.hasNext())
				{
					String DisplayObj = i5t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboAuthor3Model.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboAuthor3Model.addElement(DisplayObj);
					}
				}

				cboAuthor_3.showPopup();

				if ((cboAuthor3Model.getSize() == 2) && ((String) cboAuthor_3.getItemAt(1)).length() > EditorContent.length() && miCboAutocYes.isSelected()
						&& (Character.isLetterOrDigit(e.getKeyChar()) || e.getKeyChar() == '-' || e.getKeyChar() == ',' || e.getKeyChar() == '.'))
					cboAuthor_3.setSelectedIndex(1);
				else
					cboAuthor_3.getEditor().setItem(EditorContent);

				cboAuthor_3.addItemListener(this);
				e.consume();
			}

			else if (e.getSource().equals(cboAuthor_4.getEditor().getEditorComponent()))
			{
				String EditorContent = cboAuthor_4.getEditor().getItem().toString();

				if (EditorContent.contains("(none)"))
					EditorContent = "";

				EditorContent += e.getKeyChar();

				if (EditorContent.trim().length() == 0)
					EditorContent = "";

				if (e.getKeyChar() < 32)
					EditorContent = EditorContent.trim();

				cboAuthor_4.removeItemListener(this);
				cboAuthor_4.hidePopup();
				cboAuthor4Model.removeAllElements();
				cboAuthor4Model.addElement("  (none) ");

				Iterator<String> i4t = Father.LibrefAuthorSet.iterator();
				while (i4t.hasNext())
				{
					String DisplayObj = i4t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboAuthor4Model.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboAuthor4Model.addElement(DisplayObj);
					}
				}

				Iterator<String> i5t = Father.LibrefOtherAuthorsSet.iterator();
				while (i5t.hasNext())
				{
					String DisplayObj = i5t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboAuthor4Model.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboAuthor4Model.addElement(DisplayObj);
					}
				}

				cboAuthor_4.showPopup();

				if ((cboAuthor4Model.getSize() == 2) && ((String) cboAuthor_4.getItemAt(1)).length() > EditorContent.length() && miCboAutocYes.isSelected()
						&& (Character.isLetterOrDigit(e.getKeyChar()) || e.getKeyChar() == '-' || e.getKeyChar() == ',' || e.getKeyChar() == '.'))
					cboAuthor_4.setSelectedIndex(1);
				else
					cboAuthor_4.getEditor().setItem(EditorContent);

				cboAuthor_4.addItemListener(this);
				e.consume();
			}

			else if (e.getSource().equals(cboKeyword_1.getEditor().getEditorComponent()))
			{
				String EditorContent = cboKeyword_1.getEditor().getItem().toString();

				if (EditorContent.contains("(none)"))
					EditorContent = "";

				EditorContent += e.getKeyChar();

				if (EditorContent.trim().length() == 0)
					EditorContent = "";

				if (e.getKeyChar() < 32)
					EditorContent = EditorContent.trim();

				cboKeyword_1.removeItemListener(this);
				cboKeyword_1.hidePopup();
				cboKeyword1Model.removeAllElements();
				cboKeyword1Model.addElement("  (none) ");

				Iterator<String> i4t = Father.LibrefKeywordSet.iterator();
				while (i4t.hasNext())
				{
					String DisplayObj = i4t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboKeyword1Model.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboKeyword1Model.addElement(DisplayObj);
					}
				}

				cboKeyword_1.showPopup();

				if ((cboKeyword1Model.getSize() == 2) && ((String) cboKeyword_1.getItemAt(1)).length() > EditorContent.length() && miCboAutocYes.isSelected()
						&& (Character.isLetterOrDigit(e.getKeyChar()) || e.getKeyChar() == '-' || e.getKeyChar() == ',' || e.getKeyChar() == '.'))
					cboKeyword_1.setSelectedIndex(1);
				else
					cboKeyword_1.getEditor().setItem(EditorContent);

				cboKeyword_1.addItemListener(this);
				e.consume();
			}

			else if (e.getSource().equals(cboKeyword_2.getEditor().getEditorComponent()))
			{
				String EditorContent = cboKeyword_2.getEditor().getItem().toString();

				if (EditorContent.contains("(none)"))
					EditorContent = "";

				EditorContent += e.getKeyChar();

				if (EditorContent.trim().length() == 0)
					EditorContent = "";

				if (e.getKeyChar() < 32)
					EditorContent = EditorContent.trim();

				cboKeyword_2.removeItemListener(this);
				cboKeyword_2.hidePopup();
				cboKeyword2Model.removeAllElements();
				cboKeyword2Model.addElement("  (none) ");

				Iterator<String> i4t = Father.LibrefKeywordSet.iterator();
				while (i4t.hasNext())
				{
					String DisplayObj = i4t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboKeyword2Model.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboKeyword2Model.addElement(DisplayObj);
					}
				}

				cboKeyword_2.showPopup();

				if ((cboKeyword2Model.getSize() == 2) && ((String) cboKeyword_2.getItemAt(1)).length() > EditorContent.length() && miCboAutocYes.isSelected()
						&& (Character.isLetterOrDigit(e.getKeyChar()) || e.getKeyChar() == '-' || e.getKeyChar() == ',' || e.getKeyChar() == '.'))
					cboKeyword_2.setSelectedIndex(1);
				else
					cboKeyword_2.getEditor().setItem(EditorContent);

				cboKeyword_2.addItemListener(this);
				e.consume();
			}

			else if (e.getSource().equals(cboKeyword_3.getEditor().getEditorComponent()))
			{
				String EditorContent = cboKeyword_3.getEditor().getItem().toString();

				if (EditorContent.contains("(none)"))
					EditorContent = "";

				EditorContent += e.getKeyChar();

				if (EditorContent.trim().length() == 0)
					EditorContent = "";

				if (e.getKeyChar() < 32)
					EditorContent = EditorContent.trim();

				cboKeyword_3.removeItemListener(this);
				cboKeyword_3.hidePopup();
				cboKeyword3Model.removeAllElements();
				cboKeyword3Model.addElement("  (none) ");

				Iterator<String> i4t = Father.LibrefKeywordSet.iterator();
				while (i4t.hasNext())
				{
					String DisplayObj = i4t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboKeyword3Model.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboKeyword3Model.addElement(DisplayObj);
					}
				}

				cboKeyword_3.showPopup();

				if ((cboKeyword3Model.getSize() == 2) && ((String) cboKeyword_3.getItemAt(1)).length() > EditorContent.length() && miCboAutocYes.isSelected()
						&& (Character.isLetterOrDigit(e.getKeyChar()) || e.getKeyChar() == '-' || e.getKeyChar() == ',' || e.getKeyChar() == '.'))
					cboKeyword_3.setSelectedIndex(1);
				else
					cboKeyword_3.getEditor().setItem(EditorContent);

				cboKeyword_3.addItemListener(this);
				e.consume();
			}

			else if (e.getSource().equals(cboType.getEditor().getEditorComponent()))
			{
				String EditorContent = cboType.getEditor().getItem().toString();

				if (EditorContent.contains("(none)"))
					EditorContent = "";

				EditorContent += e.getKeyChar();

				if (EditorContent.trim().length() == 0)
					EditorContent = "";

				if (e.getKeyChar() < 32)
					EditorContent = EditorContent.trim();

				cboType.removeItemListener(this);
				cboType.hidePopup();
				cboTypeModel.removeAllElements();
				cboTypeModel.addElement("  (none) ");

				Iterator<String> i4t = Father.LibrefTypeSet.iterator();
				while (i4t.hasNext())
				{
					String DisplayObj = i4t.next();

					if (miCboCaseNo.isSelected())
					{
						if (DisplayObj.toLowerCase().startsWith(EditorContent.toLowerCase()))
							cboTypeModel.addElement(DisplayObj);
					}
					else
					{
						if (DisplayObj.startsWith(EditorContent))
							cboTypeModel.addElement(DisplayObj);
					}
				}

				cboType.showPopup();

				if ((cboTypeModel.getSize() == 2) && ((String) cboType.getItemAt(1)).length() > EditorContent.length() && miCboAutocYes.isSelected()
						&& (Character.isLetterOrDigit(e.getKeyChar()) || e.getKeyChar() == '-' || e.getKeyChar() == ',' || e.getKeyChar() == '.'))
					cboType.setSelectedIndex(1);
				else
					cboType.getEditor().setItem(EditorContent);

				cboType.addItemListener(this);
				e.consume();
			}
		}
		// END OF Treating of the editable comboboxes
	}

	@Override
	public void actionPerformed(ActionEvent e)
	{			
		if (e.getSource().equals(btnCancel))
			windowClosing(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
		
		else if (e.getSource().equals(btnOK))
		{
			if (Father.hasChanged &&  !saveEntry()) return;
			windowClosing(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
		}
		
		else if (e.getSource().equals(btnNewLibref))
			clickmiNewLibref();
		else if (e.getSource().equals(btnPeriodical))
			clickEditPeriodical();
		
		else if (e.getSource().equals(btnSave1))
		{
			saveEntry();
			btnSave1.setEnabled(Father.hasChanged);
			btnSave2.setEnabled(Father.hasChanged);	
		}
		
		else if (e.getSource().equals(btnSave2))
		{
			saveEntry();
			btnSave1.setEnabled(Father.hasChanged);
			btnSave2.setEnabled(Father.hasChanged);	
		}

		else if (e.getSource().equals(btnReport))
		{	
			TreeSet<Object> ReportTreeSet = new TreeSet<Object>();
			ReportTreeSet.add(this.myLibref);
			
			Father.createReport(ReportTreeSet, "Libref", this.getTitle(), "full", "complete", "RPU", "UTF-16");
		}		
		
		else if (e.getSource().equals(miClose))
			windowClosing(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));

		
		else if (e.getSource().equals(miQuitApp))
		{
			clickmiQuitApp();
		}
		
		else if (e.getSource().equals(btnQuitApp))
		{
			clickmiQuitApp();
		}
		
		else if (e.getSource().equals(miNewPeriodical))
			clickmiNewPeriodical();
		
		else if (e.getSource().equals(miNewLibref))
			clickmiNewLibref();
		
		else if (e.getSource().equals(miEditPeriodical))
		{
			clickEditPeriodical();
		}

		else if (e.getSource().equals(miSearchAbstract))
		{
			MayLibSearch f = MayLibSearch.getInstance(txarAbstract,	Father);
			f.showDialog(this);
		}	

		else if (e.getSource().equals(miMaxCatalogNo))
		{
			execMaxCatalogNo();
		}	
		
		else if (e.getSource().equals(miSave))	
		{
			//String fileExtension = "UCF", Characterset = "UTF-16";
			//String Dateiname = Father.MayLibFile;
			
			if (saveEntry())
			{JOptionPane.showMessageDialog(null, "Changes in opened MayLib database saved (File: " + Father.lastWrittenFile +").", "Data saved",
					JOptionPane.INFORMATION_MESSAGE);			
			}
			
			btnSave1.setEnabled(Father.hasChanged);
			btnSave2.setEnabled(Father.hasChanged);
		}

		else if (e.getSource().equals(miSaveAsUCF))	
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = null;
			
			if (saveEntry() && Father.saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database saved sucessfully in the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}

		else if (e.getSource().equals(miSaveAsOther))	
		{
			String fileExtension = "TXT", Characterset = Father.Default_Charset;
			String Dateiname = null;
			
			if (saveEntry() && Father.saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database exported sucessfully to the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveAsUnknown))	
		{
			String fileExtension = "TXT", Characterset = "UNKNOWN";
			String Dateiname = null;
			
			if (saveEntry() && Father.saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database exported sucessfully to the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		
		// Reports
		else if (e.getSource().equals(miReportAllLibrefs)
				|| e.getSource().equals(miReportAllPeriodicals)
				|| e.getSource().equals(miReportSelObjects))	
		{
			/* Possible values of createReport(TreeSet<Object> ReportTreeSet, String ObjectType, String Headertext, String Abstract, String ReportType, String fileExtension, String Characterset)
			
			 * String ObjectType = Libref, Periodical
			 * String Headertext = null or a prepared text terminating without linefeed (linefeed will be added in the method createReport
			 * String Abstract  = without, 1000, full. Will be ignored, if ObjectType = Periodical
			 * String ReportType = basic, complete 
			 * String fileExtension = RPU, RPT
			 * String Characterset	= "UTF-16", Default_Charset, "UNKNOWN"	
		

			reportAllPeriodicals(String ReportType, String fileExtension, String Characterset)
			*/
			
			String Abstract ="without", ReportType = "basic", fileExtension ="RPT", Characterset =  Father.Default_Charset;
			
			if (miWithoutAbstract.isSelected())
				Abstract ="without";
			else if (mi1000Abstract.isSelected())
				Abstract ="1000";
			else if (mi2000Abstract.isSelected())
				Abstract ="2000";
			else if (mi4000Abstract.isSelected())
				Abstract ="4000";
			else if (miFullAbstract.isSelected())
				Abstract ="full";
				
			if (miBasicReport.isSelected())
				ReportType = "basic";
			else if (miCompleteReport.isSelected())
				ReportType = "complete";
			else if (miGermanStandardReport.isSelected())
				ReportType = "GermanStandard";
			else if (miPalaeontologyReport.isSelected())
				ReportType = "Palaeontology";
			else if (miBullGeosciencesPragueReport.isSelected())
				ReportType = "BullGeosciencesPrague";
			else 
				ReportType = "complete";
			
			if (miRepUnicode.isSelected())
			{
				fileExtension = "RPU";
				Characterset = "UTF-16";
				Father.execRepCharset("Unicode");
			}
			else if (miRepDefault.isSelected())
			{
				fileExtension ="RPT";
				Characterset =  Father.Default_Charset;
				Father.execRepCharset("Default");
			}
			else if (miRepUnknown.isSelected())
			{
				fileExtension ="RPT";
				Characterset =  "UNKNOWN";
				Father.execRepCharset("Unknown");
			}
			
			if (e.getSource().equals(miReportAllLibrefs))
				Father.reportAllLibrefs(Abstract, ReportType, fileExtension, Characterset);
			else if (e.getSource().equals(miReportAllPeriodicals))
				Father.reportAllPeriodicals(ReportType, fileExtension, Characterset);
			else 
			{	
				TreeSet<Object> ReportTreeSet = new TreeSet<Object>();
				ReportTreeSet.add(this.myLibref);
				
				Father.createReport(ReportTreeSet, "Libref", this.getTitle(), Abstract, ReportType, fileExtension, Characterset);
			}			
					
		}
		
		else if(e.getSource().equals(miCboFreeNo))
		{
			submenuCboAutocomplete.setEnabled(true);
			submenuCboCase.setEnabled(true);
			miCboAutocYes.setSelected(true);
			miCboCaseNo.setSelected(true);
		}
		
		else if(e.getSource().equals(miCboFreeYes))
		{
			submenuCboAutocomplete.setEnabled(false);
			submenuCboCase.setEnabled(false);
		}
		
		miSave.setEnabled(Father.hasChanged);
		btnSave1.setEnabled(Father.hasChanged);
		btnSave2.setEnabled(Father.hasChanged);		
	
	}
	
	private void clickmiNewPeriodical()
	{
		if (!saveEntry()) return;
		
		supressPopCombwindowActiv = false;
		
		PeriodicalDialog dlg = new PeriodicalDialog(null, this.Father, this.Periodical_MayLibTable, 
				this.Libref_MayLibTable, this.myLibrefSplitPane);
		dlg.showDialog(this);
	}
	
	private void clickmiNewLibref()
	{
		if (!saveEntry()) return;
		
		// now we clean up
		tfYear.setText("");
		tfEditor.setText("");
		tfTitle.setText("");
		tfIn_Book_title.setText("");
		tfVolume.setText("");
		tfPages.setText("");
		tfFigures.setText("");
		tfNumber_of_tables.setText("");
		tfPlates.setText("");
		tfBibliographic_data.setText("");
		tfEditorial.setText("");
		tfCatalogue_Number.setText("");
		tfStoring_place.setText("");
		tfDate_Entry.setText("");
		tfISBN.setText("");
		tfRemarks.setText("");
		txarAbstract.setText("");
		
		myLibref = null;
		mySelectedPeriodical = null;
		oldCompareValue = null;
		populateComboboxes();
		
		// now the combobox is actualized
		supressPopCombwindowActiv = true;
		
		miReportSelObjects.setEnabled(false);
		btnReport.setEnabled(false);
	}
	
	private void clickmiQuitApp()
	{
		// Prove if changes must be changed
		if (queryExit())
		{
		
			try
			{
				this.execSizeDispose();

				if (this.Libref_MayLibTable != null)
				{
					this.Libref_MayLibTable.execSizeDispose();
				}

				if (this.Periodical_MayLibTable != null)
				{
					this.Periodical_MayLibTable.execSizeDispose();
				}
				
				if (this.myLibrefSplitPane != null)
				{
					this.myLibrefSplitPane.execSizeDispose();
				}

				this.Father.dispose();
			}
			catch (Exception e)
			{
			}

		}
		else
			cboAuthor_1.requestFocusInWindow();
	}



	@Override
	public void itemStateChanged(ItemEvent e)
	{
		JComboBox cb;
		
		if (e.getSource() instanceof JComboBox)
		{
			cb = (JComboBox)e.getSource();
			
			if (e.getStateChange() == ItemEvent.DESELECTED && cb.getSelectedIndex() > -1)
			{
				if (e.getSource().equals(cboPeriodical))
				{
					if (cb.getSelectedIndex() ==0)
							this.mySelectedPeriodical = null;
					else
						this.mySelectedPeriodical = (Periodical)cboPeriodical.getItemAt(cboPeriodical.getSelectedIndex()); 
				}
				
				Father.hasChanged = true;
				this.miSave.setEnabled(true);
				btnSave1.setEnabled(Father.hasChanged);
				btnSave2.setEnabled(Father.hasChanged);	
			}
		}
		
	}
	
	private void populateComboboxes()
	{
		// Periodical
		cboPeriodicalPreselection = "";
		populateCboPeriodical();

		int mySelected_Index = -1;

		// Author_1
		cboAuthor_1.removeItemListener(this);
		cboAuthor1Model.removeAllElements();
		cboAuthor1Model.addElement("  (none) ");

		if (this.myLibref == null)
		{
			mySelected_Index = 0;
		}

		int i = 1; // The first element has been added yet

		Iterator<String> i4t = Father.LibrefAuthorSet.iterator();
		while (i4t.hasNext())
		{
			String DisplayObj = i4t.next();
			cboAuthor1Model.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null 
					&& this.myLibref.getAuthor_1().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}

		cboAuthor1Model.addElement("-------------------");
		i++;

		Iterator<String> i5t = Father.LibrefOtherAuthorsSet.iterator();
		while (i5t.hasNext())
		{
			String DisplayObj = i5t.next();
			cboAuthor1Model.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null 
					&& this.myLibref.getAuthor_1().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}
		
		if (mySelected_Index >-1)
			cboAuthor_1.setSelectedIndex(mySelected_Index);
		
		cboAuthor_1.addItemListener(this);
		
		// Author_2
		cboAuthor_2.removeItemListener(this);
		cboAuthor2Model.removeAllElements();
		cboAuthor2Model.addElement("  (none) ");
		mySelected_Index = -1;

		if (this.myLibref == null || this.myLibref.getAuthor_2().length()==0)
		{
			mySelected_Index = 0;
		}

		i = 1; // The first element has been added yet

		Iterator<String> it1 = Father.LibrefAuthorSet.iterator();
		while (it1.hasNext())
		{
			String DisplayObj = it1.next();
			cboAuthor2Model.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null 
					&& this.myLibref.getAuthor_2().length() > 0
					&& this.myLibref.getAuthor_2().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}

		cboAuthor2Model.addElement("-------------------");
		i++;

		Iterator<String> it2 = Father.LibrefOtherAuthorsSet.iterator();
		while (it2.hasNext())
		{
			String DisplayObj = it2.next();
			cboAuthor2Model.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null 
					&& this.myLibref.getAuthor_2().length() > 0
					&& this.myLibref.getAuthor_2().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}
		
		if (mySelected_Index > -1)
			cboAuthor_2.setSelectedIndex(mySelected_Index);
		
		cboAuthor_2.addItemListener(this);	

		// Author_3
		cboAuthor_3.removeItemListener(this);
		cboAuthor3Model.removeAllElements();
		cboAuthor3Model.addElement("  (none) ");
		mySelected_Index = -1;

		if (this.myLibref == null || this.myLibref.getAuthor_3().length()==0)
		{
			mySelected_Index = 0;
		}

		i = 1; // The first element has been added yet

		Iterator<String> it3 = Father.LibrefAuthorSet.iterator();
		while (it3.hasNext())
		{
			String DisplayObj = it3.next();
			cboAuthor3Model.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null 
					&& this.myLibref.getAuthor_3().length() > 0
					&& this.myLibref.getAuthor_3().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}

		cboAuthor3Model.addElement("-------------------");
		i++;

		Iterator<String> it4 = Father.LibrefOtherAuthorsSet.iterator();
		while (it4.hasNext())
		{
			String DisplayObj = it4.next();
			cboAuthor3Model.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null 
					&& this.myLibref.getAuthor_3().length() > 0
					&& this.myLibref.getAuthor_3().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}

		if (mySelected_Index > -1)
			cboAuthor_3.setSelectedIndex(mySelected_Index);

		cboAuthor_3.addItemListener(this);

		// Author_4
		cboAuthor_4.removeItemListener(this);
		cboAuthor4Model.removeAllElements();
		cboAuthor4Model.addElement("  (none) ");
		mySelected_Index = -1;

		if (this.myLibref == null || this.myLibref.getAuthor_4().length() == 0)
		{
			mySelected_Index = 0;
		}

		i = 1; // The first element has been added yet

		Iterator<String> it5 = Father.LibrefAuthorSet.iterator();
		while (it5.hasNext())
		{
			String DisplayObj = it5.next();
			cboAuthor4Model.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null && this.myLibref.getAuthor_4().length() > 0 && this.myLibref.getAuthor_4().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}

		cboAuthor4Model.addElement("-------------------");
		i++;

		Iterator<String> it6 = Father.LibrefOtherAuthorsSet.iterator();
		while (it6.hasNext())
		{
			String DisplayObj = it6.next();
			cboAuthor4Model.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null && this.myLibref.getAuthor_4().length() > 0 && this.myLibref.getAuthor_4().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}

		if (mySelected_Index > -1)
			cboAuthor_4.setSelectedIndex(mySelected_Index);

		cboAuthor_4.addItemListener(this);
		
		// Keyword_1
		cboKeyword_1.removeItemListener(this);
		cboKeyword1Model.removeAllElements();
		cboKeyword1Model.addElement("  (none) ");
		mySelected_Index = -1;

		if (this.myLibref == null || this.myLibref.getKeyword_1().length()==0)
		{
			mySelected_Index = 0;
		}

		i = 1; // The first element has been added yet

		Iterator<String> itk1 = Father.LibrefKeywordSet.iterator();
		while (itk1.hasNext())
		{
			String DisplayObj = itk1.next();
			cboKeyword1Model.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null 
					&& this.myLibref.getKeyword_1().length() > 0
					&& this.myLibref.getKeyword_1().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}

		if (mySelected_Index > -1)
			cboKeyword_1.setSelectedIndex(mySelected_Index);
		
		cboKeyword_1.addItemListener(this);	

		// Keyword_2
		cboKeyword_2.removeItemListener(this);
		cboKeyword2Model.removeAllElements();
		cboKeyword2Model.addElement("  (none) ");
		mySelected_Index = -1;

		if (this.myLibref == null || this.myLibref.getKeyword_2().length()==0)
		{
			mySelected_Index = 0;
		}

		i = 1; // The first element has been added yet

		Iterator<String> itk2 = Father.LibrefKeywordSet.iterator();
		while (itk2.hasNext())
		{
			String DisplayObj = itk2.next();
			cboKeyword2Model.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null 
					&& this.myLibref.getKeyword_2().length() > 0
					&& this.myLibref.getKeyword_2().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}

		if (mySelected_Index > -1)
			cboKeyword_2.setSelectedIndex(mySelected_Index);
		
		cboKeyword_2.addItemListener(this);	
		
		// Keyword_3
		cboKeyword_3.removeItemListener(this);
		cboKeyword3Model.removeAllElements();
		cboKeyword3Model.addElement("  (none) ");
		mySelected_Index = -1;

		if (this.myLibref == null || this.myLibref.getKeyword_3().length()==0)
		{
			mySelected_Index = 0;
		}

		i = 1; // The first element has been added yet

		Iterator<String> itk3 = Father.LibrefKeywordSet.iterator();
		while (itk3.hasNext())
		{
			String DisplayObj = itk3.next();
			cboKeyword3Model.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null 
					&& this.myLibref.getKeyword_3().length() > 0
					&& this.myLibref.getKeyword_3().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}

		if (mySelected_Index > -1)
			cboKeyword_3.setSelectedIndex(mySelected_Index);
		
		cboKeyword_3.addItemListener(this);	
		
		// Type
		cboType.removeItemListener(this);
		cboTypeModel.removeAllElements();
		cboTypeModel.addElement("  (none) ");
		mySelected_Index = -1;

		if (this.myLibref == null || this.myLibref.getType().length()==0)
		{
			mySelected_Index = 0;
		}

		i = 1; // The first element has been added yet

		Iterator<String> itt = Father.LibrefTypeSet.iterator();
		while (itt.hasNext())
		{
			String DisplayObj = itt.next();
			cboTypeModel.addElement(DisplayObj);

			if (mySelected_Index == -1 && this.myLibref != null 
					&& this.myLibref.getType().length() > 0
					&& this.myLibref.getType().equals(DisplayObj))
			{
				mySelected_Index = i;
			}

			i++;
		}

		if (mySelected_Index > -1)
			cboType.setSelectedIndex(mySelected_Index);
		
		cboType.addItemListener(this);	
		
	}

	private void populateCboPeriodical()
	{
		Set<String> keys = Father.PeriodicalTree.keySet();
		
		// to avoid "has changed" unnesssary we remove the listener
		if (cboPeriodicalPreselection.trim().length() == 0)
			cboPeriodical.removeItemListener(this);
		
		cboPeriodicalModel.removeAllElements();
		
		int	mySelectedPeriodical_Index = 0; 
		
		cboPeriodicalModel.addElement("  (none) ");
	
		if (this.mySelectedPeriodical == null)
		{
			mySelectedPeriodical_Index = 0;
		}
		
		int i = 1;
				
		for (String s : keys)
		{
			Periodical listper = Father.PeriodicalTree.get(s);
			if (listper.getName().toLowerCase().startsWith(cboPeriodicalPreselection.toLowerCase()))
			   cboPeriodicalModel.addElement( listper);
			
			if (this.mySelectedPeriodical != null && this.mySelectedPeriodical.equals(listper))
			{
				mySelectedPeriodical_Index = i;
			}
			
			i++;
		}
		
		//set the selected value
		
		if (cboPeriodicalPreselection.trim().length() == 0)
		{
			cboPeriodical.setSelectedIndex(mySelectedPeriodical_Index);
			cboPeriodical.addItemListener(this);
		}
		else
		{
			if (cboPeriodicalModel.getSize() > 1 && cboPeriodicalPreselection.trim().length() > 0)
				cboPeriodical.setSelectedIndex(1);
			else if (cboPeriodicalModel.getSize() < 2 && cboPeriodicalPreselection.trim().length() > 0)
			{
				cboPeriodicalPreselection = "";
				populateCboPeriodical();
			}
		}
	}

	@Override
	public void componentHidden(ComponentEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	@Override
	public void componentMoved(ComponentEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	@Override
	public void componentResized(ComponentEvent arg0)
	{
		int i = 0;
		
		if (this.getWidth() >805)
		{
			i= this.getWidth() - 805;
			// resize fields
			cboAuthor_2.setBounds(480, 10, 300+i, 25);
			cboAuthor_4.setBounds(500, 38, 280+i, 25);
			tfEditorial.setBounds(675, 66, 105+i, 25);
			tfTitle.setBounds(50, 94, 730+i, 25);
			tfIn_Book_title.setBounds(105, 122, 675+i, 25);
			tfBibliographic_data.setBounds(310, 206, 470+i, 25);
			cboKeyword_1.setBounds(490, 234, 290+i, 25);
			cboKeyword_3.setBounds(490, 262, 290+i, 25);
			tfRemarks.setBounds(85, 318, 695+i, 25);
			cboPeriodical.setBounds(85, 150, 695+i, 25);		
		}	
		
		

		if (this.getWidth() >869)
		{	
			btnSave1.setBounds(785, 290, 60, 25);
			btnSave1.setVisible(true);
			btnSave2.setBounds(785, 5, 60, 25);
			btnSave2.setVisible(true);
			//btninvisible.setBounds(845, 5, 5, 25);
		}
	}

	@Override
	public void componentShown(ComponentEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	private void execMaxCatalogNo()
	{
		if (Father.LibrefTree.size() == 0)
		{
			JOptionPane.showMessageDialog(null, "Sorry, without existing literature references there can not be catalogue numbers!", "No search result",
					JOptionPane.INFORMATION_MESSAGE);
			return;
		}
		else
		{

			String strMaxCat = " ";

			Set<String> keys = Father.LibrefTree.keySet();

			for (String s : keys)
			{
				Libref qlib = Father.LibrefTree.get(s);

				if (qlib.getCatalogue_Number() != null && qlib.getCatalogue_Number().length() > 0
						&& qlib.getCatalogue_Number().compareToIgnoreCase(strMaxCat) > 0)
					strMaxCat = qlib.getCatalogue_Number();
			}

			JOptionPane.showMessageDialog(null, "Actually the highest catalogue number is:  " + strMaxCat+"  ", "Highest catalogue number",
					JOptionPane.INFORMATION_MESSAGE);
			return;

		}
	}
	
	private void clickEditPeriodical()
	{
		if (!saveEntry())
			return;
		if (this.myLibref == null)
		{
			PeriodicalDialog dlg = new PeriodicalDialog(null, this.Father, this.Periodical_MayLibTable, this.Libref_MayLibTable, this.myLibrefSplitPane);
			dlg.showDialog(this);
		}
		else
		{
			PeriodicalDialog dlg = new PeriodicalDialog(this.myLibref.getPeriodical(), this.Father, this.Periodical_MayLibTable, this.Libref_MayLibTable,
					this.myLibrefSplitPane);
			dlg.showDialog(this);
		}
	}
	
	protected void execSizeDispose()
	{
		Father.LibrefDialog_X = this.getX();
		Father.LibrefDialog_Y = this.getY();
		Father.LibrefDialog_Width = this.getWidth();
		Father.LibrefDialog_Height = this.getHeight();
		this.dispose();
	}
}
