package MayLib;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Insets;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.image.BufferedImage;
//import java.util.ArrayList;
//import java.util.Collections;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
//import javax.swing.JCheckBoxMenuItem;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;

public class LibrefSplitPane extends AbstractDialog implements ActionListener, TreeSelectionListener, WindowListener, KeyListener
{
	private static final long serialVersionUID = 1L;
	private JSplitPane splitPane;
	private MyJTree				tree;
	private DefaultTreeModel treeModel;
	private DefaultMutableTreeNode root;
	private JPanel rightPanel;
	private Font Plainfont, Boldfont; 
	private JLabel lblTitel;
	private JTextArea txarAbstract;
	private JScrollPane txarAbstractScrollPane;
	

	private JMenuBar	       menuBar;
	private JMenu	           menuFile, menuTree, menuEdit, submenuSaveAs;
	private JMenuItem	       miNew, miEditRef, miDelete, miClose, miSave, miSaveAsOther, miSaveAsUCF, miSaveAsUnknown, miQuit;
	private JMenu	           menuSearch;
	private JMenuItem			miSearchAbstract; 

	//Menue Report
	private JMenu	              menuReport, submenuAbstract, submenuReportType;
	private JMenuItem             miReportAllLibrefs, miReportAllPeriodicals, miReportSelObjects;
	private JRadioButtonMenuItem  miWithoutAbstract, mi1000Abstract, miFullAbstract, miBasicReport, miCompleteReport;
	private JRadioButtonMenuItem  mi2000Abstract, mi4000Abstract;
	private ButtonGroup		      bgAbstract, bgReportType;
	//Addition to menue Report
	private JMenu	              submenuRepCharacterset;
	private JRadioButtonMenuItem  miRepUnicode, miRepDefault, miRepUnknown;
	private ButtonGroup		      bgRepCharacterset;
	//Addition to menue Report
	private JRadioButtonMenuItem  miGermanStandardReport, miPalaeontologyReport, miBullGeosciencesPragueReport;
	
	//save search
	private JMenu	         submenuSaveSearch;
	private JMenuItem        miSaveSearchOther, miSaveSearchUCF, miSaveSearchUnknown, miSaveSearchCSV;
		
	private JMenuItem	miReduzieren, miErweitern, miRefresh;
	
	private MayLib_Start Father;
	private String Mode;
	private boolean isLoading; 
	
	private JPanel		pnlBottom;
	private JButton	    btnRefresh, btnEdit, btnDelete, btnNewLibref, btnQuitApp, btnClose, btninvisible;
	
	private DefaultMutableTreeNode node;

	private boolean suppressWindowActivated = true;
		
	public LibrefSplitPane(MayLib_Start Father, String Mode)
	{
		this.Father = Father;
		this.Plainfont = this.Father.Plainfont;
		this.Boldfont = this.Father.Boldfont;
		this.setFont(Plainfont);
		this.Mode = Mode;
		this.isLoading = false;
		initializeComponents();
	}


	private void setmyFontChild()
	{	
	
		this.getJMenuBar().setFont(Boldfont);	
		
		txarAbstract.setFont(Plainfont);
		
		for (int i = 0; i < menuBar.getMenuCount(); i++)
		{
			menuBar.getMenu(i).setFont(Boldfont);
			setFontMenuItems(menuBar.getMenu(i));
		}
		
		setFontComponents(this.getContentPane());
		setFontComponents(pnlBottom);
	}
	
	private void setFontMenuItems(JMenu m)
	{
		for (Component c : m.getMenuComponents())
		{
			// Der Separator hat keinen Text und keine Elemente
			if (c instanceof JMenuItem)
			{
				((JMenuItem)c).setFont(Boldfont);
				if (((JMenuItem) c).getSubElements().length > 0)
					setFontMenuItems((JMenu) c);
			}
		}
	}

	private void setFontComponents(Container container)
	{
		for (Component c : container.getComponents())
		{
			if (c instanceof JLabel)
				((JLabel) c).setFont(Boldfont);
			else if (c instanceof JTextField)
				((JTextField) c).setFont(Plainfont);
			else if (c instanceof JComboBox)
				((JComboBox) c).setFont(Plainfont);
			else if (c instanceof JTextArea)
				((JTextArea) c).setFont(Plainfont);
			else if (c instanceof JButton)
				((JButton) c).setFont(Boldfont);
			else if (c instanceof JPanel)
			{
				// Prfen, ob das Panel einen TitledBorder hat, dessen Text
				// dann ebenfalls bersetzt werden muss.
				Border b = ((JPanel) c).getBorder();
				if (b instanceof TitledBorder)
					((TitledBorder) b).setTitleFont(Plainfont);

				// Ein Panel ist ein Container und enthlt in aller Regel
				// Komponenten
				setFontComponents((JPanel) c);
			}

		}
	}

	
	@Override
	public void initializeComponents()
	{
		Font font;

		this.setTitle("MayLib - Tree of: "+Father.LibrefQueryCriteria);
		// Nur in Verbindung mit pack()
		//this.setPreferredSize(new Dimension(800, 600));
		this.setBounds(10, 10, 800, 480);
		this.setModalityType(DEFAULT_MODALITY_TYPE);
		this.setDefaultCloseOperation(AbstractDialog.DISPOSE_ON_CLOSE);
		this.addWindowListener(this);
		
		splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
		this.add(splitPane);
		splitPane.setBackground(Father.BackGroundColor);

		createMenu();

		// Die Daten eines Baums sitzen in einem Modell, das die Schnittstelle
		// TreeModel implementiert.
		// Das Modell ist sehr einfach und muss lediglich die Aussage treffen, ob
		// das Element ein Blatt oder eine Wurzel darstellt und wo ein Element in 
		// der Baumverstelung liegt.

		// Fr einfache Bume ist es nicht ntig, sich mit dem TreeModel
		// auseinanderzusetzen, da Swing eine
		// andere Mglichkeit bietet, die Verstelung darzustellen.
		// Dazu gibt es fr Knoten eine Schnittstelle TreeNode, die einen Eintrag
		// im Baum reprsentiert.
		// Die konkrete Klasse DefaultMutableTreeNode stellt einen
		// Standardbaumknoten dar, der universell eingesetzt
		// werden kann; er ist eine Implementierung der Schnittstelle
		// MutableTreeNode, die wiederum TreeNode erweitert.
		// Mit der add()-Methode vom DefaultMutableTreeNode kann eine Baumstruktur
		// geschaffen werden.

		root = new DefaultMutableTreeNode("Literature");

		//font = new Font("Tahoma", Font.PLAIN, 12);
		font = Plainfont;

		treeModel = new DefaultTreeModel(root);
		tree = new MyJTree(treeModel);
		tree.setFont(font);
		tree.addTreeSelectionListener(this);
		JScrollPane treeScrollPane = new JScrollPane(tree);
		splitPane.setLeftComponent(treeScrollPane);

		rightPanel = new JPanel(new BorderLayout());
		rightPanel.setBackground(Color.WHITE);
		splitPane.setRightComponent(rightPanel);

		lblTitel = new JLabel("Information");
		lblTitel.setBorder(BorderFactory.createLineBorder(Color.darkGray));
		lblTitel.setOpaque(true);
		lblTitel.setBackground(Color.GRAY);
		lblTitel.setForeground(Color.WHITE);
		lblTitel.setHorizontalAlignment(JLabel.CENTER);
		lblTitel.setPreferredSize(new Dimension(300, 40));

		font = new Font("Tahoma", Font.BOLD, 16);
		lblTitel.setFont(font);
		rightPanel.add(lblTitel, BorderLayout.PAGE_START);
		rightPanel.setBackground(Father.BackGroundColor);

		// Bank Info Panel

		//font = new Font("Tahoma", Font.PLAIN, 12);
		
		font = Plainfont;
		
		
		// Textarea

		txarAbstract = new JTextArea();
		txarAbstractScrollPane = new JScrollPane(txarAbstract);
		txarAbstractScrollPane.setPreferredSize(new Dimension(775, 85));
		// Vertikale Laufleiste immer sichtbar
		txarAbstractScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		// Automatischer Zeilenumbruch
		txarAbstract.setLineWrap(true);

		// Automatischer Umbruch auf Wortgrenze
		// wenn autom. Zeilenumbruch gesetzt wurde.
		txarAbstract.setWrapStyleWord(true);

		// Freien Bereich zwischen Rahmen und dem Text definieren.
		txarAbstract.setMargin(new Insets(2, 2, 2, 2));
		txarAbstract.setEditable(false);
		txarAbstract.setName("Abstract");

		rightPanel.add(txarAbstractScrollPane, BorderLayout.CENTER);

		// Absolute Position des Trenners
		// splitPane.setDividerLocation(400);

		// Breite des Trenners (SpplitBar) setzen
		splitPane.setDividerSize(3);

		// Verteilung der Bereiche der SplitPane nach Gewichtung
		splitPane.setResizeWeight(0.4);

		// Permanentes Anpassen der Komponenten innerhalb der SplitPane
		splitPane.setContinuousLayout(true);
		
		// For Buttons at the bottom
		// Panel Bottom
		pnlBottom = new JPanel(null);
		pnlBottom.setPreferredSize(new Dimension(590, 35));
		rightPanel.add(pnlBottom, BorderLayout.PAGE_END);
		pnlBottom.setLayout(new BorderLayout());

		// Buttons
		
		btnRefresh = new JButton("Refresh");
		btnRefresh.setBounds(5, 5, 70, 25);
		btnRefresh.setMargin(new Insets(2, 2, 2, 2));
		btnRefresh.setName("Refresh");
		btnRefresh.addActionListener(this);
		btnRefresh.addKeyListener(this);
		pnlBottom.add(btnRefresh);

		btnClose = new JButton("Close");
		btnClose.setBounds(76, 5, 4, 25);
		btnClose.setMargin(new Insets(2, 2, 2, 2));
		btnClose.setName("Close");
		btnClose.addActionListener(this);
		btnClose.addKeyListener(this);
		btnClose.setVisible(false);
		pnlBottom.add(btnClose);

		btnEdit = new JButton("Edit");
		btnEdit.setBounds(85, 5, 70, 25);
		btnEdit.setMargin(new Insets(2, 2, 2, 2));
		btnEdit.setName("Edit");
		btnEdit.addActionListener(this);
		btnEdit.addKeyListener(this);
		pnlBottom.add(btnEdit);

		btnDelete = new JButton("Delete");
		btnDelete.setName("Delete");
		btnDelete.setBounds(165, 5, 70, 25);
		btnDelete.setMargin(new Insets(2, 2, 2, 2));
		btnDelete.addActionListener(this);
		btnDelete.addKeyListener(this);
		pnlBottom.add(btnDelete);

		btnNewLibref = new JButton("New Literature");
		btnNewLibref.setBounds(245, 5, 120, 25);
		btnNewLibref.setMargin(new Insets(2, 2, 2, 2));
		btnNewLibref.setName("New Literature");
		btnNewLibref.addKeyListener(this);
		btnNewLibref.addActionListener(this);
		pnlBottom.add(btnNewLibref);

		btnQuitApp = new JButton("Quit application");
		btnQuitApp.setName("Quit");
		btnQuitApp.setBounds(375, 5, 120, 25);
		btnQuitApp.setMargin(new Insets(2, 2, 2, 2));
		btnQuitApp.addActionListener(this);
		btnQuitApp.addKeyListener(this);
		pnlBottom.add(btnQuitApp);

		btninvisible = new JButton("invisible");
		btninvisible.setBounds(495, 5, 5, 25);
		btninvisible.setVisible(false);
		pnlBottom.add(btninvisible);

	}

	private void createMenu()
	{
		menuBar = new JMenuBar();
		this.setJMenuBar(menuBar);
		
		menuFile = this.createMenu(menuBar, "File", "menuFile", 'F');
		miSave = this.createMenuItem(menuFile, "miSave", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Save opened MayLib file (*.ucf)", null, 'S', "Saves the opened MayLib as MayLib file (*.ucf) under the same name");
		submenuSaveAs = this.createSubMenue(menuFile, "Save opened MayLib as...", "submenuSaveAs", 'a');
		miSaveAsUCF = this.createMenuItem(submenuSaveAs, "miSaveAsUCF", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "MayLib file (*.ucf)", null, 'b', "Saves the opened MayLib as MayLib file (*.ucf) under another name");
		miSaveAsOther = this.createMenuItem(submenuSaveAs, "miSaveAsOther", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "System default character set", null, 'y', "Saves the opened MayLib as a file with the system default character set under another name");
		miSaveAsUnknown = this.createMenuItem(submenuSaveAs, "miSaveAsUnknown", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Unknown character set", null, 0, "Saves the opened MayLib as a file with the character set for opened files with an unknown character set");

		// save search
		menuFile.addSeparator();
		submenuSaveSearch = this.createSubMenue(menuFile, "Save searched literature in...", "submenuSaveSearch", 'e');
		miSaveSearchUCF = this.createMenuItem(submenuSaveSearch, "miSaveSearchUCF", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "MayLib file (*.ucf)", null, 0,
						"Saves the searched literature as MayLib file (*.ucf) under another name. NOTE: Periodicals without Literature references will not be included!");
		miSaveSearchOther = this.createMenuItem(submenuSaveSearch, "miSaveSearchOther",
						AbstractDialog.MenuItemType.ITEM_PLAIN,
						this, "System default character set",
						null, 0,
						"Saves the searched literature as a MayLib-like file with the system default character set under another name. NOTE: Periodicals without Literature references will not be included!");
		miSaveSearchUnknown = this.createMenuItem(submenuSaveSearch,	"miSaveSearchUnknown",
						AbstractDialog.MenuItemType.ITEM_PLAIN,
						this, "Unknown character set",
						null, 0,
						"Saves the searched literature as a  MayLib-like file with the character set for opened files with an unknown character set. NOTE: Periodicals without Literature references will not be included!");
		miSaveSearchCSV = this.createMenuItem(submenuSaveSearch, "miSaveSearchCSV", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "CSV file (can be read by Excel)", null, 0,
						"Saves the searched literature as a CSV file which can be read by Excel. NOTE: Periodicals without Literature references will not be included!");
		
		menuFile.addSeparator();	
		miClose = this.createMenuItem(menuFile, null, AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Close", null, 'C', "Closes this window");	
		miQuit = this.createMenuItem(menuFile, "miQuit", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Quit application", null, 'Q', "Quits the program/application and closes all windows");
		
		menuTree = this.createMenu(menuBar, "Tree", "menuTree", 'T');
		miErweitern = this.createMenuItem(menuTree, "miErweitern", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Expand all nodes", null, 'E', "Expand all nodes");
		miReduzieren = this.createMenuItem(menuTree, "miReduzieren", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Reduce all nodes", null, 'R', "Reduce all nodes");
		miRefresh = this.createMenuItem(menuTree, "miRefresh", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Refresh tree", null, 'f', "Refreshes the whole tree reading the actual data");

		menuEdit = this.createMenu(menuBar, "Edit", null, 'E');
		miNew = this.createMenuItem(menuEdit, "miNew", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "New", null, 'N', "Opens window to create a new reference");
		miEditRef = this.createMenuItem(menuEdit, "miEditRef", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Edit reference", null, 'r', "Opens window to edit the selected reference");
		miDelete = this.createMenuItem(menuEdit, "miDelete", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Delete", null, 'D', "Deletes the selected reference");	
	
		menuSearch = this.createMenu(menuBar, "Search", "menuSearch", 'h');
		miSearchAbstract = this.createMenuItem(menuSearch, "miSearchAbstract", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Search abstract", null, 'a', "Searches the abstract for a word or a part of a word/phrase");
	
		menuReport = this.createMenu(menuBar, "Report", "menuReport", 'R');
		miReportAllLibrefs = this.createMenuItem(menuReport, "miReportAllLibrefs", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Report all literature", null, 'l', "Creates a report of all literature references");
		miReportAllPeriodicals = this.createMenuItem(menuReport, "miReportAllPeriodicals", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Report all periodicals", null, 'p', "Creates a report of all periodicals");
		miReportSelObjects = this.createMenuItem(menuReport, "miReportSelObjects", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Report listed objects", null, 'o', "Creates a report of ALL literature references listed in this tree");
		menuReport.addSeparator();
		submenuAbstract = this.createSubMenue(menuReport, "Include Abstract?",  "submenuAbstract", 'i');
		miWithoutAbstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "miWithoutAbstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Without abstract", null, 'W', "The resulting report does not contain any abstract");
		mi1000Abstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "mi1000Abstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "1000 characters", null, '1', "The resulting report contains the first 1000 characters of the abstract, if it is a literature references report");
		mi2000Abstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "mi2000Abstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "2000 characters", null, '2', "The resulting report contains the first 2000 characters of the abstract, if it is a literature references report");
		mi4000Abstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "mi4000Abstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "4000 characters", null, '4', "The resulting report contains the first 4000 characters of the abstract, if it is a literature references report");
		miFullAbstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "miFullAbstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Full abstract", null, 'F', "The resulting report contains the full abstract, if it is a literature references report");
		submenuReportType = this.createSubMenue(menuReport, "Type of Report",  "submenuReportType", 'T');
		miBasicReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miBasicReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Basic report", null, 'B', "A short report with the most relevant information");
		miCompleteReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miCompleteReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Complete report", null, 'C', "A complete report with all information");
		bgAbstract = new ButtonGroup();
		bgAbstract.add(miWithoutAbstract);
		bgAbstract.add(mi1000Abstract);
		bgAbstract.add(mi2000Abstract);
		bgAbstract.add(mi4000Abstract);
		bgAbstract.add(miFullAbstract);
		bgReportType = new ButtonGroup();
		bgReportType.add(miBasicReport);
		bgReportType.add(miCompleteReport);
		//Addition to menue Report
		miGermanStandardReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miGermanStandardReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "German Standard report", null, 'G', "Detailed literature reference in German style");
		miPalaeontologyReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miPalaeontologyReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Palaeontology report", null, 'P', "Literature reference in 'Palaeontology (London)' style");
		miBullGeosciencesPragueReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miBullGeosciencesPragueReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Bulletin Geosciences Prague report", null, 'u', "Literature reference in 'Bulletin of Geosciences (Prague)' style");
		bgReportType.add(miBullGeosciencesPragueReport);
		bgReportType.add(miGermanStandardReport);
		bgReportType.add(miPalaeontologyReport);
		//Addition to menue Report
		submenuRepCharacterset = this.createSubMenue(menuReport, "Characterset of the report",  "submenuRepCharacterset", 'h');
		miRepUnicode = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepUnicode", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Unicode (*.RPU)", null, 'U', "The resulting report will be written with Unicode character set. The default file extension is *.RPU");
		miRepDefault = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepDefault", AbstractDialog.MenuItemType.ITEM_RADIO, this, "System default character set (*.RPT)", null, 'y', "The resulting report will be written with the default system character set. The default file extension is *.RPT");
		miRepUnknown = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepUnknown", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Unknown character set (*.RPT)", null, 0, "The resulting report will be written with the character set used by the last file imported with UNKNOWN character set. The default file extension is *.RPT");
		bgRepCharacterset = new ButtonGroup();
		bgRepCharacterset.add(miRepUnicode);
		bgRepCharacterset.add(miRepDefault);
		bgRepCharacterset.add(miRepUnknown);	
	}	

	private class MyJTree extends JTree
	{
		/**
		 * Um eine Performance-Steigerung beim Aufklappen eines JTrees zu
		 * erreichen, mu eine neue Klasse angelegt werden, die JTree erweitert,
		 * d.h. von ihr erbt. Deshalb wird in dem Beispiel die Klasse MyJTree
		 * erstellt. Das wichtigste an der Klasse ist die Methode public
		 * Enumeration getExpandedDescendants(final TreePath parent). Dabei
		 * handelt es sich um eine Methode des JTree, welche aufgerufen wird, wenn
		 * der Baum aufgeklappt wird. Diese Methode tut meines Wissens nichts, was
		 * im Normalfall bentigt wird. Allerdings bentigt sie eine Menge
		 * Rechenzeit und beansprucht Speicherplatz, wenn der Baum aufgeklappt
		 * werden soll. Deshalb wurde sie berschreiben und liefert einfach den
		 * Wert null zurck.
		 * 
		 */
		public MyJTree(DefaultTreeModel treeModel)
		{
			super(treeModel);
		}

		public DefaultMutableTreeNode findChildNode(DefaultMutableTreeNode root, String suchBegriff)
		{
			for (int i = 0; i < root.getChildCount(); i++)
			{
				TreeNode child = root.getChildAt(i);
				if (child.toString().equals(suchBegriff)) return (DefaultMutableTreeNode) child;
			}

			return null;

		}

		public void expandAll()
		{
			int row = 1;

			while (row < tree.getRowCount())
			{
				tree.expandRow(row++);
			}

		}

		public void collapseAll()
		{
			int row = 1;

			while (row < tree.getRowCount())
			{
				tree.collapseRow(row++);
			}
		}

		@Override
		public Enumeration getExpandedDescendants(final TreePath parent)
		{
			return null;
		}

	}

	@Override
	public void initDialog()
	{
		this.getContentPane().setBackground(Father.BackGroundColor);
		this.pnlBottom.setBackground(Father.BackGroundColor);
		this.rightPanel.setBackground(Father.BackGroundColor);
		this.setBackground(Father.BackGroundColor);
		
		// Windowsize
		if (Father.LibrefSplitPane_Width > 0 && Father.LibrefSplitPane_Height > 0)
			this.setBounds(Father.LibrefSplitPane_X, Father.LibrefSplitPane_Y, Father.LibrefSplitPane_Width, Father.LibrefSplitPane_Height);
		else
		{
			if (Father.MaximizeWindow.equalsIgnoreCase("big") || Father.MaximizeWindow.equalsIgnoreCase("all"))
			{
				makeFrameFullSize();
			}
		}
		
		if (this.getWidth() > 869)
		{
			btnClose.setBounds(505, 5, 60, 25);
			btnClose.setVisible(true);
			btninvisible.setBounds(565, 5, 5, 25);
		}

		setmyFontChild();

		miSave.setEnabled(Father.hasChanged);
		
		// activate /deactivate Report Menu
		menuReport.setEnabled(true);
		submenuAbstract.setEnabled(true);
		submenuReportType.setEnabled(true);
		miReportAllLibrefs.setEnabled(true);
		miReportAllPeriodicals.setEnabled(true);
		miReportSelObjects.setEnabled(true);
		miWithoutAbstract.setEnabled(true);
		mi1000Abstract.setEnabled(true);
		mi2000Abstract.setEnabled(true);
		mi4000Abstract.setEnabled(true);
		miFullAbstract.setEnabled(true);
		miBasicReport.setEnabled(true);
		miCompleteReport.setEnabled(true);
		miGermanStandardReport.setEnabled(true);
		miPalaeontologyReport.setEnabled(true);
		miBullGeosciencesPragueReport.setEnabled(true);
		
		miWithoutAbstract.setSelected(true);
		miBasicReport.setSelected(true);
		//miRepUnicode.setSelected(true);
	
		// Defines charset of report
		if (Father.strexecRepCharset.equalsIgnoreCase("Default"))
		{
			this.miRepDefault.setSelected(true);
		}
		else if (Father.strexecRepCharset.equalsIgnoreCase("Unknown"))
		{
			this.miRepUnknown.setSelected(true);
		}
		else
		{
			this.miRepUnicode.setSelected(true);
		}

		
		btnRefresh.setEnabled(false); 
		miRefresh.setEnabled(false); 
		btnEdit.setEnabled(false); 
		btnDelete.setEnabled(false);
		miSearchAbstract.setEnabled(false); 
		////////////////////////////////////////////////////////
		
		// Eigene Symbole in der Baumansicht verwenden
		ImageIcon iconOpen, iconClosed, iconLeaf;
		
		// Originalgrsse (32 x 32)
//		iconOpen = new ImageIcon("images\\open.jpg");
//		iconClosed = new ImageIcon("images\\folder.jpg");
//		iconLeaf = new ImageIcon("images\\bullet.jpg");
		
		// Verkleinert (24 x 24)
		iconOpen = scaleIconToComponent(new ImageIcon("MayLib_images\\open.jpg"), new Dimension(24, 24));
		iconClosed = scaleIconToComponent(new ImageIcon("MayLib_images\\folder.jpg"), new Dimension(24, 24));
		iconLeaf = scaleIconToComponent(new ImageIcon("MayLib_images\\bullet.jpg"), new Dimension(24, 24));
		
		DefaultTreeCellRenderer renderer = (DefaultTreeCellRenderer)tree.getCellRenderer();
		renderer.setClosedIcon(iconClosed);  // Icon fr zugeklappten Knoten
		renderer.setOpenIcon(iconOpen);      // Icon fr aufgeklappten Knoten
		renderer.setLeafIcon(iconLeaf);      // Icon fr ein Blatt

		tree.requestFocus();
		txarAbstract.setVisible(false);

		//create tree
		// First Mode: Tree model shows Authors and Periodical-Name.
		if (Mode.equalsIgnoreCase("Libref"))
			ReadIntoLibrefTree();
		// Second Mode: Tree model shows Dictionary.
		else if (Mode.equalsIgnoreCase("Dictionary"))
		{
			// Nur so kann die Statusanzeige aktualisiert werden.
			Thread t = new Thread(new ReadIntoDictionaryTree(tree));
			t.start();
		}
		// Third Mode: Tree model shows Periodicals.
		if (Mode.equalsIgnoreCase("Periodical"))
			ReadIntoPeriodicalTree();
	}

	private ImageIcon scaleIconToComponent(ImageIcon ico, Dimension dim)
	{
		ImageIcon newIcon = null;
		int newWidth, newHeight;
		
		float factor = getFactor(ico.getIconWidth(), ico.getIconHeight(), dim);
		
		newWidth = (int)(ico.getIconWidth() * factor);
		newHeight = (int)(ico.getIconHeight() * factor); 
		
		// TYPE_INT_ARGB sorgt dafr, dass transparente Hintergrnde transparent bleiben.
		BufferedImage bi = new BufferedImage(newWidth, newHeight, BufferedImage.TYPE_INT_ARGB);
		
		Graphics2D g = bi.createGraphics();
		// Verbessert die Qualitt des scalierten Images.
      g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
      g.drawImage(ico.getImage(), 0, 0, newWidth, newHeight, null);
		g.dispose();
		
		newIcon = new ImageIcon(bi);
		
		return newIcon;
	}
	
	private float getFactor(int width, int height, Dimension dim)
	{
		float fx = dim.width / (float)width;
		float fy = dim.height / (float)height;
		
		return Math.min(fx,  fy);
		
	}
	
	

	private void selectedPath(TreePath path)
	{
		node = (DefaultMutableTreeNode) path.getLastPathComponent();

		// Name der Bank bzw. PLZ + Ort in PAGE_START aktualisieren
		// getLastPathComponent(): gibt das letzte Elemnt des Pfades zurck
		// lblTitel.setText(path.getLastPathComponent().toString());
		if (node.getLevel() == 0)
		{
			lblTitel.setText(path.getLastPathComponent().toString());
		}
		else if (node.getLevel() < 3 && node.getLevel() > 0)
		{
			lblTitel.setText(path.getParentPath().toString() + ": " + path.getLastPathComponent().toString());
		}
		else if (node.getLevel() == 3)
		{
			lblTitel.setText(path.getLastPathComponent().toString());
		}

		// Level 0 = Banken
		// Level 1 = Name der Bank
		// Level 2 = PLZ, Ort ...

		if (node.getLevel() < 3)
		{
			// Info Panel in CENTER unsichtbar machen
			txarAbstract.setVisible(false);
			btnEdit.setEnabled(false);
			btnDelete.setEnabled(false);
			miSearchAbstract.setEnabled(false);
		}

		if (node.getLevel() == 3 && node.getUserObject() instanceof Libref)
		{
			// Info Panel aufbereiten und anzeigen
			showBankInfo((Libref) node.getUserObject());
			btnEdit.setEnabled(true);
			btnDelete.setEnabled(true);
			miSearchAbstract.setEnabled(true);
		}

	}

	private void showBankInfo(Libref bank)
	{
		txarAbstract.setText(bank.showComplete());
		txarAbstract.setCaretPosition(0);
		txarAbstract.setVisible(true);
	}

	private void ReadIntoLibrefTree()
	{

		TreeMap<String, Object> treeMap1 = new TreeMap<String, Object>();
		TreeMap<String, TreeSet<Libref>> treeMap2 = new TreeMap<String, TreeSet<Libref>>();
		TreeSet<Libref> treeSet3 = new TreeSet<Libref>();
		MyJTree tree;

		// Root Objekt sichern
		Object userObject = root.getUserObject();

		// Anzeige in Root-Objekt
		root.setUserObject("References are read ...");
		treeModel.reload(root);

		Iterator<Libref> i2t = Father.QueriedLibrefSet.iterator();
		while (i2t.hasNext())

		{
			Libref DisplayObj = i2t.next();

			String key = DisplayObj.getAuthor_1();

			if (treeMap1.containsKey(key))
				treeMap2 = (TreeMap<String, TreeSet<Libref>>) treeMap1.get(key);
			else
				treeMap2 = new TreeMap<String, TreeSet<Libref>>();

			String key2 = DisplayObj.getYear();
			if (key2.length() > 4)
				key2 = DisplayObj.getYear().substring(0, 4);

			if (treeMap2.containsKey(key2))
				treeSet3 = treeMap2.get(key2);
			else
				treeSet3 = new TreeSet<Libref>();

			treeSet3.add(DisplayObj);
			treeMap2.put(key2, treeSet3);
			treeMap1.put(key, treeMap2);

			if ((DisplayObj.getAuthor_2().length() > 0) && (!DisplayObj.getAuthor_2().equals("et al.")))
			{
				key = DisplayObj.getAuthor_2();

				if (treeMap1.containsKey(key))
					treeMap2 = (TreeMap<String, TreeSet<Libref>>) treeMap1.get(key);
				else
					treeMap2 = new TreeMap<String, TreeSet<Libref>>();

				key2 = DisplayObj.getYear();
				if (key2.length() > 4)
					key2 = DisplayObj.getYear().substring(0, 4);

				if (treeMap2.containsKey(key2))
					treeSet3 = treeMap2.get(key2);
				else
					treeSet3 = new TreeSet<Libref>();

				treeSet3.add(DisplayObj);
				treeMap2.put(key2, treeSet3);
				treeMap1.put(key, treeMap2);
			}
			if ((DisplayObj.getAuthor_3().length() > 0) && (!DisplayObj.getAuthor_3().equals("et al.")))
			{
				key = DisplayObj.getAuthor_3();

				if (treeMap1.containsKey(key))
					treeMap2 = (TreeMap<String, TreeSet<Libref>>) treeMap1.get(key);
				else
					treeMap2 = new TreeMap<String, TreeSet<Libref>>();

				key2 = DisplayObj.getYear();
				if (key2.length() > 4)
					key2 = DisplayObj.getYear().substring(0, 4);

				if (treeMap2.containsKey(key2))
					treeSet3 = treeMap2.get(key2);
				else
					treeSet3 = new TreeSet<Libref>();

				treeSet3.add(DisplayObj);
				treeMap2.put(key2, treeSet3);
				treeMap1.put(key, treeMap2);
			}
		}

		Set<String> keys = treeMap1.keySet();

		for (String key : keys)
		{
			treeMap2 = (TreeMap<String, TreeSet<Libref>>) treeMap1.get(key);

			DefaultMutableTreeNode node1 = new DefaultMutableTreeNode(key);
			root.add(node1);

			Set<String> keys2 = treeMap2.keySet();

			for (String key2 : keys2)
			{
				treeSet3 = treeMap2.get(key2);

				DefaultMutableTreeNode node2 = new DefaultMutableTreeNode(key2);
				node1.add(node2);

				Iterator<Libref> it = treeSet3.iterator();

				while (it.hasNext())
				{
					Libref LibrefObj = it.next();
					node2.add(new DefaultMutableTreeNode(LibrefObj));
				}
			}
		}

		// we repeat the same for the periodical

		treeMap1.clear();
		treeMap2.clear();
		treeSet3.clear();

		Iterator<Libref> it_p = Father.QueriedLibrefSet.iterator();
		while (it_p.hasNext())
		{
			Libref DisplayObj = it_p.next();

			if (DisplayObj.getPeriodical() != null)
			{

				String key = DisplayObj.getPeriodical().toString();

				if (treeMap1.containsKey(key))
					treeMap2 = (TreeMap<String, TreeSet<Libref>>) treeMap1.get(key);
				else
					treeMap2 = new TreeMap<String, TreeSet<Libref>>();

				String key2 = DisplayObj.getYear();
				if (key2.length() > 4)
					key2 = DisplayObj.getYear().substring(0, 4);

				if (treeMap2.containsKey(key2))
					treeSet3 = treeMap2.get(key2);
				else
					treeSet3 = new TreeSet<Libref>();

				treeSet3.add(DisplayObj);
				treeMap2.put(key2, treeSet3);
				treeMap1.put(key, treeMap2);
			}
		}

		Set<String> k1eys = treeMap1.keySet();

		for (String key : k1eys)
		{
			treeMap2 = (TreeMap<String, TreeSet<Libref>>) treeMap1.get(key);

			DefaultMutableTreeNode node1 = new DefaultMutableTreeNode(key);
			root.add(node1);

			Set<String> keys2 = treeMap2.keySet();

			for (String key2 : keys2)
			{
				treeSet3 = treeMap2.get(key2);

				DefaultMutableTreeNode node2 = new DefaultMutableTreeNode(key2);
				node1.add(node2);

				Iterator<Libref> it = treeSet3.iterator();

				while (it.hasNext())
				{
					Libref LibrefObj = it.next();
					node2.add(new DefaultMutableTreeNode(LibrefObj));
				}
			}
		}

		// Wiederherstellen des gesicherten Root-Objektes
		root.setUserObject(userObject);
		treeModel.reload(root);
	}

	private class ReadIntoDictionaryTree implements Runnable
	{
		private TreeMap<String, Object> treeMap1 = new TreeMap<String, Object>();
		private TreeMap<String, TreeSet<Libref>> treeMap2 = new TreeMap<String, TreeSet<Libref>>();
		private TreeSet<Libref> treeSet3 = new TreeSet<Libref>();
		private MyJTree	tree;
		private String[] split;
		
		private ProgressWindow progressWindow;
		
		public ReadIntoDictionaryTree(MyJTree tree)
		{
			this.tree = tree;
			
		}

		@Override
		public void run()
		{
			LibrefSplitPane.this.isLoading = true;

		// Root Objekt sichern
		Object userObject = root.getUserObject();

		// Anzeige in Root-Objekt
		root.setUserObject("References are read ...");
		treeModel.reload(root);
		
		// Fortschrittsanzeige vorbereiten und sichtbar machen
					progressWindow = new ProgressWindow(LibrefSplitPane.this);
					progressWindow.setMaxValue(Father.QueriedLibrefSet.size());
					progressWindow.setValue(0);
							
					Thread pw = new Thread(progressWindow);
					pw.start();
					
					int k=0;

		Iterator<Libref> i2t = Father.QueriedLibrefSet.iterator();
		while (i2t.hasNext())

		{
			Libref DisplayObj = i2t.next();

			// We analyze Publication title, In-Book-Title and Abstract
			String[] StringForDict =
			{
					DisplayObj.getTitle().replace('.', ' ').replace(',', ' ').replace('?', ' ').replace('!', ' ').replace(';', ' ').replace('*', ' ')
							.replace('+', ' ').replace('"', ' ').replace('\'', ' ').replace('(', ' ').replace(')', ' ').replace('[', ' ')
							.replace(']', ' ').replace('=', ' '),
					DisplayObj.getIn_Book_title().replace('.', ' ').replace(',', ' ').replace('?', ' ').replace('!', ' ').replace(';', ' ').replace('*', ' ')
							.replace('+', ' ').replace('"', ' ').replace('\'', ' ').replace('(', ' ').replace(')', ' ').replace('[', ' ')
							.replace(']', ' ').replace('=', ' '),
					DisplayObj.getAbstract().replace('.', ' ').replace(',', ' ').replace('?', ' ').replace('!', ' ').replace(';', ' ').replace('*', ' ')
							.replace('+', ' ').replace('"', ' ').replace('\'', ' ').replace('(', ' ').replace(')', ' ').replace('[', ' ')
							.replace(']', ' ').replace('=', ' ') };

			for (int j = 0; j < 3; j++)
			{
				split = StringForDict[j].split(" ");

				for (int i = 0; i < split.length; i++)
				{

					if (split[i].trim().length() > 4 && Character.isLetter(split[i].trim().charAt(0)) && Character.isLetter(split[i].trim().charAt(1))
							&& Character.isLetter(split[i].trim().charAt(2)) && Character.isLetter(split[i].trim().charAt(3)))
					{
						String TreeString = split[i].trim().toLowerCase();
						String key = split[i].trim().substring(0, 2).toLowerCase();

						if (treeMap1.containsKey(key))
							treeMap2 = (TreeMap<String, TreeSet<Libref>>) treeMap1.get(key);
						else
							treeMap2 = new TreeMap<String, TreeSet<Libref>>();

						String key2 = TreeString;

						if (treeMap2.containsKey(key2))
							treeSet3 = treeMap2.get(key2);
						else
							treeSet3 = new TreeSet<Libref>();

						treeSet3.add(DisplayObj);
						treeMap2.put(key2, treeSet3);
						treeMap1.put(key, treeMap2);
					}
				}
			}
			
			progressWindow.setValue(progressWindow.getValue() + 1);
			k++;
			
			if (k % 10 == 0)
			    progressWindow.setMessage(String.format("Reading data ...  [%d] references", k));
			
			if (progressWindow.cancelRequest()) 
			{
				Toolkit.getDefaultToolkit().beep();
				Object[] options = { "Yes", "No"};
				if (JOptionPane.showOptionDialog(null, "Do you want to cancel the creation of the dictionary?", "Cancel creation of dictionary", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[1]) == 0)
					break;
				else
					progressWindow.setCancelRequest(false);
			}
		}

		Set<String> keys = treeMap1.keySet();

		for (String key : keys)
		{
			treeMap2 = (TreeMap<String, TreeSet<Libref>>) treeMap1.get(key);

			DefaultMutableTreeNode node1 = new DefaultMutableTreeNode(key);
			root.add(node1);

			Set<String> keys2 = treeMap2.keySet();

			for (String key2 : keys2)
			{
				treeSet3 = treeMap2.get(key2);

				DefaultMutableTreeNode node2 = new DefaultMutableTreeNode(key2);
				node1.add(node2);

				Iterator<Libref> it = treeSet3.iterator();

				while (it.hasNext())
				{
					Libref LibrefObj = it.next();
					node2.add(new DefaultMutableTreeNode(LibrefObj));
				}
			}
		}

		// Wiederherstellen des gesicherten Root-Objektes
		root.setUserObject(userObject);
		treeModel.reload(root);
		LibrefSplitPane.this.isLoading = false;
		
		// Fortschrittsanzeige schlieen
		progressWindow.close();
		}

	}


	private void ReadIntoPeriodicalTree()
	{

		TreeMap<String, Object> treeMap1 = new TreeMap<String, Object>();
		TreeMap<String, TreeSet<Libref>> treeMap2 = new TreeMap<String, TreeSet<Libref>>();
		TreeSet<Libref> treeSet3 = new TreeSet<Libref>();
		MyJTree tree;

		// Root Objekt sichern
		Object userObject = root.getUserObject();

		// Anzeige in Root-Objekt
		root.setUserObject("References are read ...");
		treeModel.reload(root);

		Iterator<Libref> it_p = Father.QueriedLibrefSet.iterator();
		while (it_p.hasNext())
		{
			Libref DisplayObj = it_p.next();

			if (DisplayObj.getPeriodical() != null)
			{

				String key = DisplayObj.getPeriodical().toString();

				if (treeMap1.containsKey(key))
					treeMap2 = (TreeMap<String, TreeSet<Libref>>) treeMap1.get(key);
				else
					treeMap2 = new TreeMap<String, TreeSet<Libref>>();

				String key2 = DisplayObj.getYear();
				if (key2.length() > 4)
					key2 = DisplayObj.getYear().substring(0, 4);
				
				key2 += " - " + DisplayObj.getVolume();
				
				if (treeMap2.containsKey(key2))
					treeSet3 = treeMap2.get(key2);
				else
					treeSet3 = new TreeSet<Libref>();

				treeSet3.add(DisplayObj);
				treeMap2.put(key2, treeSet3);
				treeMap1.put(key, treeMap2);
			}
		}

		Set<String> k1eys = treeMap1.keySet();

		for (String key : k1eys)
		{
			treeMap2 = (TreeMap<String, TreeSet<Libref>>) treeMap1.get(key);

			DefaultMutableTreeNode node1 = new DefaultMutableTreeNode(key);
			root.add(node1);

			Set<String> keys2 = treeMap2.keySet();

			for (String key2 : keys2)
			{
				treeSet3 = treeMap2.get(key2);

				DefaultMutableTreeNode node2 = new DefaultMutableTreeNode(key2);
				node1.add(node2);

				Iterator<Libref> it = treeSet3.iterator();

				while (it.hasNext())
				{
					Libref LibrefObj = it.next();
					node2.add(new DefaultMutableTreeNode(LibrefObj));
				}
			}
		}

		// Wiederherstellen des gesicherten Root-Objektes
		root.setUserObject(userObject);
		treeModel.reload(root);
	}


	@Override
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource().equals(btnRefresh))
		{	
			MayLib_Start Father = this.Father;
			String Mode = this.Mode; 
			
			this.execSizeDispose();
			
			LibrefSplitPane dlg = new LibrefSplitPane(Father, Mode);
			dlg.showDialog(Father);
		}
		
		else if (e.getSource().equals(btnDelete))
			deleteEntry();
		else if (e.getSource().equals(btnEdit))
			detailFormat("EDIT");
		else if (e.getSource().equals(btnNewLibref))
			detailFormat("NEW Libref");
		else if (e.getSource().equals(btnQuitApp))
			clickmiQuitApp();
		
		else if (e.getSource().equals(btnClose))
		{
			this.execSizeDispose();
		}

		else if (e.getSource().equals(miSearchAbstract))
		{
			MayLibSearch f = MayLibSearch.getInstance(txarAbstract,	Father);
			f.showDialog(this);
		}	
		
		else if (e.getSource().equals(miReduzieren))
			tree.collapseAll();
		else if (e.getSource().equals(miErweitern))
			tree.expandAll();
		else if (e.getSource().equals(miRefresh))
		{	
			MayLib_Start Father = this.Father;
			String Mode = this.Mode; 
			
			this.execSizeDispose();
			
			LibrefSplitPane dlg = new LibrefSplitPane(Father, Mode);
			dlg.showDialog(Father);
		}

		else if (e.getSource().equals(miClose))
			windowClosing(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));

		else if (e.getSource().equals(miQuit))
			clickmiQuitApp();
		
		else if (e.getSource().equals(miDelete))
		{
			deleteEntry();
		}
		
		else if (e.getSource().equals(miNew))
		{
			detailFormat("NEW Libref");
		}
		else if (e.getSource().equals(miEditRef))
		{
			detailFormat("EDIT");
		}
		else if (e.getSource().equals(miSave))	
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = Father.MayLibFile;
			
			if (Father.saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Changes in opened MayLib database saved (File: " + Father.lastWrittenFile +").", "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}

		else if (e.getSource().equals(miSaveAsUCF))	
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = null;
			
			if (Father.saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database saved sucessfully in the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}

		else if (e.getSource().equals(miSaveAsOther))	
		{
			String fileExtension = "TXT", Characterset = Father.Default_Charset;
			String Dateiname = null;
			
			if (Father.saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database exported sucessfully to the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveAsUnknown))	
		{
			String fileExtension = "TXT", Characterset = "UNKNOWN";
			String Dateiname = null;
			
			if (Father.saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database exported sucessfully to the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		

		else if (e.getSource().equals(miSaveSearchUCF))	
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			
			if (Father.saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Searched literature saved sucessfully in the MayLib file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}

		else if (e.getSource().equals(miSaveSearchOther))	
		{
			String fileExtension = "TXT", Characterset = Father.Default_Charset;
			
			if (Father.saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Searched literature exported sucessfully to the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveSearchUnknown))	
		{
			String fileExtension = "TXT", Characterset = "UNKNOWN";
			
			if (Father.saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Searched literature exported sucessfully to the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveSearchCSV))	
		{
			String fileExtension = "CSV", Characterset = Father.Default_Charset;
			
			if (Father.saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Searched literature exported sucessfully to the CSV file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
			
		// Reports
		else if (e.getSource().equals(miReportAllLibrefs)
				|| e.getSource().equals(miReportAllPeriodicals)
				|| e.getSource().equals(miReportSelObjects))	
		{
			/* Possible values of createReport(TreeSet<Object> ReportTreeSet, String ObjectType, String Headertext, String Abstract, String ReportType, String fileExtension, String Characterset)
			
			 * String ObjectType = Libref, Periodical
			 * String Headertext = null or a prepared text terminating without linefeed (linefeed will be added in the method createReport
			 * String Abstract  = without, 1000, full. Will be ignored, if ObjectType = Periodical
			 * String ReportType = basic, complete 
			 * String fileExtension = RPU, RPT
			 * String Characterset	= "UTF-16", Default_Charset, "UNKNOWN"	
		

			reportAllPeriodicals(String ReportType, String fileExtension, String Characterset)
			*/
			
			String Abstract ="without", ReportType = "basic", fileExtension ="RPT", Characterset =  Father.Default_Charset;
			
			if (miWithoutAbstract.isSelected())
				Abstract ="without";
			else if (mi1000Abstract.isSelected())
				Abstract ="1000";
			else if (mi2000Abstract.isSelected())
				Abstract ="2000";
			else if (mi4000Abstract.isSelected())
				Abstract ="4000";
			else if (miFullAbstract.isSelected())
				Abstract ="full";
				
			if (miBasicReport.isSelected())
				ReportType = "basic";
			else if (miCompleteReport.isSelected())
				ReportType = "complete";
			else if (miGermanStandardReport.isSelected())
				ReportType = "GermanStandard";
			else if (miPalaeontologyReport.isSelected())
				ReportType = "Palaeontology";
			else if (miBullGeosciencesPragueReport.isSelected())
				ReportType = "BullGeosciencesPrague";
			else 
				ReportType = "complete";
			
			if (miRepUnicode.isSelected())
			{
				fileExtension = "RPU";
				Characterset = "UTF-16";
				Father.execRepCharset("Unicode");
			}
			else if (miRepDefault.isSelected())
			{
				fileExtension ="RPT";
				Characterset =  Father.Default_Charset;
				Father.execRepCharset("Default");
			}
			else if (miRepUnknown.isSelected())
			{
				fileExtension ="RPT";
				Characterset =  "UNKNOWN";
				Father.execRepCharset("Unknown");
			}
	
			if (e.getSource().equals(miReportAllLibrefs))
				Father.reportAllLibrefs(Abstract, ReportType, fileExtension, Characterset);
			else if (e.getSource().equals(miReportAllPeriodicals))
				Father.reportAllPeriodicals(ReportType, fileExtension, Characterset);
			else 
			{	
				Father.reportSelLibrefs(Abstract, ReportType, fileExtension, Characterset);
			}			
		}
	}

	@Override
	public void valueChanged(TreeSelectionEvent e)
	{
		selectedPath(e.getPath());
	}

	@Override
	public void windowActivated(WindowEvent arg0)
	{
		miSave.setEnabled(Father.hasChanged);

		if (suppressWindowActivated == false && node.getLevel() == 3 && node.getUserObject() instanceof Libref)
		{
			Libref li = (Libref) node.getUserObject();
			lblTitel.setText(li.toString());
			showBankInfo(li);	
		}
	}

	@Override
	public void windowClosed(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowClosing(WindowEvent arg0)
	{
		this.execSizeDispose();
		
	}

	@Override
	public void windowDeactivated(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowDeiconified(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowIconified(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowOpened(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	private void clickmiQuitApp()
	{
		// Prove if changes must be changed
		if (queryExit())
		{
		
			try
			{
				this.execSizeDispose();

				this.Father.dispose();
			}
			catch (Exception e)
			{
			}

		}
	}

	private boolean queryExit()
	{
			
		// Benutzerdefinierten Button Text
		Object[] options = {"Yes", "No", "Cancel"};
		
		if (!Father.hasChanged) return true;
		
		int retValue = JOptionPane.showOptionDialog(this, "The literature data have been changed.\nDo you want to save the changes?", "Save the changes?", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[2]);
		
		// Abbrechen ?
		if (retValue == 2) return false;
		
		// Ja - Speichern ?
		if (retValue == 0)
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = Father.MayLibFile;
			boolean result = Father.saveMayLib(Dateiname, fileExtension, Characterset);
			
			if (result==true)
			{
				JOptionPane.showMessageDialog(null, "Changes in opened MayLib database saved (File: " + Father.lastWrittenFile +").", "Data saved",
						JOptionPane.INFORMATION_MESSAGE);	
			}
			
			return result;
		}
		
		// Nein - Nicht speichern
		return true;			
	}


	@Override
	public void keyPressed(KeyEvent e)
	{
		if (e.getKeyCode() == KeyEvent.VK_ENTER)
		{
			if (e.getSource().equals(btnRefresh))
			{	
				MayLib_Start Father = this.Father;
				String Mode = this.Mode; 
				
				this.execSizeDispose();
				
				LibrefSplitPane dlg = new LibrefSplitPane(Father, Mode);
				dlg.showDialog(Father);
			}
			else if (e.getSource().equals(btnDelete))
				deleteEntry();
			else if (e.getSource().equals(btnEdit))
				detailFormat("EDIT");
			else if (e.getSource().equals(btnNewLibref))
				detailFormat("NEW Libref");
			else if (e.getSource().equals(btnQuitApp))
				clickmiQuitApp();
			
			else if (e.getSource().equals(btnClose))
			{
				this.execSizeDispose();
			}
		}
		
	}


	@Override
	public void keyReleased(KeyEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	@Override
	public void keyTyped(KeyEvent arg0)
	{
		// TODO Auto-generated method stub

	}

	private void detailFormat(String actionDesired)
	{
		MayLibTable Periodical_MayLibTable = null;
		MayLibTable Libref_MayLibTable = null;
		Libref Librefedit = null;

		if (actionDesired.equalsIgnoreCase("EDIT"))
		{
			if (node.getLevel() == 3 && node.getUserObject() instanceof Libref)
			{
				// Info Panel aufbereiten und anzeigen
				Librefedit = (Libref) node.getUserObject();
			}
		}
		
		LibrefDialog dlg = new LibrefDialog(Librefedit, this.Father, Periodical_MayLibTable, Libref_MayLibTable, this);
		dlg.showDialog(this);

		miSave.setEnabled(Father.hasChanged);
		btnRefresh.setEnabled(true);
		miRefresh.setEnabled(true); 
		suppressWindowActivated = false;
	}

	private void deleteEntry()
	{
		if (node.getLevel() == 3 && node.getUserObject() instanceof Libref)
		{
			Object[] options =
			{ "Yes", "No" };
			int retValue = JOptionPane.showOptionDialog(this, "Do you really want to delete the shown reference?", "Delete", JOptionPane.YES_NO_OPTION,
					JOptionPane.QUESTION_MESSAGE, null, options, options[1]);
			// Nein - nicht lschen
			if (retValue != 0)
				return;

			Libref LibrefObj = (Libref) node.getUserObject();
			
			btnDelete.setEnabled(false);
			miDelete.setEnabled(false);
			
			if (!Father.deleteLibref(LibrefObj))
				return;
			
			node.removeFromParent();

			Father.hasChanged = true;
			miSave.setEnabled(Father.hasChanged);
			btnRefresh.setEnabled(true);
			miRefresh.setEnabled(true); 
			
			suppressWindowActivated = false;

		}

	}

	protected void execSizeDispose()
	{
		Father.LibrefSplitPane_X = this.getX();
		Father.LibrefSplitPane_Y = this.getY();
		Father.LibrefSplitPane_Width = this.getWidth();
		Father.LibrefSplitPane_Height = this.getHeight();
		this.dispose();
	}
}
