package MayLib;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Insets;
//import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;


public class MayLibManual extends AbstractDialog implements ActionListener, KeyListener
{
	private static final long serialVersionUID = 1L;
	private Font Plainfont, Boldfont; 
	private JMenuBar	       menuBar;
	private JMenu	           menuFile;
	private JMenuItem	       miClose, miQuit;
	private JMenu	           menuSearch;
	private JMenuItem		   miSearchAbstract; 

	protected MayLib_Start  	Father;
	
	private JTextArea txarAbstract;
	private JScrollPane txarAbstractScrollPane;
	
	//For Statusbar and Buttons at the bottom
	private JPanel		pnlBottom, pnlStart;;
	private JButton	     btnSearchAbs, btnClose, btninvisible;
	
	
	public MayLibManual( MayLib_Start Father)
	{	
		this.Plainfont = Father.Plainfont;
		this.Boldfont = Father.Boldfont;
		this.setFont(Plainfont);
		this.Father = Father;
		initializeComponents();
	
	}

	private void setmyFontChild()
	{		
		this.getJMenuBar().setFont(Boldfont);		
		
		for (int i = 0; i < menuBar.getMenuCount(); i++)
		{
			menuBar.getMenu(i).setFont(Boldfont);
			setFontMenuItems(menuBar.getMenu(i));
		}
		
		setFontComponents(this.getContentPane());
		
		txarAbstract.setFont(Plainfont);
	}
	
	private void setFontMenuItems(JMenu m)
	{
		for (Component c : m.getMenuComponents())
		{
			// Der Separator hat keinen Text und keine Elemente
			if (c instanceof JMenuItem)
			{
				((JMenuItem)c).setFont(Boldfont);
				if (((JMenuItem)c).getSubElements().length > 0)
					setFontMenuItems((JMenu)c);
			}
		}
	}
	
	private void setFontComponents(Container container)
	{
		for (Component c : container.getComponents())
		{
			if (c instanceof JLabel)
				((JLabel)c).setFont(Plainfont);
			else if (c instanceof JButton)
				((JButton)c).setFont(Boldfont);
			else if (c instanceof JPanel)
			{
				// Prfen, ob das Panel einen TitledBorder hat, dessen Text
				// dann ebenfalls bersetzt werden muss.
				Border b = ((JPanel)c).getBorder();
				if (b instanceof TitledBorder)
					((TitledBorder)b).setTitleFont(Plainfont);
					
				// Ein Panel ist ein Container und enthlt in aller Regel Komponenten
				setFontComponents((JPanel)c);
			}
			
		}
	}

	
	@Override
	public void initializeComponents()
	{
		
		this.setTitle("MayLib - Mini-Manual");
		this.setModalityType(DEFAULT_MODALITY_TYPE);
		this.setBounds(10, 10, 800, 480);
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.setLayout(new BorderLayout());
		
		createMenu();
		
		
		//Panel Start
				pnlStart = new JPanel(null);
				pnlStart.setPreferredSize(new Dimension(790, 5));
				this.add(pnlStart,  BorderLayout.PAGE_START);
				pnlStart.setLayout(new BorderLayout());
				pnlStart.setBackground(Father.BackGroundColor);
		
		//Buttons at the bottom
		//Panel Bottom
		pnlBottom = new JPanel(null);
		pnlBottom.setPreferredSize(new Dimension(790, 35));
		this.add(pnlBottom,  BorderLayout.PAGE_END);
		pnlBottom.setLayout(new BorderLayout());
  		

	    //Buttons
  		
		btnSearchAbs = new JButton("Search");
		btnSearchAbs.setBounds(5, 5, 120, 25);
		btnSearchAbs.setMargin(new Insets(2, 2, 2, 2));
		btnSearchAbs.setName("Search");
		btnSearchAbs.addActionListener(this);
		btnSearchAbs.addKeyListener(this);
		pnlBottom.add(btnSearchAbs);


		btnClose = new JButton("Close");
		btnClose.setName("Close");
		btnClose.setBounds(265, 5, 120, 25);
		btnClose.setMargin(new Insets(2, 2, 2, 2));
		btnClose.addActionListener(this);
		btnClose.addKeyListener(this);
		pnlBottom.add(btnClose);
		
		btninvisible = new JButton("invisible");
		btninvisible.setBounds(780, 5, 5, 25);
		btninvisible.setVisible(false);
		pnlBottom.add(btninvisible);
  		
		// Textarea

		txarAbstract = new JTextArea();
		txarAbstractScrollPane = new JScrollPane(txarAbstract);
		txarAbstractScrollPane.setPreferredSize(new Dimension(790, 85));
		// Vertikale Laufleiste immer sichtbar
		txarAbstractScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

		// Automatischer Zeilenumbruch
		txarAbstract.setLineWrap(true);

		// Automatischer Umbruch auf Wortgrenze
		// wenn autom. Zeilenumbruch gesetzt wurde.
		txarAbstract.setWrapStyleWord(true);

		// Freien Bereich zwischen Rahmen und dem Text definieren.
		txarAbstract.setMargin(new Insets(2, 2, 2, 2));
		
		txarAbstract.setEditable(false);
		this.add(txarAbstractScrollPane, BorderLayout.CENTER);
		
		
		//Wev fill the text
		
		StringBuilder sb = new StringBuilder();
		sb.append("MayLib - Mini-Manual \n\nDefinition:");
		sb.append("\nMayLib is a literature database, which in contrary to other databases does not need any database engine. MayLib only needs a text-file in a very specific format, which will be described in detail below. ");
		sb.append("MayLib has been designed to store references of scientific publications (books, articles, thesis etc) of all languages  English, French, German, Spanish and Czech as well as Russian, Japanese and Chinese etc. etc..");
		sb.append("It does not only contain the basic functions but also contains some advanced features. For example, for each reference it allows storing a text of several pages length (up to 95.000 characters). These texts can be searched.");
		sb.append("\nTo make for you the use of MayLib more comfortable, the menu Preferences offers three items: 1) the election of the font size, 2) the colour of the background and 3) the size of the windows of the application.");
		sb.append("\n\nCharacter set of the MayLib files:");
		sb.append("\nTo be able to store references of all languages, MayLib uses internally a Unicode character set. Nevertheless, MayLib is able to read furthermore the default character set of your operating system and the UTF-8 character set. ");
		sb.append("If you do not know the character set of a file which you would like to read, or if you use the UTF-8 character set, you have to use the option UNKNOWN CHARACTERSET.");
		sb.append("\nIn the same way, as MayLib can read different character sets, it can write with different character sets. Your options are: 1) a Unicode character set, ");
		sb.append("2) the default character set of your operating system and 3) write with the same character set you have read the last time using the option UNKNOWN CHARACTERSET.");
		sb.append("\nPrincipally, the best choice is to use always a Unicode character set, because only Unicode is able to reproduce all letters of all languages.");
		sb.append("\n\nFormat of the MayLib files:");
		sb.append("\nThe text file which MayLib uses for storing the references has a very specific format. You can see it, if you open the file with a normal text editor. The format is very similar to the CSV format. ");
		sb.append("\nEach reference occupies one line and consists of 30 fields. Each field is separated from the next field by a semicolon ;. Each field must be filled by one space. ");
		sb.append("Of course, the fields must not contain semicolons, neither linefeeds.");
		sb.append("\nName, maximum length (in characters) and comments on the fields:");
		sb.append("\nAuthor_1: 50, 1. Author --  OBLIGATORY FIELD (Must be filled)!");
		sb.append("\nAuthor_2: 50.");
		sb.append("\nAuthor_3: 50");
		sb.append("\nAuthor_4: 70");
		sb.append("\nYear: 10, Year of Publication --  OBLIGATORY FIELD (Must be filled)!");
		sb.append("\nEditor: 8, Field will be filled with 'Eds.' if necessary.");
		sb.append("\nTitle: 255");
		sb.append("\nIn_Book_title: 255, If the publication is an article in a book, is this the place for the title of the book.");
		sb.append("\nVolume: 50, Volume (and Number)");
		sb.append("\nPages: 40, First and last page;");
		sb.append("\nFigures 10, Number of figures");
		sb.append("\nNumber_of_tables: 4, Number of Tables");
		sb.append("\nPlates 20, First and last plate");
		sb.append("\nBibliographic_data: 255, Place of Publication (IF NOT IN A PERIODICAL) and further bibliographic data");
		sb.append("\nEditorial: 100");
		sb.append("\nType: 25, Is it a book, a reprint, a PDF file, xerocopies, etc.?");
		sb.append("\nKeyword_1: 25 1. Keyword --  OBLIGATORY FIELD (Must be filled)!");
		sb.append("\nKeyword_2: 25");
		sb.append("\nKeyword_3: 25");
		sb.append("\nName: 255, Name of the Periodical --  OBLIGATORY FIELD (Must be filled)!");
		sb.append("\nPlace:100, Publishing Place of the Periodical (and eventually Publishing House)");
		sb.append("\nAbreviated_Name: 255, Abbreviated Name of the Periodical");
		sb.append("\nISSN: 15");
		sb.append("\nLanguage: 30,  Note if  the papers of the Periodical are published in Russian or Chinese etc.");
		sb.append("\nCatalogue_Number 17 , The catalogue number given by the owner.");
		sb.append("\nStoring_place: 50,  Where is the publication stored now?");
		sb.append("\nRemarks: 255");
		sb.append("\nDate_Entry: date in the format yyyyMMdd_HH:mm");
		sb.append("\nISBN: 15");
		sb.append("\nAbstract: (95.000), Abstract, Summary, or List of Contents of the Publication;");
		sb.append("\n\nFor further information and updates contact Dr. Andreas May, may_devonian@yahoo.es");
		sb.append("\n\nJanuary 13th, 2013, Feast of the Baptism of the Lord");
		
		txarAbstract.setText(sb.toString());
		txarAbstract.setCaretPosition(0);
		
		//Windowsize
		if (Father.MaximizeWindow.equalsIgnoreCase("big") || Father.MaximizeWindow.equalsIgnoreCase("all"))
						makeFrameFullSize();
		
	}

	private void createMenu()
	{
		menuBar = new JMenuBar();
		this.setJMenuBar(menuBar);
		
		menuFile = this.createMenu(menuBar, "File", "menuFile", 'F');
		miClose = this.createMenuItem(menuFile, null, AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Close", null, 'C', "Closes this window");	
		miQuit = this.createMenuItem(menuFile, "miQuit", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Quit application", null, 'Q', "Quits the program/application and closes all windows");
		
		menuSearch = this.createMenu(menuBar, "Search", "menuSearch", 'h');
		miSearchAbstract = this.createMenuItem(menuSearch, "miSearchAbstract", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Search abstract", null, 'a', "Searches the abstract for a word or a part of a word/phrase");
	
	}
	

		
	@Override
	public void initDialog()
	{
		this.setBackground(Father.BackGroundColor);
		this.getContentPane().setBackground(Father.BackGroundColor);
		this.pnlBottom.setBackground(Father.BackGroundColor);

		//Windowsize
		if (Father.MaximizeWindow.equalsIgnoreCase("big") || Father.MaximizeWindow.equalsIgnoreCase("all"))
				makeFrameFullSize();
	
		setmyFontChild();
		
	
	}

	@Override
	public void actionPerformed(ActionEvent e)
	{

		
		if (e.getSource().equals(btnSearchAbs))
		{
			MayLibSearch f = MayLibSearch.getInstance(txarAbstract,	Father);
			f.showDialog(this);
		}
	

		else if (e.getSource().equals(btnClose))
		{
			this.dispose();
		}
		
		else if (e.getSource().equals(miClose))
			this.dispose();

		else if (e.getSource().equals(miQuit))
			clickmiQuitApp();
		
		
		else if (e.getSource().equals(miSearchAbstract))
		{
			MayLibSearch f = MayLibSearch.getInstance(txarAbstract,	Father);
			f.showDialog(this);
		}	

	
		
	
	}


	@Override
	public void keyPressed(KeyEvent e)
	{
		
			if (e.getKeyCode() == KeyEvent.VK_ENTER)
			{

				if (e.getSource().equals(btnSearchAbs))
				{
					MayLibSearch f = MayLibSearch.getInstance(txarAbstract,	Father);
					f.showDialog(this);
				}
			

				else if (e.getSource().equals(btnClose))
				{
					this.dispose();
				}

			}
	
	}


	@Override
	public void keyReleased(KeyEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	@Override
	public void keyTyped(KeyEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	private void clickmiQuitApp()
	{
		// Prove if changes must be changed
		if (queryExit())
		{
		
			try
			{
				this.dispose();

				this.Father.dispose();
			}
			catch (Exception e)
			{
			}

		}
	}

	private boolean queryExit()
	{
			
		// Benutzerdefinierten Button Text
		Object[] options = {"Yes", "No", "Cancel"};
		
		if (!Father.hasChanged) return true;
		
		int retValue = JOptionPane.showOptionDialog(this, "The literature data have been changed.\nDo you want to save the changes?", "Save the changes?", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[2]);
		
		// Abbrechen ?
		if (retValue == 2) return false;
		
		// Ja - Speichern ?
		if (retValue == 0)
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = Father.MayLibFile;
			boolean result = Father.saveMayLib(Dateiname, fileExtension, Characterset);
			
			if (result==true)
			{
				JOptionPane.showMessageDialog(null, "Changes in opened MayLib database saved (File: " + Father.lastWrittenFile +").", "Data saved",
						JOptionPane.INFORMATION_MESSAGE);	
			}
			
			return result;
		}
		
		// Nein - Nicht speichern
		return true;			
	}
	
}
