package MayLib;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Insets;
//import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.TreeSet;

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.AbstractTableModel;


public class MayLibTable extends AbstractDialog implements WindowListener, ActionListener, KeyListener, ListSelectionListener, MouseListener
{
	private static final long serialVersionUID = 1L;
	private Font Plainfont, Boldfont; 
	private JMenuBar	       menuBar;
	private JMenu	           menuFile, menuEdit, submenuSaveAs;
	private JMenuItem	       miNew, miEditRef, miDelete, miClose, miSave, miSaveAsOther, miSaveAsUCF, 
									miSaveAsUnknown, miQuit, miCopy;
	private JMenu	           menuSearch;
	private JMenuItem			miSearchWord, miRepeatSearch, miSearchAbstract, miCleanRemarks;
	
	//save search
	private JMenu	         submenuSaveSearch;
	private JMenuItem        miSaveSearchOther, miSaveSearchUCF, miSaveSearchUnknown, miSaveSearchCSV;
	
	//Menue Report
	private JMenu	              menuReport, submenuAbstract, submenuReportType;
	private JMenuItem             miReportAllLibrefs, miReportAllPeriodicals, miReportSelObjects;
	private JRadioButtonMenuItem  miWithoutAbstract, mi1000Abstract, miFullAbstract, miBasicReport, miCompleteReport;
	private JRadioButtonMenuItem  mi2000Abstract, mi4000Abstract;
	private ButtonGroup		      bgAbstract, bgReportType;
	//Addition to menue Report
	private JMenu	              submenuRepCharacterset;
	private JRadioButtonMenuItem  miRepUnicode, miRepDefault, miRepUnknown;
	private ButtonGroup		      bgRepCharacterset;
	
	//Addition to menue Report
	private JRadioButtonMenuItem  miGermanStandardReport, miPalaeontologyReport, miBullGeosciencesPragueReport;
	
	private JTable			   Tabelle;
	private JScrollPane		   jspTabelle;		
	
	private ArrayList<String> MyTableHeader;
	private String 			Mode, Titletext;
	protected MayLib_Start  	Father;
	
	protected TreeSet<Object>	 MyTableTreeSet;

	private JTextArea txarAbstract;
	private JScrollPane txarAbstractScrollPane;
	
	//For Statusbar and Buttons at the bottom
	private JPanel		pnlBottom, pnlStart;
	private JButton	     btnEdit, btnDelete, btnNewLibref, btnNewPeriodical, btnReport, 
							btnClose, btnQuitApp, btnCopy, btninvisible;
	private StatusBar	       statusBar;
	private String 		strSearchWord;
	
	
	public MayLibTable(ArrayList<String> MyTableHeader, TreeSet<Object> MyTableTreeSet, 
			String Mode, String Titletext, MayLib_Start Father)
	{	
		this.MyTableHeader = MyTableHeader;
		this.MyTableTreeSet = MyTableTreeSet;
		this.Plainfont = Father.Plainfont;
		this.Boldfont = Father.Boldfont;
		this.setFont(Plainfont);
		this.Mode = Mode;
		this.Titletext = Titletext;
		this.Father = Father;
		initializeComponents();
	
	}

	private void setmyFontChild()
	{		
		this.getJMenuBar().setFont(Boldfont);		
		
		for (int i = 0; i < menuBar.getMenuCount(); i++)
		{
			menuBar.getMenu(i).setFont(Boldfont);
			setFontMenuItems(menuBar.getMenu(i));
		}
		
		setFontComponents(this.getContentPane());
		
		txarAbstract.setFont(Plainfont);
	}
	
	private void setFontMenuItems(JMenu m)
	{
		for (Component c : m.getMenuComponents())
		{
			// Der Separator hat keinen Text und keine Elemente
			if (c instanceof JMenuItem)
			{
				((JMenuItem)c).setFont(Boldfont);
				if (((JMenuItem)c).getSubElements().length > 0)
					setFontMenuItems((JMenu)c);
			}
		}
	}
	
	private void setFontComponents(Container container)
	{
		for (Component c : container.getComponents())
		{
			if (c instanceof JLabel)
				((JLabel)c).setFont(Plainfont);
			else if (c instanceof JButton)
				((JButton)c).setFont(Boldfont);
			else if (c instanceof JPanel)
			{
				// Prfen, ob das Panel einen TitledBorder hat, dessen Text
				// dann ebenfalls bersetzt werden muss.
				Border b = ((JPanel)c).getBorder();
				if (b instanceof TitledBorder)
					((TitledBorder)b).setTitleFont(Plainfont);
					
				// Ein Panel ist ein Container und enthlt in aller Regel Komponenten
				setFontComponents((JPanel)c);
			}
			
		}
	}

	
	@Override
	public void initializeComponents()
	{
		
		this.setTitle("MayLib - " + this.Titletext);
		this.setModalityType(DEFAULT_MODALITY_TYPE);
		this.setBounds(10, 10, 800, 480);
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.setLayout(new BorderLayout());
		this.addWindowListener(this);
		
		createMenu();
		
		//Panel Start
				pnlStart = new JPanel(null);
				pnlStart.setPreferredSize(new Dimension(790, 320));
				this.add(pnlStart,  BorderLayout.PAGE_START);
				pnlStart.setLayout(new BorderLayout());
		
		Tabelle = new JTable();
		//Tabelle.setBackground(Father.BackGroundColor);
		// Keine Mehrfachauswahl zulassen
		Tabelle.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		Tabelle.addKeyListener(this);
		Tabelle.addMouseListener(this);
		// Listener zur Anzeige der aktuellen Zeilennummer
		Tabelle.getSelectionModel().addListSelectionListener(this);
		
		jspTabelle = new JScrollPane(Tabelle);
		jspTabelle.setBackground(Father.BackGroundColor);
		
		pnlStart.add(jspTabelle, BorderLayout.CENTER);
		pnlStart.setBackground(Father.BackGroundColor);
		
		//For Statusbar and Buttons at the bottom
		//Panel Bottom
		pnlBottom = new JPanel(null);
		pnlBottom.setPreferredSize(new Dimension(790, 55));
		this.add(pnlBottom,  BorderLayout.PAGE_END);
		pnlBottom.setLayout(new BorderLayout());
				
		// Statusleiste
  		statusBar = new StatusBar();
  		statusBar.setHorizontalAlignment(JLabel.CENTER);
  		pnlBottom.add(statusBar, BorderLayout.PAGE_END);
  		

	    //Buttons
  		
		btnEdit = new JButton("Edit selected");
		btnEdit.setBounds(5, 5, 120, 25);
		btnEdit.setMargin(new Insets(2, 2, 2, 2));
		btnEdit.setName("Edit");
		btnEdit.addActionListener(this);
		btnEdit.addKeyListener(this);
		pnlBottom.add(btnEdit);
		
		btnClose = new JButton("Close");
		btnClose.setBounds(126, 5, 4, 25);
		btnClose.setMargin(new Insets(2, 2, 2, 2));
		btnClose.setName("Close");
		btnClose.addActionListener(this);
		btnClose.addKeyListener(this);
		btnClose.setVisible(false);
		pnlBottom.add(btnClose);
		
		btnCopy = new JButton("Copy");
		btnCopy.setBounds(126, 5, 4, 25);
		btnCopy.setMargin(new Insets(2, 2, 2, 2));
		btnCopy.setName("Copy");
		btnCopy.addActionListener(this);
		btnCopy.addKeyListener(this);
		btnCopy.setVisible(false);
		pnlBottom.add(btnCopy);

		btnDelete = new JButton("Delete selected");
		btnDelete.setName("Delete");
		btnDelete.setBounds(135, 5, 120, 25);
		btnDelete.setMargin(new Insets(2, 2, 2, 2));
		btnDelete.addActionListener(this);
		btnDelete.addKeyListener(this);
		pnlBottom.add(btnDelete);
		
		btnNewLibref = new JButton("New Literature");
		btnNewLibref.setBounds(265, 5, 120, 25);
		btnNewLibref.setMargin(new Insets(2, 2, 2, 2));
		btnNewLibref.setName("New Literature");
		btnNewLibref.addKeyListener(this);
		btnNewLibref.addActionListener(this);
		pnlBottom.add(btnNewLibref);

		btnNewPeriodical = new JButton("New Periodical");
		btnNewPeriodical.setName("New Periodical");
		btnNewPeriodical.setBounds(395, 5, 120, 25);
		btnNewPeriodical.setMargin(new Insets(2, 2, 2, 2));
		btnNewPeriodical.addActionListener(this);
		btnNewPeriodical.addKeyListener(this);
		pnlBottom.add(btnNewPeriodical);

		btnReport = new JButton("Report");
		btnReport.setName("Report");
		btnReport.setBounds(525, 5, 120, 25);
		btnReport.setMargin(new Insets(2, 2, 2, 2));
		btnReport.addActionListener(this);
		btnReport.addKeyListener(this);
		pnlBottom.add(btnReport);

		btnQuitApp = new JButton("Quit application");
		btnQuitApp.setName("Quit");
		btnQuitApp.setBounds(655, 5, 120, 25);
		btnQuitApp.setMargin(new Insets(2, 2, 2, 2));
		btnQuitApp.addActionListener(this);
		btnQuitApp.addKeyListener(this);
		pnlBottom.add(btnQuitApp);
		
		btninvisible = new JButton("invisible");
		btninvisible.setBounds(780, 5, 5, 25);
		btninvisible.setVisible(false);
		pnlBottom.add(btninvisible);
  		
		// Textarea

		txarAbstract = new JTextArea();
		txarAbstractScrollPane = new JScrollPane(txarAbstract);
		txarAbstractScrollPane.setPreferredSize(new Dimension(790, 85));
		// Vertikale Laufleiste immer sichtbar
		txarAbstractScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

		// Automatischer Zeilenumbruch
		txarAbstract.setLineWrap(true);

		// Automatischer Umbruch auf Wortgrenze
		// wenn autom. Zeilenumbruch gesetzt wurde.
		txarAbstract.setWrapStyleWord(true);

		// Freien Bereich zwischen Rahmen und dem Text definieren.
		txarAbstract.setMargin(new Insets(2, 2, 2, 2));
		
		txarAbstract.setEditable(false);
		this.add(txarAbstractScrollPane, BorderLayout.CENTER);
		
	}

	private void createMenu()
	{
		menuBar = new JMenuBar();
		this.setJMenuBar(menuBar);
		
		menuFile = this.createMenu(menuBar, "File", "menuFile", 'F');
		miSave = this.createMenuItem(menuFile, "miSave", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Save opened MayLib file (*.ucf)", null, 'S', "Saves the opened MayLib as MayLib file (*.ucf) under the same name");
		submenuSaveAs = this.createSubMenue(menuFile, "Save opened MayLib as...", "submenuSaveAs", 'a');
		miSaveAsUCF = this.createMenuItem(submenuSaveAs, "miSaveAsUCF", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "MayLib file (*.ucf)", null, 'b', "Saves the opened MayLib as MayLib file (*.ucf) under another name");
		miSaveAsOther = this.createMenuItem(submenuSaveAs, "miSaveAsOther", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "System default character set", null, 'y', "Saves the opened MayLib as a file with the system default character set under another name");
		miSaveAsUnknown = this.createMenuItem(submenuSaveAs, "miSaveAsUnknown", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Unknown character set", null, 0, "Saves the opened MayLib as a file with the character set for opened files with an unknown character set");
		
		// save search
		menuFile.addSeparator();
		submenuSaveSearch = this.createSubMenue(menuFile, "Save searched literature in...", "submenuSaveSearch", 'e');
		miSaveSearchUCF = this.createMenuItem(submenuSaveSearch, "miSaveSearchUCF", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "MayLib file (*.ucf)", null, 0,
								"Saves the searched literature as MayLib file (*.ucf) under another name. NOTE: Periodicals without Literature references will not be included!");
		miSaveSearchOther = this.createMenuItem(submenuSaveSearch, "miSaveSearchOther",
								AbstractDialog.MenuItemType.ITEM_PLAIN,
								this, "System default character set",	null, 0,
								"Saves the searched literature as a MayLib-like file with the system default character set under another name. NOTE: Periodicals without Literature references will not be included!");
		miSaveSearchUnknown = this.createMenuItem(submenuSaveSearch,	"miSaveSearchUnknown",
								AbstractDialog.MenuItemType.ITEM_PLAIN,
								this, "Unknown character set",	null, 0,
								"Saves the searched literature as a  MayLib-like file with the character set for opened files with an unknown character set. NOTE: Periodicals without Literature references will not be included!");
		miSaveSearchCSV = this.createMenuItem(submenuSaveSearch, "miSaveSearchCSV", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "CSV file (can be read by Excel)", null, 0,
								"Saves the searched literature as a CSV file which can be read by Excel. NOTE: Periodicals without Literature references will not be included!");
						
		
		menuFile.addSeparator();	
		miClose = this.createMenuItem(menuFile, null, AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Close", null, 'C', "Closes this window");	
		miQuit = this.createMenuItem(menuFile, "miQuit", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Quit application", null, 'Q', "Quits the program/application and closes all windows");
		
		menuEdit = this.createMenu(menuBar, "Edit", null, 'E');
		miNew = this.createMenuItem(menuEdit, "miNew", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "New", null, 'N', "Opens window to create a new reference");
		miEditRef = this.createMenuItem(menuEdit, "miEditRef", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Edit reference", null, 'r', "Opens window to edit the selected reference");
		miCopy = this.createMenuItem(menuEdit, "miCopy", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Create copy of reference", null, 0, "Opens window to edit a copy of the selected literature reference");
		miDelete = this.createMenuItem(menuEdit, "miDelete", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Delete", null, 'D', "Deletes the selected reference");	
		miCleanRemarks = this.createMenuItem(menuEdit, "miCleanRemarks", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Clean remarks", null, 'C', "Cleans the field 'Remarks' in all references of this table.");	
		
		menuSearch = this.createMenu(menuBar, "Search", "menuSearch", 'h');
		miSearchWord = this.createMenuItem(menuSearch, "miSearchWord", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Search word", null, 'w', "Searches the table for a word or a part of a word/phrase. Starts with the selected row.");
		miRepeatSearch = this.createMenuItem(menuSearch, "miRepeatSearch", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Repeats search", null, 'R', "Repeats to search the table for a word or a part of a word/phrase");
		miSearchAbstract = this.createMenuItem(menuSearch, "miSearchAbstract", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Search abstract", null, 'a', "Searches the abstract for a word or a part of a word/phrase");
	
		menuReport = this.createMenu(menuBar, "Report", "menuReport", 'R');
		miReportAllLibrefs = this.createMenuItem(menuReport, "miReportAllLibrefs", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Report all literature", null, 'l', "Creates a report of all literature references");
		miReportAllPeriodicals = this.createMenuItem(menuReport, "miReportAllPeriodicals", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Report all periodicals", null, 'p', "Creates a report of all periodicals");
		miReportSelObjects = this.createMenuItem(menuReport, "miReportSelObjects", AbstractDialog.MenuItemType.ITEM_PLAIN, this, "Report listed objects", null, 'o', "Creates a report of ALL objects listed in this form (either literature references or periodicals)");
		menuReport.addSeparator();
		submenuAbstract = this.createSubMenue(menuReport, "Include Abstract?",  "submenuAbstract", 'i');
		miWithoutAbstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "miWithoutAbstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Without abstract", null, 'W', "The resulting report does not contain any abstract");
		mi1000Abstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "mi1000Abstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "1000 characters", null, '1', "The resulting report contains the first 1000 characters of the abstract, if it is a literature references report");
		mi2000Abstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "mi2000Abstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "2000 characters", null, '2', "The resulting report contains the first 2000 characters of the abstract, if it is a literature references report");
		mi4000Abstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "mi4000Abstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "4000 characters", null, '4', "The resulting report contains the first 4000 characters of the abstract, if it is a literature references report");
		miFullAbstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "miFullAbstract", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Full abstract", null, 'F', "The resulting report contains the full abstract, if it is a literature references report");
		submenuReportType = this.createSubMenue(menuReport, "Type of Report",  "submenuReportType", 'T');
		miBasicReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miBasicReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Basic report", null, 'B', "A short report with the most relevant information");
		miCompleteReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miCompleteReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Complete report", null, 'C', "A complete report with all information");
		bgAbstract = new ButtonGroup();
		bgAbstract.add(miWithoutAbstract);
		bgAbstract.add(mi1000Abstract);
		bgAbstract.add(mi2000Abstract);
		bgAbstract.add(mi4000Abstract);
		bgAbstract.add(miFullAbstract);
		bgReportType = new ButtonGroup();
		bgReportType.add(miBasicReport);
		bgReportType.add(miCompleteReport);
		//Addition to menue Report
		miGermanStandardReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miGermanStandardReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "German Standard report", null, 'G', "Detailed literature reference in German style");
		miPalaeontologyReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miPalaeontologyReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Palaeontology report", null, 'P', "Literature reference in 'Palaeontology (London)' style");
		miBullGeosciencesPragueReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miBullGeosciencesPragueReport", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Bulletin Geosciences Prague report", null, 'u', "Literature reference in 'Bulletin of Geosciences (Prague)' style");
		bgReportType.add(miBullGeosciencesPragueReport);
		bgReportType.add(miGermanStandardReport);
		bgReportType.add(miPalaeontologyReport);
		//Addition to menue Report
		submenuRepCharacterset = this.createSubMenue(menuReport, "Characterset of the report",  "submenuRepCharacterset", 'h');
		miRepUnicode = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepUnicode", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Unicode (*.RPU)", null, 'U', "The resulting report will be written with Unicode character set. The default file extension is *.RPU");
		miRepDefault = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepDefault", AbstractDialog.MenuItemType.ITEM_RADIO, this, "System default character set (*.RPT)", null, 'y', "The resulting report will be written with the default system character set. The default file extension is *.RPT");
		miRepUnknown = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepUnknown", AbstractDialog.MenuItemType.ITEM_RADIO, this, "Unknown character set (*.RPT)", null, 0, "The resulting report will be written with the character set used by the last file imported with UNKNOWN character set. The default file extension is *.RPT");
		bgRepCharacterset = new ButtonGroup();
		bgRepCharacterset.add(miRepUnicode);
		bgRepCharacterset.add(miRepDefault);
		bgRepCharacterset.add(miRepUnknown);	
	}
	
	
	private void showDataThread()
	{
		 Thread t  = new Thread(new ShowData());
		 t.start();	
	}
	
	
	private void setColumnWidth(JTable jTable, int col, int width)
	{
		
		jTable.getColumnModel().getColumn(col).setWidth(width);
		// setMaxWidth() ist erforderlich um die Spaltenbreite zu setzen,
		// durch den Multiplikator wird aber die Mglichkeit gegeben
		// die Spalte nachtrglich um das n-fache zu vergrssern. 
		jTable.getColumnModel().getColumn(col).setMaxWidth(width * 3);
		jTable.getColumnModel().getColumn(col).setPreferredWidth(width);
		jTable.getTableHeader().resizeAndRepaint();
		
	}
	




	private void setTableColumnInvisible(JTable jTable, int col)
	{
		jTable.getColumnModel().getColumn(col).setWidth(0);
		jTable.getColumnModel().getColumn(col).setMaxWidth(0);
		jTable.getColumnModel().getColumn(col).setMinWidth(0);
		jTable.getColumnModel().getColumn(col).setPreferredWidth(0);
		jTable.getColumnModel().getColumn(col).setResizable(false);
		jTable.getTableHeader().resizeAndRepaint();
	}
	
	
	
	private void setSelectedRow(int row)
	{
		if (row > 0 && row <= Tabelle.getRowCount())
			Tabelle.changeSelection(row - 1, 0, false, true);
	}
	
	
	private void deleteEntry(Object key)
	{

		Object[] options =
		{ "Yes", "No" };
		int retValue = JOptionPane.showOptionDialog(this, "Do you really want to delete the selected reference?", "Delete", JOptionPane.YES_NO_OPTION,
				JOptionPane.QUESTION_MESSAGE, null, options, options[1]);
		// Nein - nicht lschen
		if (retValue != 0)
			return;

		// Aktuelle Zeile merken
		int selectedRow = Tabelle.getSelectedRow();

		// The following depends on if it is a Libref or a Periodical
		if (Mode.equalsIgnoreCase("Libref"))
		{
			Libref LibrefObj = (Libref) key;
			if (!Father.deleteLibref(LibrefObj))
				return;
		}
		else
		{
			Periodical PeriodicalObj = (Periodical) key;
			// Object deleting form Objecttree and corresponding map!!!!!
			if (!Father.deletePeriodical(PeriodicalObj))
				return;
		}

		Father.hasChanged = true;
		MyTableTreeSet.remove(key);

		statusBar.setText("Reading data...");
		ShowData showData = new ShowData();
		showData.run();
		
		miSave.setEnabled(Father.hasChanged);

		// Auf die vorherige Zeile positionieren
		setSelectedRow(selectedRow);

	}

	private void detailFormat(String actionDesired)
	{
		int selectedRow = -1;
		
		MayLibTable Periodical_MayLibTable = null;
		MayLibTable Libref_MayLibTable = null;
		
		if (this.Mode.equalsIgnoreCase("Libref"))
			Libref_MayLibTable = this;
		else
			Periodical_MayLibTable = this;
		
		if (actionDesired.equalsIgnoreCase("EDIT") || actionDesired.equalsIgnoreCase("Copy Libref"))
		{
			selectedRow = Tabelle.getSelectedRow();
			
			// if no row was selected, we start new creation
			if (selectedRow == -1)
				actionDesired = "NEW "+this.Mode;
			
		}
		
		//public PeriodicalDialog(Periodical myPeriodical, MayLib_Start Father, MayLibTable Periodical_MayLibTable, MayLibTable Libref_MayLibTable)
		
		if (selectedRow > -1 && this.Mode.equalsIgnoreCase("Periodical"))
		{
			Periodical PeriodicalObj = (Periodical)Tabelle.getValueAt(selectedRow, 0);
			PeriodicalDialog dlg = new PeriodicalDialog(PeriodicalObj, this.Father, Periodical_MayLibTable, 
					Libref_MayLibTable, null);
			dlg.showDialog(this);
		}
		
		else if (selectedRow < 0 && actionDesired.equalsIgnoreCase("NEW Periodical"))
		{
			PeriodicalDialog dlg = new PeriodicalDialog(null, this.Father, Periodical_MayLibTable, 
					Libref_MayLibTable, null);
			dlg.showDialog(this);
		}
		
		else if (selectedRow > -1 && this.Mode.equalsIgnoreCase("Libref") && actionDesired.equalsIgnoreCase("EDIT"))
		{
			Libref LibrefObj = (Libref)Tabelle.getValueAt(selectedRow, 0);
			LibrefDialog dlg = new LibrefDialog(LibrefObj, this.Father, Periodical_MayLibTable, 
					Libref_MayLibTable, null);
			dlg.showDialog(this);
		}
		
		else if (selectedRow > -1 && this.Mode.equalsIgnoreCase("Libref") && actionDesired.equalsIgnoreCase("Copy Libref"))
		{
			Libref LibrefObj = (Libref)Tabelle.getValueAt(selectedRow, 0);
			Libref CopyObj = Libref.copyLibref(LibrefObj);
			
			if (CopyObj==null)
			{
				JOptionPane.showMessageDialog(this, "It was not possible to copy the literature reference. Reason: Unknown.", "Copy not possible",
						JOptionPane.ERROR_MESSAGE);	
				return;
			}
			
			//Prove on duplicates
			String Teststring = Libref.makeCompareValue(CopyObj.getAuthor_1(), CopyObj.getAuthor_2(), CopyObj.getAuthor_3(), CopyObj.getAuthor_4(), CopyObj.getYear());
			
			if (Father.LibrefTree.containsKey(Teststring))
			{
					JOptionPane.showMessageDialog(this, "It was not possible to copy the literature reference. Reason:\nA literature reference with this combination of authors and year already exists.", "Copy not possible",
							JOptionPane.ERROR_MESSAGE);
					return;
			}
			
			Father.hasChanged = true; 
			
			LibrefDialog dlg = new LibrefDialog(CopyObj, this.Father, Periodical_MayLibTable, 
					Libref_MayLibTable, null);
			dlg.showDialog(this);
		}
		
		else if (selectedRow < 0 && actionDesired.equalsIgnoreCase("NEW Libref"))
		{
			LibrefDialog dlg = new LibrefDialog(null, this.Father, Periodical_MayLibTable, 
					Libref_MayLibTable, null);
			dlg.showDialog(this);
		}

		// Finally we actualize the DialogFrame
		statusBar.setText("Reading data...");
		ShowData showData = new ShowData();
		showData.run();
		miSave.setEnabled(Father.hasChanged);

		// selectedRow+1 because in setSelectedRow 1 is substracted
		setSelectedRow(selectedRow+1);
		
	}

	
	private void SearchWord()
	{
		String str = JOptionPane.showInputDialog(this, "Please insert a word or a part of a word/phrase, which you would like to search: ", "Search", JOptionPane.PLAIN_MESSAGE);
		if (str.trim() == null) return;
		
		strSearchWord = str.trim();
		miRepeatSearch.setEnabled(true);
		
		selectRowByValue(str);	
	}
		
	private class ShowData implements Runnable
	{

		@Override
		public void run()
		{
			
			Tabelle.setModel(new LibrefTableModel());
			
			// Erste Spalte unsichtbar machen
			setTableColumnInvisible(Tabelle, 0);
			
			// Spaltenbreitefestlegen
			//setColumnWidth(Tabelle, 1, 100);
			
			Font font = new Font(Tabelle.getFont().getFamily(), Font.PLAIN, Plainfont.getSize()-1);
			Tabelle.setFont(font);
		
			// berschriften der Tabelle grsser und fett
			font = new Font(Tabelle.getTableHeader().getFont().getFamily(), Font.BOLD, Boldfont.getSize());
			Tabelle.getTableHeader().setFont(font);
			Tabelle.getTableHeader().setBackground(Father.BackGroundColor);
			
			miEditRef.setEnabled(Tabelle.getRowCount() > 0);
			miCopy.setVisible(Tabelle.getRowCount() > 0 && Mode.equalsIgnoreCase("Libref"));
			miDelete.setEnabled(Tabelle.getRowCount() > 0);
			//System.out.println("Tabelle.getRowCount()" + Tabelle.getRowCount());
			if (Tabelle.getRowCount() > 0)
				setSelectedRow(1);
			
		}
	}
	
	
	private class LibrefTableModel extends AbstractTableModel
	{
		
		private int               anzahlZeilen;
	    private int               anzahlSpalten;
	    private ArrayList<String>  ColumnNames; 
	    
	    private Object[][] data;
		

		public LibrefTableModel()
		{
			// Number of columns: MyTableHeader ={"Libref_Object", "Author_1", "Author_2", "Author_3", "Author_4", 
			// "Year", "Editor", "Title", "In_Book_title", "Periodical", "Volume", "Pages", "Type", 
			// "Keyword_1", "Keyword_2", "Keyword_3", "Storing_place", "Remarks"};	
			this.anzahlSpalten = MyTableHeader.size();
			
			//Number of rows
			this.anzahlZeilen = MyTableTreeSet.size();
				
			// Header
			this.ColumnNames =  MyTableHeader;
			
			// Liest alle Datenstze in das zweidimensioanle Objekt-Array 'data'
			getData();
		}
		
		private void getData()
		{
			
			data = new Object[anzahlZeilen][anzahlSpalten];
			
			Iterator<Object> it = MyTableTreeSet.iterator();
			int ObjectRow =0;
			while (it.hasNext())
				{ 
				//The following depends on if it is a Libref or a Periodical
					if (Mode.equalsIgnoreCase("Libref"))
					{
						Libref LibrefObj = (Libref)it.next();
						// Now we fill one row
						data[ObjectRow][0] = LibrefObj;
						data[ObjectRow][1] = LibrefObj.getAuthor_1();
						data[ObjectRow][2] = LibrefObj.getAuthor_2();
						data[ObjectRow][3] = LibrefObj.getAuthor_3();
						data[ObjectRow][4] = LibrefObj.getAuthor_4();
						data[ObjectRow][5] = LibrefObj.getYear();
						data[ObjectRow][6] = LibrefObj.getEditor();
						data[ObjectRow][7] = LibrefObj.getTitle();
						data[ObjectRow][8] = LibrefObj.getIn_Book_title();
						data[ObjectRow][9] = LibrefObj.getPeriodical();
						data[ObjectRow][10] = LibrefObj.getVolume();
						data[ObjectRow][11] = LibrefObj.getPages();
						data[ObjectRow][12] = LibrefObj.getType();
						data[ObjectRow][13] = LibrefObj.getKeyword_1();
						data[ObjectRow][14] = LibrefObj.getKeyword_2();
						data[ObjectRow][15] = LibrefObj.getKeyword_3();
						data[ObjectRow][16] = LibrefObj.getStoring_place();
						data[ObjectRow][17] = LibrefObj.getRemarks();
					}
					else 
					{
						Periodical PeriodicalObj = (Periodical)it.next();
						// Now we fill one row
						data[ObjectRow][0] = PeriodicalObj;
						data[ObjectRow][1] = PeriodicalObj.getName();
						data[ObjectRow][2] = PeriodicalObj.getPlace();
						data[ObjectRow][3] = PeriodicalObj.getAbreviated_Name();
						data[ObjectRow][4] = PeriodicalObj.getISSN();
						data[ObjectRow][5] = PeriodicalObj.getLanguage();
	
					}
					
					ObjectRow++;
				
				}		
			
		}
		
		public int FindEntry(String value)
		{
			int retValue = -1;
			//System.out.println(value);
			int selectedRow = -1;
			
			selectedRow = Tabelle.getSelectedRow();

			if (selectedRow == -1)
				selectedRow = 0;

			for (int zeile = selectedRow + 1; zeile < getRowCount(); zeile++)
			{
				for (int colInd = 1; colInd < getColumnCount(); colInd++)
				{

					//System.out.println(data[zeile][colInd].toString());
					
					if (!(data[zeile][colInd] == null) &&
							data[zeile][colInd].toString().toLowerCase().contains(value.trim().toLowerCase()))
					{
						return zeile;

					}
				}
			}

			return retValue;

		}

		
		
		private int getColumnIndex(String colName)
		{
			int retValue = -1;
			int i = 0;
			
			for (String s : ColumnNames)
			{
				if (s.equals(colName))
				{
					retValue = i;
					break;
				}
				i++;
			}
			
			return retValue;
		}
		
		
		@Override
		public String getColumnName(int colIndex)
		{
			
			return ColumnNames.get(colIndex);
		}

		
		@Override
		public int getColumnCount()
		{
			
			return anzahlSpalten;
		}

		@Override
		public int getRowCount()
		{
			return anzahlZeilen;
		}

		@Override
		public Object getValueAt(int rowIndex, int colIndex)
		{
			return data[rowIndex][colIndex];
		}

		@Override
		public void setValueAt(Object value, int rowIndex, int colIndex)
		{
			data[rowIndex][colIndex] = value;
			fireTableCellUpdated(rowIndex, colIndex);
		}
		
		
	}
	
	
	private class StatusBar extends JLabel
	{
		public StatusBar()
		{
			this.setBorder(LineBorder.createGrayLineBorder());
		}
		
		public void setMessage(String message)
		{
			setText(" " + message);
		}
		
	}
	
	private void selectRowByValue(String value)
	{
		int rowIndex = ((LibrefTableModel)Tabelle.getModel()).FindEntry(value);
		setSelectedRow(++rowIndex);	
	}

	@Override
	public void initDialog()
	{
		this.setBackground(Father.BackGroundColor);
		this.getContentPane().setBackground(Father.BackGroundColor);
		this.pnlBottom.setBackground(Father.BackGroundColor);
		this.pnlStart.setBackground(Father.BackGroundColor);
		
		// Windowsize
		if (Father.MayLibTable_Width > 0 && Father.MayLibTable_Height > 0)
			this.setBounds(Father.MayLibTable_X, Father.MayLibTable_Y, Father.MayLibTable_Width, Father.MayLibTable_Height);
		else
		{
			if (Father.MaximizeWindow.equalsIgnoreCase("big") || Father.MaximizeWindow.equalsIgnoreCase("all"))
			{
				makeFrameFullSize();		
			}
		}
		
		if (this.getWidth() > 859)
		{
			btnClose.setBounds(785, 5, 50, 25);
			btnClose.setVisible(true);
			btninvisible.setBounds(835, 5, 5, 25);
		}
		
		if (this.getWidth() > 909 && Mode.equalsIgnoreCase("Libref"))
		{
			btnCopy.setBounds(845, 5, 50, 25);
			btnCopy.setVisible(true);
			btninvisible.setBounds(895, 5, 5, 25);
		}
					
		statusBar.setText("Reading data...");
		setmyFontChild();
		showDataThread();

		miSave.setEnabled(Father.hasChanged);
		
		// activate /deactivate Report Menu
		menuReport.setEnabled(true);
		submenuAbstract.setEnabled(Mode.equalsIgnoreCase("Libref"));
		submenuReportType.setEnabled(true);
		miReportAllLibrefs.setEnabled(Mode.equalsIgnoreCase("Libref"));
		miReportAllPeriodicals.setEnabled(Mode.equalsIgnoreCase("Periodical"));
		miReportSelObjects.setEnabled(true);
		miWithoutAbstract.setEnabled(Mode.equalsIgnoreCase("Libref"));
		mi1000Abstract.setEnabled(Mode.equalsIgnoreCase("Libref"));
		mi2000Abstract.setEnabled(Mode.equalsIgnoreCase("Libref"));
		mi4000Abstract.setEnabled(Mode.equalsIgnoreCase("Libref"));
		miFullAbstract.setEnabled(Mode.equalsIgnoreCase("Libref"));
		miBasicReport.setEnabled(true);
		miCompleteReport.setEnabled(true);
		miGermanStandardReport.setVisible(Mode.equalsIgnoreCase("Libref"));
		miPalaeontologyReport.setVisible(Mode.equalsIgnoreCase("Libref"));
		miBullGeosciencesPragueReport.setVisible(Mode.equalsIgnoreCase("Libref"));
		
		miWithoutAbstract.setSelected(true);
		miBasicReport.setSelected(true);
		//miRepUnicode.setSelected(true);
		miRepeatSearch.setEnabled(false);
		miCleanRemarks.setVisible(Mode.equalsIgnoreCase("Libref"));
		miCopy.setVisible(Mode.equalsIgnoreCase("Libref"));
		
		//Defines charset of report
		if (Father.strexecRepCharset.equalsIgnoreCase("Default"))
		{
			this.miRepDefault.setSelected(true);
		}
		else if (Father.strexecRepCharset.equalsIgnoreCase("Unknown"))
		{
			this.miRepUnknown.setSelected(true);
		}
		else
		{
			this.miRepUnicode.setSelected(true);
		}

	}

	@Override
	public void actionPerformed(ActionEvent e)
	{

		if (e.getSource().equals(btnDelete))
			{
			int selectedRow = Tabelle.getSelectedRow();
			deleteEntry(Tabelle.getValueAt(selectedRow, 0));
		}
		
		else if (e.getSource().equals(btnEdit))
		{
			detailFormat("EDIT");
		}
		
		else if (e.getSource().equals(btnClose))
		{
			this.execSizeDispose();
		}
		
		else if (e.getSource().equals(btnCopy))
		{
			detailFormat("Copy Libref");
		}
		
		else if (e.getSource().equals(btnNewLibref))
			detailFormat("NEW Libref");
		else if (e.getSource().equals(btnNewPeriodical))
			detailFormat("NEW Periodical");

		else if (e.getSource().equals(btnReport))
		{				
			Father.createReport(MyTableTreeSet, this.Mode, this.getTitle(), "1000", "complete", "RPU", "UTF-16");
		}		

		
		else if (e.getSource().equals(btnQuitApp))
		{
			clickmiQuitApp();
		}
		
		else if (e.getSource().equals(miClose))
			windowClosing(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));

		else if (e.getSource().equals(miQuit))
			clickmiQuitApp();
		
		else if (e.getSource().equals(miSearchWord))
		{
			SearchWord();
		}	

		else if (e.getSource().equals(miCleanRemarks))
		{
			execCleanRemarks();
		}
		
		else if (e.getSource().equals(miSearchAbstract))
		{
			MayLibSearch f = MayLibSearch.getInstance(txarAbstract,	Father);
			f.showDialog(this);
		}	
		
		else if (e.getSource().equals(miRepeatSearch))
		{
			selectRowByValue(this.strSearchWord);
		}		
		
		else if (e.getSource().equals(miDelete))
		{
			int selectedRow = Tabelle.getSelectedRow();
			deleteEntry(Tabelle.getValueAt(selectedRow, 0));
		}
		
		else if (e.getSource().equals(miNew))
			detailFormat("NEW "+this.Mode);
		
		else if (e.getSource().equals(miEditRef))
			detailFormat("EDIT");
		
		else if (e.getSource().equals(miCopy))
			detailFormat("Copy Libref");
		
		else if (e.getSource().equals(miSave))	
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = Father.MayLibFile;
			
			if (Father.saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Changes in opened MayLib database saved (File: " + Father.lastWrittenFile +").", "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}

		else if (e.getSource().equals(miSaveAsUCF))	
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = null;
			
			if (Father.saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database saved sucessfully in the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}

		else if (e.getSource().equals(miSaveAsOther))	
		{
			String fileExtension = "TXT", Characterset = Father.Default_Charset;
			String Dateiname = null;
			
			if (Father.saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database exported sucessfully to the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveAsUnknown))	
		{
			String fileExtension = "TXT", Characterset = "UNKNOWN";
			String Dateiname = null;
			
			if (Father.saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database exported sucessfully to the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		


		else if (e.getSource().equals(miSaveSearchUCF))	
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			
			if (Father.saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Searched literature saved sucessfully in the MayLib file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}

		else if (e.getSource().equals(miSaveSearchOther))	
		{
			String fileExtension = "TXT", Characterset = Father.Default_Charset;
			
			if (Father.saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Searched literature exported sucessfully to the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveSearchUnknown))	
		{
			String fileExtension = "TXT", Characterset = "UNKNOWN";
			
			if (Father.saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Searched literature exported sucessfully to the file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveSearchCSV))	
		{
			String fileExtension = "CSV", Characterset = Father.Default_Charset;
			
			if (Father.saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Searched literature exported sucessfully to the CSV file " + Father.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
			
		// Reports
		else if (e.getSource().equals(miReportAllLibrefs)
				|| e.getSource().equals(miReportAllPeriodicals)
				|| e.getSource().equals(miReportSelObjects))	
		{
			/* Possible values of createReport(TreeSet<Object> ReportTreeSet, String ObjectType, String Headertext, String Abstract, String ReportType, String fileExtension, String Characterset)
			
			 * String ObjectType = Libref, Periodical
			 * String Headertext = null or a prepared text terminating without linefeed (linefeed will be added in the method createReport
			 * String Abstract  = without, 1000, full. Will be ignored, if ObjectType = Periodical
			 * String ReportType = basic, complete 
			 * String fileExtension = RPU, RPT
			 * String Characterset	= "UTF-16", Default_Charset, "UNKNOWN"	
		

			reportAllPeriodicals(String ReportType, String fileExtension, String Characterset)
			*/
			
			String Abstract ="without", ReportType = "basic", fileExtension ="RPT", Characterset =  Father.Default_Charset;
			
			if (miWithoutAbstract.isSelected())
				Abstract ="without";
			else if (mi1000Abstract.isSelected())
				Abstract ="1000";
			else if (mi2000Abstract.isSelected())
				Abstract ="2000";
			else if (mi4000Abstract.isSelected())
				Abstract ="4000";
			else if (miFullAbstract.isSelected())
				Abstract ="full";
				
			if (miBasicReport.isSelected())
				ReportType = "basic";
			else if (miCompleteReport.isSelected())
				ReportType = "complete";
			else if (miGermanStandardReport.isSelected())
				ReportType = "GermanStandard";
			else if (miPalaeontologyReport.isSelected())
				ReportType = "Palaeontology";
			else if (miBullGeosciencesPragueReport.isSelected())
				ReportType = "BullGeosciencesPrague";
			else 
				ReportType = "complete";
			
			if (miRepUnicode.isSelected())
			{
				fileExtension = "RPU";
				Characterset = "UTF-16";
				Father.execRepCharset("Unicode");
			}
			else if (miRepDefault.isSelected())
			{
				fileExtension ="RPT";
				Characterset =  Father.Default_Charset;
				Father.execRepCharset("Default");
			}
			else if (miRepUnknown.isSelected())
			{
				fileExtension ="RPT";
				Characterset =  "UNKNOWN";
				Father.execRepCharset("Unknown");
			}
			
			if (e.getSource().equals(miReportAllLibrefs))
				Father.reportAllLibrefs(Abstract, ReportType, fileExtension, Characterset);
			else if (e.getSource().equals(miReportAllPeriodicals))
				Father.reportAllPeriodicals(ReportType, fileExtension, Characterset);
			else 
			{	
				Father.createReport(this.MyTableTreeSet, this.Mode, this.Titletext, Abstract, ReportType, fileExtension, Characterset);
			}			
					
		}
	}

	@Override
	public void windowActivated(WindowEvent arg0)
	{
		miSave.setEnabled(Father.hasChanged);
		
	}

	@Override
	public void windowClosed(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowClosing(WindowEvent arg0)
	{
		this.execSizeDispose();
		
	}

	@Override
	public void windowDeactivated(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowDeiconified(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowIconified(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowOpened(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	@Override
	public void keyPressed(KeyEvent e)
	{
		if (e.getSource().equals(Tabelle))
		{
			int selectedRow = Tabelle.getSelectedRow();

			if (e.getKeyCode() == KeyEvent.VK_HOME)
				setSelectedRow(1);
			else if (e.getKeyCode() == KeyEvent.VK_END)
				setSelectedRow(Tabelle.getRowCount());
			else if (e.getKeyCode() == KeyEvent.VK_DELETE)
				deleteEntry(Tabelle.getValueAt(selectedRow, 0));
			else
			{
				if (e.getKeyCode() == KeyEvent.VK_ENTER)
				{
					e.consume();
					detailFormat("EDIT");
				}
			}
		}
		else
		{
			if (e.getKeyCode() == KeyEvent.VK_ENTER)
			{

				if (e.getSource().equals(btnDelete))
				{
					int selectedRow = Tabelle.getSelectedRow();
					deleteEntry(Tabelle.getValueAt(selectedRow, 0));
				}

				else if (e.getSource().equals(btnEdit))
				{
					detailFormat("EDIT");
				}

				else if (e.getSource().equals(btnNewLibref))
					detailFormat("NEW Libref");
				else if (e.getSource().equals(btnNewPeriodical))
					detailFormat("NEW Periodical");

				else if (e.getSource().equals(btnReport))
				{		
					Father.createReport(MyTableTreeSet, this.Mode, this.getTitle(), "1000", "complete", "RPU", "UTF-16");
				}		
				
				else if (e.getSource().equals(btnQuitApp))
				{
					clickmiQuitApp();
				}
				
				else if (e.getSource().equals(btnClose))
				{
					this.execSizeDispose();
				}
								
				else if (e.getSource().equals(btnCopy))
				{
					detailFormat("Copy Libref");
				}

			}
		}
	}


	@Override
	public void keyReleased(KeyEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	@Override
	public void keyTyped(KeyEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	@Override
	public void valueChanged(ListSelectionEvent e)
	{
		
		statusBar.setText(String.format("Data set %d of %d", Tabelle.getSelectedRow() + 1, Tabelle.getRowCount()));
		
		int selectedRow =Tabelle.getSelectedRow();
		
		if (selectedRow > -1 && this.Mode.equalsIgnoreCase("Periodical"))
		{
			Periodical PeriodicalObj = (Periodical)Tabelle.getValueAt(selectedRow, 0);
			txarAbstract.setText(PeriodicalObj.expComplete());
			txarAbstract.setCaretPosition(0);
		}
		
		else if (selectedRow > -1 && this.Mode.equalsIgnoreCase("Libref"))
		{
			Libref LibrefObj = (Libref)Tabelle.getValueAt(selectedRow, 0);
			txarAbstract.setText(LibrefObj.showComplete());
			txarAbstract.setCaretPosition(0);
		}
		
	}


	@Override
	public void mouseClicked(MouseEvent e)
	{
		// Doppelklick erkennen
		if(e.getClickCount() == 2)
		{
			detailFormat("EDIT");
		}
		
	}


	@Override
	public void mouseEntered(MouseEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	@Override
	public void mouseExited(MouseEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	@Override
	public void mousePressed(MouseEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}


	@Override
	public void mouseReleased(MouseEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}
	
	private void clickmiQuitApp()
	{
		// Prove if changes must be changed
		if (queryExit())
		{
		
			try
			{
				this.execSizeDispose();

				this.Father.dispose();
			}
			catch (Exception e)
			{
			}

		}
	}

	private boolean queryExit()
	{
			
		// Benutzerdefinierten Button Text
		Object[] options = {"Yes", "No", "Cancel"};
		
		if (!Father.hasChanged) return true;
		
		int retValue = JOptionPane.showOptionDialog(this, "The literature data have been changed.\nDo you want to save the changes?", "Save the changes?", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[2]);
		
		// Abbrechen ?
		if (retValue == 2) return false;
		
		// Ja - Speichern ?
		if (retValue == 0)
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = Father.MayLibFile;
			boolean result = Father.saveMayLib(Dateiname, fileExtension, Characterset);
			
			if (result==true)
			{
				JOptionPane.showMessageDialog(null, "Changes in opened MayLib database saved (File: " + Father.lastWrittenFile +").", "Data saved",
						JOptionPane.INFORMATION_MESSAGE);	
			}
			
			return result;
		}
		
		// Nein - Nicht speichern
		return true;			
	}

	protected void execSizeDispose()
	{
		Father.MayLibTable_X = this.getX();
		Father.MayLibTable_Y = this.getY();
		Father.MayLibTable_Width = this.getWidth();
		Father.MayLibTable_Height = this.getHeight();
		this.dispose();
	}
	
	private void execCleanRemarks()
	{

		Object[] options =
		{ "Yes", "No" };
		int retValue = JOptionPane.showOptionDialog(this, "Do you really want to clean the content of the field 'Remarks' in all references?",
				"Clean the field 'Remarks'", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[1]);
		// Nein - nicht lschen
		if (retValue != 0)
			return;
		
		// Aktuelle Zeile merken
		int selectedRow = Tabelle.getSelectedRow();
		
		if (Mode.equalsIgnoreCase("Libref"))
		{
			Iterator<Object> it = MyTableTreeSet.iterator();
			while (it.hasNext())
			{
				Libref LibrefObj = (Libref) it.next();
				LibrefObj.setRemarks("");
			}
		}

		Father.hasChanged = true;

		statusBar.setText("Reading data...");
		ShowData showData = new ShowData();
		showData.run();
		
		miSave.setEnabled(Father.hasChanged);

		// Auf die Zeile positionieren
		setSelectedRow(selectedRow+1);
		
	}
}
