package MayLib;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Insets;
import java.awt.KeyboardFocusManager;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
//import java.awt.event.ItemEvent;
//import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import java.nio.charset.Charset;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.Properties;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;

import javax.swing.JButton;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
//import javax.swing.ImageIcon;
//import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.Border;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileNameExtensionFilter;


public class MayLib_Start extends AbstractFrame implements ActionListener, WindowListener, KeyListener
{

	private static final long serialVersionUID = 1L;
	
	protected Font 		Plainfont, Boldfont, backGroundFont;
	private int 		fontSize;
	private JMenuBar	          menuBar;
	private JMenu	              menuFile, menuLibref, menuPeriodical, menuExtras, menuPreferences, submenuFontsize, submenuSaveAs;
	private JMenuItem             miQuit, miReadUCF, miReadOther, miAddUCF, miAddOther, miNew, miSave, miSaveAsOther, miSaveAsUCF,
									miReadUnknown, miAddUnknown, miSaveAsUnknown, miNewLibref, miNewPeriodical,
	 								miShowAllLibrefs, miShowAllPeriodicals, miShowSelLibrefs, miShowSelPeriodicals, miCopyright;
	private JRadioButtonMenuItem  mi10pt,mi11pt,mi12pt,mi13pt,mi14pt, mi15pt;
	private StatusBar	          statusBar;
	private ButtonGroup		      bgFontsize;
	private JLabel 				 jlabelSearchTitle, jlabelKeyword_2, jlabelTitlePartSearch, jlabelType, jlabelSearchPer, jlabelPerPeriodical;
	private JLabel				jlabelYearSearch, jlabelPeriodical, jlabelAuthor, jlabelYearStart, jlabelYearEnd, 
								jlabelKeyword, jlabelPartOf, jlabelRemarks;
	private JTextField			tfYearSearch, tfKeyword_2, tfTitlePartSearch, tfPerPeriodical, tfRemarks;
	private JButton				btnbackGroundLbl, btnExecLibrefSearch_Table, btnExecLibrefSearch_Tree, 
							btnExecLibrefSearch_Dictionary, btnExecLibrefSearch_Periodical, btnClearLibrefSearch;
	
	private JMenuItem	      miTreeLibref, miTreeDictionary, miTreePeriodical,
							  miMostRecent, miAllRecent, miMiniManual;
	
	//save search
	private JMenu	         submenuSaveSearch;
	private JMenuItem        miSaveSearchOther, miSaveSearchUCF, miSaveSearchUnknown, miSaveSearchCSV;
	
	
	//Menue Report
	private JMenu	              menuReport, submenuAbstract, submenuReportType;
	private JMenuItem             miReportAllLibrefs, miReportAllPeriodicals, miReportSelLibrefs, miReportSelPeriodicals;
	private JRadioButtonMenuItem  miWithoutAbstract, mi1000Abstract, miFullAbstract, miBasicReport, miCompleteReport;
	private JRadioButtonMenuItem  mi2000Abstract, mi4000Abstract;
	private ButtonGroup		      bgAbstract, bgReportType;
	
	//Addition to menue Report
	private JMenu	              submenuRepCharacterset;
	protected JRadioButtonMenuItem  miRepUnicode, miRepDefault, miRepUnknown;
	private ButtonGroup		      bgRepCharacterset;
	
	//Addition to menue Report
	private JRadioButtonMenuItem  miGermanStandardReport, miPalaeontologyReport, miBullGeosciencesPragueReport;
	
	//Addition to menue Preferences
	private JMenu	              submenuMaximize;
	private JRadioButtonMenuItem  miMaxNone, miMaxBig, miMaxAll;
	private ButtonGroup		      bgMaximize;
	protected String			  MaximizeWindow, strexecRepCharset;
	
	private JMenu	              submenuBackGroundColor;
	private JRadioButtonMenuItem  miBrown, miPink, miGreen, miYellow, miBlue, miGray;
	protected Color				  BackGroundColor;
	protected String 			  strBackGroundColor;
	private ButtonGroup		      bgBackGroundColor;

	// to store the data and show the lists 
	protected TreeMap < String, Libref > LibrefTree;
	protected TreeMap < String, Periodical > PeriodicalTree;
	
	protected TreeSet < Libref > QueriedLibrefSet;
	protected TreeSet < Periodical > QueriedPeriodicalSet;
	
	private ArrayList <String> LibrefHeader, PeriodicalHeader;	
	protected TreeSet <String> LibrefTypeSet;
	//LibrefTypes receives a set of standard types in "public ReadFileIntoLib"
	protected TreeSet <String> LibrefYearSet;
	protected TreeSet <String> LibrefAuthorSet;
	protected TreeSet <String> LibrefOtherAuthorsSet;
	protected TreeSet <String> LibrefKeywordSet;
	
	//For the search and for the comboboxes
	private JPanel		pnlLibrefsearch;
	private JComboBox				cboPeriodical, cboAuthor, cboYearStart, cboYearEnd, cboKeyword;
	private DefaultComboBoxModel	cboPeriodicalModel, cboAuthorModel, cboYearStartModel, cboYearEndModel, cboKeywordModel;
	private JComboBox				cboType, cboTextSeek;
	private DefaultComboBoxModel	cboTypeModel, cboTextSeekModel; 
	private String 					cboAuthorPreselection, cboKeywordPreselection, 
						cboPeriodicalPreselection, cboTypePreselection;
	
	private JButton	     btnReadUCF, btnSave, btnNewLibref, btnNewPeriodical, btnReport, btnQuitApp, btninvisible;
		
	private KeyboardFocusManager kbFocusManager;

	// to be able to recognize when data have changed and must be saved
	protected boolean hasChanged = false; 
	
	protected boolean needCleaningInternalLists = false, needpopulateCboOther = false, needpopulateCboPeriod = false; 
	
	private File fcFile = null; 
	
	// fcFile.toString() of the new opened Literature database
	protected String MayLibFile = null;
	protected String NameOfMayLibFile = null;
	private final String lineFeed = System.getProperty("line.separator");
	protected final String Default_Charset = Charset.defaultCharset().toString(); 
	private String Unknown_Encoding;
	protected String lastWrittenFile;
	protected String LibrefQueryCriteria;	
	static private String appConfigPath;
	
	//for defining the size and position of the different windows
	protected int LibrefDialog_X=0, LibrefDialog_Y=0, LibrefDialog_Width=-1, LibrefDialog_Height=-1,
			LibrefSplitPane_X=0, LibrefSplitPane_Y=0, LibrefSplitPane_Width=-1, LibrefSplitPane_Height=-1,
			MayLibTable_X=0, MayLibTable_Y=0, MayLibTable_Width=-1, MayLibTable_Height=-1,
			PeriodicalDialog_X=0, PeriodicalDialog_Y=0, PeriodicalDialog_Width=-1, PeriodicalDialog_Height=-1;
	
	public MayLib_Start()
	{
		initializeComponents();
	}
	
	private void setmyFont(int fntsz)
	{
		this.fontSize = fntsz;
		
		if (fntsz == 10)
			mi10pt.setSelected(true);
		else if (fntsz == 11)
			mi11pt.setSelected(true);
		else if (fntsz == 12)
			mi12pt.setSelected(true);
		else if (fntsz == 13)
			mi13pt.setSelected(true);
		else if (fntsz == 14)
			mi14pt.setSelected(true);
		else 
			mi15pt.setSelected(true);
		
		String fontFamily = this.getContentPane().getFont().getFamily();
		//int fontSize = this.fontLabel.getFont().getSize();
		
	    Plainfont = new Font(fontFamily, Font.PLAIN, this.fontSize);
	    Boldfont = new Font(fontFamily, Font.BOLD, this.fontSize);
			
		// Es scheint nicht zu funktionieren...
		this.setFont(Plainfont);
		
		this.getJMenuBar().setFont(Boldfont);		
		
		for (int i = 0; i < menuBar.getMenuCount(); i++)
		{
			menuBar.getMenu(i).setFont(Boldfont);
			setFontMenuItems(menuBar.getMenu(i));
		}
		
		setFontComponents(this.getContentPane());
		
		//special cases
		btnbackGroundLbl.setFont(backGroundFont);
		statusBar.setFont(Plainfont);
	}
	
	private void setFontMenuItems(JMenu m)
	{
		for (Component c : m.getMenuComponents())
		{
			// Der Separator hat keinen Text und keine Elemente
			if (c instanceof JMenuItem)
			{
				((JMenuItem)c).setFont(Boldfont);
				if (((JMenuItem)c).getSubElements().length > 0)
					setFontMenuItems((JMenu)c);
			}
		}
	}
	
	private void setFontComponents(Container container)
	{
		for (Component c : container.getComponents())
		{
			if (c instanceof JLabel)
				((JLabel)c).setFont(Boldfont);
			else if (c instanceof JButton)
				((JButton)c).setFont(Boldfont);
			else if (c instanceof JTextField)
				((JTextField) c).setFont(Plainfont);
			else if (c instanceof JComboBox)
				((JComboBox) c).setFont(Plainfont);
//			else if (c instanceof JTextArea)
//				((JTextArea) c).setFont(Plainfont);
			else if (c instanceof JPanel)
			{
				// Prfen, ob das Panel einen TitledBorder hat, dessen Text
				// dann ebenfalls bersetzt werden muss.
				Border b = ((JPanel)c).getBorder();
				if (b instanceof TitledBorder)
					((TitledBorder)b).setTitleFont(Plainfont);
					
				// Ein Panel ist ein Container und enthlt in aller Regel Komponenten
				setFontComponents((JPanel)c);
			}		
		}
	}

	@Override
	public void initializeComponents()
	{
		
		this.setTitle("MayLib (no open Literature database)");
		this.setBounds(10,  10,  800,  480);
		
		// Das Schlieen des Frames wird mit dem WindowListener berwacht. 
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		this.addWindowListener(this);
		
		this.setLayout(new BorderLayout());
		
		createApplicationMenu();
		
		statusBar = new StatusBar();
		this.add(statusBar, BorderLayout.PAGE_END);
		statusBar.setMessage("Ready to open or create Literature database");
		
		// Labels etc
		btnbackGroundLbl = new JButton("Welcome to MayLib - the textfile-based literature database ");
		btnbackGroundLbl.setHorizontalAlignment(JLabel.CENTER);
		btnbackGroundLbl.addActionListener(this);
		btnbackGroundLbl.addKeyListener(this);
		this.add(btnbackGroundLbl, BorderLayout.CENTER);
		
		
		// Instantiate the used lists
		LibrefTree = new TreeMap<String, Libref >();
		PeriodicalTree = new TreeMap<String, Periodical >();	
		
		QueriedLibrefSet = new TreeSet <Libref>();
		QueriedPeriodicalSet = new TreeSet <Periodical>();
		
		LibrefTypeSet = new TreeSet <String>();
		//LibrefTypes receives a set of standard types in "public ReadFileIntoLib"
		LibrefYearSet = new TreeSet <String>();	
		LibrefAuthorSet = new TreeSet <String>();	
		LibrefOtherAuthorsSet = new TreeSet <String>();	
		LibrefKeywordSet = new TreeSet <String>();
		
		// Define the header used in the Table of Librefs in MayLibTable.Java
		LibrefHeader = new ArrayList <String>();
		LibrefHeader.add("Libref_Object");
		LibrefHeader.add("Author_1");
		LibrefHeader.add("Author_2");
		LibrefHeader.add("Author_3");
		LibrefHeader.add("Author_4");
		LibrefHeader.add("Year");
		LibrefHeader.add("Editor");
		LibrefHeader.add("Title");
		LibrefHeader.add("In_Book_title");
		LibrefHeader.add("Periodical");
		LibrefHeader.add("Volume");
		LibrefHeader.add("Pages");
		LibrefHeader.add("Type");
		LibrefHeader.add("Keyword_1");
		LibrefHeader.add("Keyword_2");
		LibrefHeader.add("Keyword_3");
		LibrefHeader.add("Storing_place");
		LibrefHeader.add("Remarks");

		// Define the header used in the Table of Periodicals in MayLibTable.Java
		PeriodicalHeader = new ArrayList <String>();
		PeriodicalHeader.add("Periodical_Object");
		PeriodicalHeader.add("Name");	
		PeriodicalHeader.add("Place");	
		PeriodicalHeader.add("Abreviated_Name");	
		PeriodicalHeader.add("ISSN");	
		PeriodicalHeader.add("Language");	
		
		fillAuxiliaryTreeSets();
		
		// Panel
		pnlLibrefsearch = new JPanel(null);
		pnlLibrefsearch.setPreferredSize(new Dimension(790, 410));
		this.add(pnlLibrefsearch,  BorderLayout.PAGE_START);
		
		jlabelSearchTitle = new JLabel("Filters for searching literature references:");
		jlabelSearchTitle.setBounds(10, 10, 630, 25);
		jlabelSearchTitle.setName("SearchTitle");
		pnlLibrefsearch.add(jlabelSearchTitle);
		
		btnClearLibrefSearch = new JButton("Clear Search");
		btnClearLibrefSearch.setBounds(645, 10, 130, 25);
		btnClearLibrefSearch.setMargin(new Insets(1, 1, 1, 1));
		btnClearLibrefSearch.setBackground(Color.RED);
		btnClearLibrefSearch.addActionListener(this);
		btnClearLibrefSearch.addKeyListener(this);
		pnlLibrefsearch.add(btnClearLibrefSearch);
		
		// For the combobox
		// Author
		jlabelAuthor = new JLabel("Filter for Author");
		jlabelAuthor.setBounds(10, 40, 140, 25);
		jlabelAuthor.setName("FilterAuthor");
		pnlLibrefsearch.add(jlabelAuthor);
		
		cboAuthorModel = new DefaultComboBoxModel();
		cboAuthor = new JComboBox(cboAuthorModel);
		cboAuthor.setBounds(150, 40, 625, 25);
		cboAuthor.addKeyListener(this);
		pnlLibrefsearch.add(cboAuthor);
		
		// For the combobox
		// Keyword
		jlabelKeyword = new JLabel("Filter for Keyword");
		jlabelKeyword.setBounds(10, 70, 140, 25);
		jlabelKeyword.setName("FilterKeyword");
		pnlLibrefsearch.add(jlabelKeyword);

		cboKeywordModel = new DefaultComboBoxModel();
		cboKeyword = new JComboBox(cboKeywordModel);
		cboKeyword.setBounds(150, 70, 625, 25);
		cboKeyword.addKeyListener(this);
		pnlLibrefsearch.add(cboKeyword);
		
		jlabelPartOf = new JLabel("Letters of...");
		jlabelPartOf.setBounds(10, 100, 90, 25);
		jlabelPartOf.setName("PartOf");
		pnlLibrefsearch.add(jlabelPartOf);
		
		jlabelKeyword_2 = new JLabel("Keyword");
		jlabelKeyword_2.setBounds(100, 100, 70, 25);
		jlabelKeyword_2.setName("Keyword_2");
		pnlLibrefsearch.add(jlabelKeyword_2);

		tfKeyword_2 = new JTextField();
		tfKeyword_2.setBounds(170, 100, 240, 25);
		tfKeyword_2.setName("Keyword_2");
		tfKeyword_2.setMargin(new Insets(1, 1, 1, 1));
		pnlLibrefsearch.add(tfKeyword_2);
				
		jlabelRemarks = new JLabel("Remarks");
		jlabelRemarks.setBounds(435, 100, 75, 25);
		jlabelRemarks.setName("Remarks");
		pnlLibrefsearch.add(jlabelRemarks);

		tfRemarks = new JTextField();
		tfRemarks.setBounds(510, 100, 265, 25);
		tfRemarks.setName("Remarks");
		tfRemarks.setMargin(new Insets(1, 1, 1, 1));
		pnlLibrefsearch.add(tfRemarks);

		// For the combobox
		// YearStart
		jlabelYearStart = new JLabel("From year");
		jlabelYearStart.setBounds(10, 130, 90, 25);
		jlabelYearStart.setName("FilterYearStart");
		pnlLibrefsearch.add(jlabelYearStart);

		cboYearStartModel = new DefaultComboBoxModel();
		cboYearStart = new JComboBox(cboYearStartModel);
		cboYearStart.setBounds(100, 130, 100, 25);
		pnlLibrefsearch.add(cboYearStart);

		// For the combobox
		// YearEnd
		jlabelYearEnd = new JLabel("to year");
		jlabelYearEnd.setBounds(220, 130, 80, 25);
		jlabelYearEnd.setName("FilterYearEnd");
		pnlLibrefsearch.add(jlabelYearEnd);
		
		cboYearEndModel = new DefaultComboBoxModel();
		cboYearEnd = new JComboBox(cboYearEndModel);
		cboYearEnd.setBounds(300, 130, 100, 25);
		pnlLibrefsearch.add(cboYearEnd);
		
		jlabelYearSearch = new JLabel("First digits of a year");
		jlabelYearSearch.setBounds(480, 130, 180, 25);
		jlabelYearSearch.setName("YearSearch");
		pnlLibrefsearch.add(jlabelYearSearch);

		tfYearSearch = new JTextField();
		tfYearSearch.setBounds(660, 130, 100, 25);
		tfYearSearch.setName("YearSearch");
		tfYearSearch.setMargin(new Insets(1, 1, 1, 1));
		pnlLibrefsearch.add(tfYearSearch);		
		
		jlabelTitlePartSearch = new JLabel("Letters of");
		jlabelTitlePartSearch.setBounds(10, 160, 260, 25);
		jlabelTitlePartSearch.setName("TitlePartSearch");
		pnlLibrefsearch.add(jlabelTitlePartSearch);
		
		cboTextSeekModel = new DefaultComboBoxModel();
		cboTextSeek = new JComboBox(cboTextSeekModel);
		cboTextSeek.setBounds(100, 160, 220, 25);
		pnlLibrefsearch.add(cboTextSeek);
		cboTextSeekModel.addElement("Title (or In Book Title)");
		cboTextSeekModel.addElement("Title, In Book Title or Abstract");
		cboTextSeek.setSelectedIndex(0);

		tfTitlePartSearch = new JTextField();
		tfTitlePartSearch.setBounds(328, 160, 447, 25);
		tfTitlePartSearch.setName("TitlePartSearch");
		tfTitlePartSearch.setMargin(new Insets(1, 1, 1, 1));
		pnlLibrefsearch.add(tfTitlePartSearch);

		// For the combobox
		// Type
		jlabelType = new JLabel("Filter for Type");
		jlabelType.setBounds(10, 190, 140, 25);
		jlabelType.setName("FilterType");
		pnlLibrefsearch.add(jlabelType);

		cboTypeModel = new DefaultComboBoxModel();
		cboType = new JComboBox(cboTypeModel);
		cboType.setBounds(150, 190, 625, 25);
		cboType.addKeyListener(this);
		pnlLibrefsearch.add(cboType);

		// For the combobox
		// Periodical
		jlabelPeriodical = new JLabel("Filter for Periodical");
		jlabelPeriodical.setBounds(10, 220, 140, 25);
		jlabelPeriodical.setName("FilterPeriodical");
		pnlLibrefsearch.add(jlabelPeriodical);

		cboPeriodicalModel = new DefaultComboBoxModel();
		cboPeriodical = new JComboBox(cboPeriodicalModel);
		cboPeriodical.setBounds(150, 220, 625, 25);
		cboPeriodical.addKeyListener(this);
		pnlLibrefsearch.add(cboPeriodical);
		
		// BUTTONS
		btnExecLibrefSearch_Table = new JButton("Search result as TABLE");
		btnExecLibrefSearch_Table.setBounds(10, 250, 246, 25);
		btnExecLibrefSearch_Table.addActionListener(this);
		btnExecLibrefSearch_Table.addKeyListener(this);
		pnlLibrefsearch.add(btnExecLibrefSearch_Table);

		btnExecLibrefSearch_Tree = new JButton("Search result as TREE");
		btnExecLibrefSearch_Tree.setBounds(268, 250, 246, 25);
		btnExecLibrefSearch_Tree.addActionListener(this);
		btnExecLibrefSearch_Tree.addKeyListener(this);
		pnlLibrefsearch.add(btnExecLibrefSearch_Tree);		

		btnExecLibrefSearch_Dictionary = new JButton("Search result as Dictionary");
		btnExecLibrefSearch_Dictionary.setBounds(526, 250, 247, 25);
		btnExecLibrefSearch_Dictionary.addActionListener(this);
		btnExecLibrefSearch_Dictionary.addKeyListener(this);
		pnlLibrefsearch.add(btnExecLibrefSearch_Dictionary);
		
		////////////////////////////
		
		jlabelSearchPer = new JLabel("Filter for seeking periodical(s):");
		jlabelSearchPer.setBounds(10, 290, 770, 25);
		jlabelSearchPer.setName("SearchPer");
		pnlLibrefsearch.add(jlabelSearchPer);
		
		jlabelPerPeriodical = new JLabel("Letters of a Periodical");
		jlabelPerPeriodical.setBounds(10, 320, 165, 25);
		jlabelPerPeriodical.setName("PerPeriodical");
		pnlLibrefsearch.add(jlabelPerPeriodical);

		tfPerPeriodical = new JTextField();
		tfPerPeriodical.setBounds(175, 320, 341, 25);
		tfPerPeriodical.setName("PerPeriodical");
		tfPerPeriodical.setMargin(new Insets(1, 1, 1, 1));
		pnlLibrefsearch.add(tfPerPeriodical);

		btnExecLibrefSearch_Periodical = new JButton("Sought periodical as TREE");
		btnExecLibrefSearch_Periodical.setBounds(526, 320, 247, 25);
		btnExecLibrefSearch_Periodical.addActionListener(this);
		btnExecLibrefSearch_Periodical.addKeyListener(this);
		pnlLibrefsearch.add(btnExecLibrefSearch_Periodical);
		
		//Buttons
		  		
				btnReadUCF = new JButton("Open MayLib");
				btnReadUCF.setBounds(5, 365, 120, 25);
				btnReadUCF.setMargin(new Insets(2, 2, 2, 2));
				btnReadUCF.setName("ReadUCF");
				btnReadUCF.addActionListener(this);
				btnReadUCF.addKeyListener(this);
				pnlLibrefsearch.add(btnReadUCF);

				btnSave = new JButton("Save MayLib");
				btnSave.setName("Save");
				btnSave.setBounds(135, 365, 120, 25);
				btnSave.setMargin(new Insets(2, 2, 2, 2));
				btnSave.addActionListener(this);
				btnSave.addKeyListener(this);
				pnlLibrefsearch.add(btnSave);
				
				btnNewLibref = new JButton("New Literature");
				btnNewLibref.setBounds(265, 365, 120, 25);
				btnNewLibref.setMargin(new Insets(2, 2, 2, 2));
				btnNewLibref.setName("New Literature");
				btnNewLibref.addKeyListener(this);
				btnNewLibref.addActionListener(this);
				pnlLibrefsearch.add(btnNewLibref);

				btnNewPeriodical = new JButton("New Periodical");
				btnNewPeriodical.setName("New Periodical");
				btnNewPeriodical.setBounds(395, 365, 120, 25);
				btnNewPeriodical.setMargin(new Insets(2, 2, 2, 2));
				btnNewPeriodical.addActionListener(this);
				btnNewPeriodical.addKeyListener(this);
				pnlLibrefsearch.add(btnNewPeriodical);

				btnReport = new JButton("Report");
				btnReport.setName("Report");
				btnReport.setBounds(525, 365, 120, 25);
				btnReport.setMargin(new Insets(2, 2, 2, 2));
				btnReport.addActionListener(this);
				btnReport.addKeyListener(this);
				pnlLibrefsearch.add(btnReport);

				btnQuitApp = new JButton("Quit application");
				btnQuitApp.setName("Quit");
				btnQuitApp.setBounds(655, 365, 120, 25);
				btnQuitApp.setMargin(new Insets(2, 2, 2, 2));
				btnQuitApp.addActionListener(this);
				btnQuitApp.addKeyListener(this);
				pnlLibrefsearch.add(btnQuitApp);
				
				btninvisible = new JButton("invisible");
				btninvisible.setBounds(775, 365, 5, 25);
				btninvisible.setVisible(false);
				pnlLibrefsearch.add(btninvisible);
	}
	
	private void createApplicationMenu()
	{
		menuBar = new JMenuBar();
		this.setJMenuBar(menuBar);
		
		menuFile = this.createMenu(menuBar, "File", "menuFile", 'F');
		miNew = this.createMenuItem(menuFile, "miNew", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Create new MayLib", null, 'C', "Creates a new MayLib");
		menuFile.addSeparator();
		miReadUCF = this.createMenuItem(menuFile, "miReadUCF", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Open MayLib file (*.ucf)...", null, 'M', "Opens a MayLib file (*.ucf) or another file with Unicode character set");
		miReadOther = this.createMenuItem(menuFile, "miReadOther", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Open other file...", null, 'o', "Opens a file with the system default character set");
		miReadUnknown = this.createMenuItem(menuFile, "miReadUnknown", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Open unknown file...", null, 0, "Opens a file with an unknown character set");
		menuFile.addSeparator();
		miAddUCF = this.createMenuItem(menuFile, "miAddUCF", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Add MayLib file (*.ucf) to open MayLib...", null, 'u', "Adds a MayLib file (*.ucf) or another file with Unicode character set to the opened MayLib Database");
		miAddOther = this.createMenuItem(menuFile, "miAddOther", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Add other file to open MayLib...", null, 't', "Adds a file with the system default character set to the opened MayLib Database");
		miAddUnknown = this.createMenuItem(menuFile, "miAddUnknown", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Add unknown file to open MayLib...", null, 0, "Adds a file with an unknown character set to the opened MayLib Database");
		menuFile.addSeparator();
		miSave = this.createMenuItem(menuFile, "miSave", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Save opened MayLib file (*.ucf)", null, 'S', "Saves the opened MayLib as MayLib file (*.ucf) under the same name");
		submenuSaveAs = this.createSubMenue(menuFile, "Save opened MayLib as...", "submenuSaveAs", 'a');
		miSaveAsUCF = this.createMenuItem(submenuSaveAs, "miSaveAsUCF", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "MayLib file (*.ucf)", null, 'b', "Saves the opened MayLib as MayLib file (*.ucf) under another name");
		miSaveAsOther = this.createMenuItem(submenuSaveAs, "miSaveAsOther", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "System default character set", null, 'y', "Saves the opened MayLib as a file with the system default character set under another name");
		miSaveAsUnknown = this.createMenuItem(submenuSaveAs, "miSaveAsUnknown", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Unknown character set", null, 0, "Saves the opened MayLib as a file with the character set for opened files with an unknown character set");

		//save search
		menuFile.addSeparator();
		submenuSaveSearch = this.createSubMenue(menuFile, "Save sought literature in...", "submenuSaveSearch", 'g');
		miSaveSearchUCF = this.createMenuItem(submenuSaveSearch, "miSaveSearchUCF", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "MayLib file (*.ucf)", null, 0, 
				"Saves the literature searched for as MayLib file (*.ucf) under another name. NOTE: Periodicals without Literature references will not be included!");
		miSaveSearchOther = this.createMenuItem(submenuSaveSearch, "miSaveSearchOther", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "System default character set", null, 0, 
				"Saves the literature searched for as a MayLib-like file with the system default character set under another name. NOTE: Periodicals without Literature references will not be included!");
		miSaveSearchUnknown = this.createMenuItem(submenuSaveSearch, "miSaveSearchUnknown", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Unknown character set", null, 0, 
				"Saves the literature searched for as a  MayLib-like file with the character set for opened files with an unknown character set. NOTE: Periodicals without Literature references will not be included!");
		miSaveSearchCSV = this.createMenuItem(submenuSaveSearch, "miSaveSearchCSV", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "CSV file (can be read by Excel)", null, 0, 
				"Saves the literature searched for as a CSV file which can be read by Excel. NOTE: Periodicals without Literature references will not be included!");
				
		menuFile.addSeparator();		
		miQuit = this.createMenuItem(menuFile, "miQuit", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Quit application", null, 'Q', "Quits the program/application");
		
		menuLibref = this.createMenu(menuBar, "Literature references", "menuLibref", 'L');
		miNewLibref = this.createMenuItem(menuLibref, "miNewLibref", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "New Literature reference", null, 'N',
				"Opens window to create a new literature reference");
		menuLibref.addSeparator();
		miMostRecent = this.createMenuItem(menuLibref, "miMostRecent", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Most recently created literature reference", null, 'M', "Searches for the most recently created literature reference and shows it in a list");
		miAllRecent = this.createMenuItem(menuLibref, "miAllRecent", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "All recently created literature references", null, 'r', "Searches for all recently created literature references and shows them in a list");
		menuLibref.addSeparator();
		miShowAllLibrefs = this.createMenuItem(menuLibref, "miShowAllLibrefs", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "List all literature", null, 'a', "Opens a list which shows all literature references");
		miShowSelLibrefs = this.createMenuItem(menuLibref, "miShowSelLibrefs", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "List sought literature", null, 's', "Opens a list which shows the literature references searched for");
		menuLibref.addSeparator();
		miTreeLibref = this.createMenuItem(menuLibref, "miTreeLibref", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Sought literature as tree", null, 't', "Opens a tree which shows the literature references searched for");
		miTreeDictionary = this.createMenuItem(menuLibref, "miTreeDictionary", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Sought literature as dictionary", null, 'd', "Opens a tree which shows a dictionary of the literature references searched for");
		
		menuPeriodical = this.createMenu(menuBar, "Periodicals", "menuPeriodical", 'P');
		miNewPeriodical = this.createMenuItem(menuPeriodical, "miNewPeriodical", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "New Periodical", null, 'N',
				"Opens window to create a new Periodical");
		menuPeriodical.addSeparator();
		miShowAllPeriodicals = this.createMenuItem(menuPeriodical, "miShowAllPeriodicals", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "List all periodicals", null, 'a', "Opens a window which shows all periodicals");
		miShowSelPeriodicals = this.createMenuItem(menuPeriodical, "miShowSelPeriodicals", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "List sought periodicals", null, 's', "Opens a window which shows the periodicals searched for");
		menuPeriodical.addSeparator();
		miTreePeriodical = this.createMenuItem(menuPeriodical, "miTreePeriodical", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Sought periodicals as tree", null, 't', "Opens a tree which shows the literature references searched for ordered by periodical, year and volume");
		
		menuReport = this.createMenu(menuBar, "Report", "menuReport", 'R');
		miReportAllLibrefs = this.createMenuItem(menuReport, "miReportAllLibrefs", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Report all literature", null, 'l', "Creates a report of all literature references");
		miReportAllPeriodicals = this.createMenuItem(menuReport, "miReportAllPeriodicals", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Report all periodicals", null, 'p', "Creates a report of all periodicals");
		miReportSelLibrefs = this.createMenuItem(menuReport, "miReportSelLibrefs", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Report sought literature", null, 'i', "Creates a report of the literature searched for");
		miReportSelPeriodicals = this.createMenuItem(menuReport, "miReportSelPeriodical", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Report sought periodicals", null, 'o', "Creates a report of the periodicals searched for");
		menuReport.addSeparator();
		submenuAbstract = this.createSubMenue(menuReport, "Include Abstract?",  "submenuAbstract", 'i');
		miWithoutAbstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "miWithoutAbstract", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Without abstract", null, 'W', "The resulting report does not contain any abstract");
		mi1000Abstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "mi1000Abstract", AbstractFrame.MenuItemType.ITEM_RADIO, this, "1000 characters", null, '1', "The resulting report contains the first 1000 characters of the abstract, if it is a literature references report");
		mi2000Abstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "mi2000Abstract", AbstractFrame.MenuItemType.ITEM_RADIO, this, "2000 characters", null, '2', "The resulting report contains the first 2000 characters of the abstract, if it is a literature references report");
		mi4000Abstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "mi4000Abstract", AbstractFrame.MenuItemType.ITEM_RADIO, this, "4000 characters", null, '4', "The resulting report contains the first 4000 characters of the abstract, if it is a literature references report");
		miFullAbstract = (JRadioButtonMenuItem)this.createMenuItem(submenuAbstract, "miFullAbstract", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Full abstract", null, 'F', "The resulting report contains the full abstract, if it is a literature references report");
		submenuReportType = this.createSubMenue(menuReport, "Type of Report",  "submenuReportType", 'T');
		miBasicReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miBasicReport", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Basic report", null, 'B', "A short report with the most relevant information");
		miCompleteReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miCompleteReport", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Complete report", null, 'C', "A complete report with all information");
		bgAbstract = new ButtonGroup();
		bgAbstract.add(miWithoutAbstract);
		bgAbstract.add(mi1000Abstract);
		bgAbstract.add(mi2000Abstract);
		bgAbstract.add(mi4000Abstract);
		bgAbstract.add(miFullAbstract);
		bgReportType = new ButtonGroup();
		bgReportType.add(miBasicReport);
		bgReportType.add(miCompleteReport);
		//Addition to menue Report
		miGermanStandardReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miGermanStandardReport", AbstractFrame.MenuItemType.ITEM_RADIO, this, "German Standard report", null, 'G', "Detailed literature reference in German style");
		miPalaeontologyReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miPalaeontologyReport", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Palaeontology report", null, 'P', "Literature reference in 'Palaeontology (London)' style");
		miBullGeosciencesPragueReport = (JRadioButtonMenuItem)this.createMenuItem(submenuReportType, "miBullGeosciencesPragueReport", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Bulletin Geosciences Prague report", null, 'u', "Literature reference in 'Bulletin of Geosciences (Prague)' style");
		bgReportType.add(miBullGeosciencesPragueReport);
		bgReportType.add(miGermanStandardReport);
		bgReportType.add(miPalaeontologyReport);
		//Addition to menue Report
		submenuRepCharacterset = this.createSubMenue(menuReport, "Characterset of the report",  "submenuRepCharacterset", 'h');
		miRepUnicode = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepUnicode", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Unicode (*.RPU)", null, 'U', "The resulting report will be written with Unicode character set. The default file extension is *.RPU");
		miRepDefault = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepDefault", AbstractFrame.MenuItemType.ITEM_RADIO, this, "System default character set (*.RPT)", null, 'y', "The resulting report will be written with the default system character set. The default file extension is *.RPT");
		miRepUnknown = (JRadioButtonMenuItem)this.createMenuItem(submenuRepCharacterset, "miRepUnknown", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Unknown character set (*.RPT)", null, 0, "The resulting report will be written with the character set used by the last file imported with UNKNOWN character set. The default file extension is *.RPT");
		bgRepCharacterset = new ButtonGroup();
		bgRepCharacterset.add(miRepUnicode);
		bgRepCharacterset.add(miRepDefault);
		bgRepCharacterset.add(miRepUnknown);	
		
		menuPreferences = this.createMenu(menuBar, "Preferences", "menuPreferences", 'n');
		submenuFontsize = this.createSubMenue(menuPreferences, "Fontsize",  "submenuFontsize", 'z');
		mi10pt = (JRadioButtonMenuItem)this.createMenuItem(submenuFontsize, "mi10pt", AbstractFrame.MenuItemType.ITEM_RADIO, this, "10 pt", null, '0', null);
		mi11pt = (JRadioButtonMenuItem)this.createMenuItem(submenuFontsize, "mi11pt", AbstractFrame.MenuItemType.ITEM_RADIO, this, "11 pt", null, '1', null);
		mi12pt = (JRadioButtonMenuItem)this.createMenuItem(submenuFontsize, "mi12pt", AbstractFrame.MenuItemType.ITEM_RADIO, this, "12 pt", null, '2', null);
		mi13pt = (JRadioButtonMenuItem)this.createMenuItem(submenuFontsize, "mi13pt", AbstractFrame.MenuItemType.ITEM_RADIO, this, "13 pt", null, '3', null);
		mi14pt = (JRadioButtonMenuItem)this.createMenuItem(submenuFontsize, "mi14pt", AbstractFrame.MenuItemType.ITEM_RADIO, this, "14 pt", null, '4', null);
		mi15pt = (JRadioButtonMenuItem)this.createMenuItem(submenuFontsize, "mi15pt", AbstractFrame.MenuItemType.ITEM_RADIO, this, "15 pt", null, '5', null);
		bgFontsize = new ButtonGroup();
		bgFontsize.add(mi10pt);
		bgFontsize.add(mi11pt);
		bgFontsize.add(mi12pt);
		bgFontsize.add(mi13pt);
		bgFontsize.add(mi14pt);
		bgFontsize.add(mi15pt);
		
		menuPreferences.addSeparator();
		submenuBackGroundColor = this.createSubMenue(menuPreferences, "Color of the background",  "submenuBackGroundColor", 'C');
		bgBackGroundColor = new ButtonGroup();
		miBrown = (JRadioButtonMenuItem)this.createMenuItem(submenuBackGroundColor, "miBrown", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Palaeontologist's choice", null, 'P', null);
		miPink = (JRadioButtonMenuItem)this.createMenuItem(submenuBackGroundColor, "miPink", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Elisabet's favorite", null, 'E', null);
		miGreen = (JRadioButtonMenuItem)this.createMenuItem(submenuBackGroundColor, "miGreen", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Springtime", null, 'g', null);
		miYellow = (JRadioButtonMenuItem)this.createMenuItem(submenuBackGroundColor, "miYellow", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Fresh lemon", null, 0, null);
		miBlue = (JRadioButtonMenuItem)this.createMenuItem(submenuBackGroundColor, "miBlue", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Sky over Madrid", null, 0, null);
		miGray = (JRadioButtonMenuItem)this.createMenuItem(submenuBackGroundColor, "mi", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Boring", null, 0, null);
		bgBackGroundColor.add(miBrown);
		bgBackGroundColor.add(miPink);
		bgBackGroundColor.add(miGreen);
		bgBackGroundColor.add(miYellow);
		bgBackGroundColor.add(miBlue);
		bgBackGroundColor.add(miGray);
		
		menuPreferences.addSeparator();
		submenuMaximize = this.createSubMenue(menuPreferences, "Maximize Windows",  "submenuMaximize", 'm');
		miMaxNone = (JRadioButtonMenuItem)this.createMenuItem(submenuMaximize, "miMaxNone", AbstractFrame.MenuItemType.ITEM_RADIO, this, "None", null, 'o', "No window at all will be maximized to fit almost screen size");
		miMaxBig = (JRadioButtonMenuItem)this.createMenuItem(submenuMaximize, "miMaxBig", AbstractFrame.MenuItemType.ITEM_RADIO, this, "Only big windows", null, 'b', "Only the big windows with extensable elements will be maximized to fit almost screen size");
		miMaxAll = (JRadioButtonMenuItem)this.createMenuItem(submenuMaximize, "miMaxAll", AbstractFrame.MenuItemType.ITEM_RADIO, this, "All windows", null, 'A', "All windows will be maximized to fit almost screen size");
		bgMaximize = new ButtonGroup();
		bgMaximize.add(miMaxNone);
		bgMaximize.add(miMaxBig);
		bgMaximize.add(miMaxAll);
		
		menuExtras = this.createMenu(menuBar, "Extras", "menuExtras", 'x');		
		miCopyright = this.createMenuItem(menuExtras, "miCopyright", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Copyright", null, 'C', null);	
		miMiniManual = this.createMenuItem(menuExtras, "miMiniManual", AbstractFrame.MenuItemType.ITEM_PLAIN, this, "Mini-Manual", null, 'M', null);
	
	}
	
	private void openFileDialog(String Characterset)
	{	
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(fcFile);
		
		if (!Characterset.equalsIgnoreCase("UTF-16"))
			fc.setFileFilter(new  FileNameExtensionFilter("Text and csv files(*.txt, *.csv)", "*.txt", "txt", "*.csv", "csv"));
		
		if (Characterset.equalsIgnoreCase("UTF-16"))
			fc.setFileFilter(new  FileNameExtensionFilter("MayLib files (*.ucf)", "*.ucf", "ucf"));
		
		if (fc.showOpenDialog(this) != JFileChooser.APPROVE_OPTION) return;
		
		if (needCleaningInternalLists == true) 
			cleanInternalLists();
		
	    fcFile = fc.getSelectedFile();
	  
		readFile(fcFile, Characterset);		
	}
			
		
	
	private boolean saveDataDialog(String fileExtension, String Characterset, String saveString)
	{
		File f = null;
		String Dateiname;
		int dlgValue = 0;
		
		// Benutzerdefinierte Buttontexte
		Object[] options = {"Yes", "No"};
		
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(fcFile);
		
		if (fileExtension.equalsIgnoreCase("TXT"))
			fc.setFileFilter(new  FileNameExtensionFilter("Text and csv files(*.txt, *.csv)", "*.txt", "txt", "*.csv", "csv"));
		
		else if (fileExtension.equalsIgnoreCase("UCF"))
			fc.setFileFilter(new  FileNameExtensionFilter("MayLib files (*.ucf)", "*.ucf", "ucf"));

		else if (fileExtension.equalsIgnoreCase("RPU"))
			fc.setFileFilter(new FileNameExtensionFilter("Unicode Reports (*.rpu)", "*.rpu", "rpu"));
		
		else if (fileExtension.equalsIgnoreCase("RPT"))
			fc.setFileFilter(new FileNameExtensionFilter("Non-Unicode Reports (*.rpt)", "*.rpt", "rpt"));
		
		else if (fileExtension.equalsIgnoreCase("CSV"))
			fc.setFileFilter(new FileNameExtensionFilter("CSV files(*.csv)", "*.csv", "csv"));
		
		
		if (fc.showSaveDialog(this) != JFileChooser.APPROVE_OPTION) return false; 
	    
	    Dateiname = fc.getSelectedFile().toString();

		// Dateierweiterung ermitteln.
		// Nicht jede Plattform benutzt Dateierweiterungen wie Windows.
		// Deshalb gibt es auch keine Methode um die Dateierweitrerung zu ermitteln.
		
		// Grundstzlich die Endung ".txt" verwenden
		//	if (!Dateiname.toLowerCase().endsWith(".txt"))
		//		Dateiname += ".txt";
		
		// Allgemeine Variante
	    
		if (Dateiname.lastIndexOf('.') < 0)
			Dateiname += "."+fileExtension.toLowerCase();
		
		
		// berprfen, ob die Datei bereits vorhanden ist.
		f = new File(Dateiname);
		if (f.exists() && f.isFile())
		{
			dlgValue = JOptionPane.showOptionDialog(this, "The file '" + Dateiname + 
					"' already exists.\nDo you want to overwrite it?", "Save data",
					JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[1]);
		}

		if (dlgValue != 0)
			return false;
	    
	    statusBar.setMessage("Writing "+fcFile.toString());
	    
	    return  writeData(Dateiname, Characterset, saveString);		
	}
	
	private void readFile(File readFile, String Characterset)
	{
		if (this.hasChanged)
		{
			// Benutzerdefinierte Button Texte
			Object[] options ={ "Yes", "No" };

			int retValue = JOptionPane.showOptionDialog(this, "Your still opened Literature database has unsaved changes.\n Do you want to save it before you open a another Literature database?", "Unsaved changes",
					JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[0]);
			
			if (retValue == 0) 
			{
				if (!saveMayLib(MayLibFile, "UCF", "UTF-16")) return;
			}
		}

		statusBar.setMessage("Reading "+readFile.toString());
		// Thread zum Einlesen der Postleitzahlen verwenden.
		Thread t = new Thread(new ReadFileIntoLib(readFile, Characterset));
		t.start();		
	}
	
	
	private void fillAuxiliaryTreeSets()
	{
		// Three auxiliary TreeSets are filled
		LibrefAuthorSet.add("et al.");

		// LibrefTypes receives a set of standard types in
		// "public ReadFileIntoLib"
		LibrefTypeSet.add("Reprint");
		LibrefTypeSet.add("Book");
		LibrefTypeSet.add("Complete photocopies");
		LibrefTypeSet.add("Incomplete photocopies");
		LibrefTypeSet.add("Article in book");
		LibrefTypeSet.add("PDF file");
		LibrefTypeSet.add("NOT in library");
		LibrefTypeSet.add("- PDF file & Reprint/Copy");
		
		//This must be added to avoid an error in creating the combobox if the database is empty
		LibrefYearSet.add("2000");
	}

	private class ReadFileIntoLib implements Runnable
	{
		private String Dateiname;
		private String Characterset;
		private String zeile = null;
		private String[] split;
		private File readFile;
		int readFileLength = 0;
		
		int addLibrefCounter = 0;
		int addPeriodicalCounter = 0;
		int readCounter = 0;
		int codeCounter = 0;
		
		ProgressWindow progressWindow;
		
		public ReadFileIntoLib(File readFile, String Characterset)
		{
			this.readFile = readFile;
			this.Dateiname = readFile.toString();	
			this.Characterset = Characterset;
			this.readFileLength = (int) readFile.length();
			
			
			if (readFileLength > 1000000)
			{
			// Fortschrittsanzeige vorbereiten und sichtbar machen
			progressWindow = new ProgressWindow(MayLib_Start.this);
			progressWindow.setMaxValue(readFileLength);
			progressWindow.setValue(0);
			}
			
			fillAuxiliaryTreeSets();
			
		}
		
		private void errorAdviceLength(String Attribute, int readCounter, int MaximalLength, int RealLength, String OffendingText)
		{
			Toolkit.getDefaultToolkit().beep();
			Object[] options = { "Yes", "No"};
			if (JOptionPane.showOptionDialog(null, "The line "+readCounter + " contains in column \""+ Attribute 
					+ "\" "+ RealLength + " characters instead of "+ MaximalLength + " characters.\nThe column starts with:\n"
					+ OffendingText +"\nDo you want to cancel reading the file " + Dateiname + "?", "Error while constructing Literature database", JOptionPane.YES_NO_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[1]) == 0)
			{	
				if (readFileLength > 1000000)
					progressWindow.setCancelRequest(true);
				else
				{
					MayLib_Start.this.MayLibFile = "";
					MayLib_Start.this.NameOfMayLibFile ="";
					
					try
					{
						this.finalize();
					}
					catch (Throwable e)
					{
					}
					
					//MayLib_Start.this.dispose();
				}
			}
		}
		
		@Override
		public void run()
		{		
			if (readFileLength > 1000000)
			{
			Thread t = new Thread(progressWindow);
			t.start();			
			}
			
			try
			{
				if (Characterset.equalsIgnoreCase("UNKNOWN"))
				{
					Characterset = FileEncoding.getEnCoding(Dateiname);
					Unknown_Encoding = Characterset;
				}
				Reader r = new InputStreamReader(new FileInputStream(Dateiname), Characterset);
				BufferedReader br_in = new BufferedReader(r);
				while((zeile = br_in.readLine()) != null) 
				{
					readCounter++;
					
					codeCounter =1;
					
					// define Periodical to be able to access it within the different parts of the while loop
					Periodical ReadPeriodical =null;
					
					//(zeile.length()*2) because it is Unicode!
					if (readFileLength > 1000000)
					{
					progressWindow.setValue(progressWindow.getValue() + (zeile.length()*2) + 2);
					if (readCounter % 50 == 0)
					    progressWindow.setMessage(String.format("Reading data ...  [%d]", readCounter));
					}
					
					//Header of the file may contain definitions of the columns, or be empty
					if ((zeile.toLowerCase().contains("author_1") && zeile.toLowerCase().contains("author_2") && zeile.toLowerCase().contains("in_book_title")) 
							|| zeile.toLowerCase().contains("created_by_maylib")
							|| zeile.trim().length() == 0)	
					{
						//System.out.println((int)zeile.charAt(0));
						continue;
						//break;
					}
					else
					{				
						split = zeile.split(";");
						
						if (split.length != 30)
						{
							JOptionPane.showMessageDialog(null, "The line "+readCounter + " contains "+ split.length + " columns instead of 30 columns.\nThe line starts with:\n"
									+zeile.substring(0,(zeile.length() < 100 ? zeile.length() : 100)) 
									+ "\nThe import will be aborted!", "Error while constructing Literature database", JOptionPane.ERROR_MESSAGE);
							break;
						}
						
						/*Index of split:
						0 Author_1 
						1 Author_2 
						2 Author_3 
						3 Author_4 
						4 Year 
						5 Editor
						6 Title 
						7 In_Book_title 
						8 Volume 
						9 Pages 
						10 Figures 
						11 Number_of_tables 
						12 Plates 
						13 Bibliographic_data 
						14 Editorial 
						15 Type 
						16 Keyword_1 
						17 Keyword_2 
						18 Keyword_3 
						19 Name 
						20 Place 
						21 Abreviated_Name 
						22 ISSN 
						23 Language
						24 Catalogue_Number 
						25 Storing_place 
						26 Remarks 
						27 Date_Entry 
						28 ISBN 
						29 Abstract						
						*/
						codeCounter= 10;
						// At first we construct the periodical
						// Name of publication
						if (split[19].trim().length() > Periodical.getAttributeLength("Name"))
							errorAdviceLength("Name", readCounter, Periodical.getAttributeLength("Name"), 
									split[19].trim().length(), split[19].trim().substring(0, 100));
						
						// Place of publication
						if (split[20].trim().length() > Periodical.getAttributeLength("Place"))
							errorAdviceLength("Place", readCounter, Periodical.getAttributeLength("Place"), 
									split[20].trim().length(), split[20].trim().substring(0, 100));
						
						// prove Periodical
						if (split[19].trim().length() > 0)
						{
							
							
							String S_Name = split[19].trim();
							if (S_Name.length() > Periodical.getAttributeLength("Name"))
								S_Name = split[19].trim().substring(0, Periodical.getAttributeLength("Name"));
							
							String S_Place = split[20].trim();
							if (S_Place.length() > Periodical.getAttributeLength("Place"))
								S_Place = split[20].trim().substring(0, Periodical.getAttributeLength("Place"));
							
							String S_Abreviated_Name = split[21].trim();
							if (S_Abreviated_Name.length() > Periodical.getAttributeLength("Abreviated_Name"))
								S_Abreviated_Name = split[21].trim().substring(0, Periodical.getAttributeLength("Abreviated_Name"));
							
							String S_ISSN = split[22].trim();
							if (S_ISSN.length() > Periodical.getAttributeLength("ISSN"))
								S_ISSN = split[22].trim().substring(0, Periodical.getAttributeLength("ISSN"));
							
							String S_Language = split[23].trim();
							if (S_Language.length() > Periodical.getAttributeLength("Language"))
								S_Language = split[23].trim().substring(0, Periodical.getAttributeLength("Language"));
							
							
							// Identifier of the periodical
							String ReadPeriodicalID = Periodical.makeCompareValue(S_Name, S_Place);
							
							// It does not matter if the combination Periodical_Name & Place already exists. 
							// In this case, it will be actualized.
							if (PeriodicalTree.containsKey(ReadPeriodicalID))
								ReadPeriodical = PeriodicalTree.get(ReadPeriodicalID);
							else 
								ReadPeriodical = new Periodical(S_Name, S_Place);
							
							ReadPeriodical.setAbreviated_Name(S_Abreviated_Name);
							
							ReadPeriodical.setISSN(S_ISSN);
							
							ReadPeriodical.setLanguage(S_Language);
							
							PeriodicalTree.put(ReadPeriodical.getCompareValue(), ReadPeriodical);
				
						}
						
						codeCounter = 20;
						
						// After constructing the periodical we construct the Libref
						
						if (((split[0].trim().length()==0) || (split[4].trim().length()==0)) &&((split[1].trim().length()>0) 
								|| (split[2].trim().length()>0) || (split[3].trim().length()>0) || (split[6].trim().length()>0) || (split[7].trim().length()>0)))
						{							
							Toolkit.getDefaultToolkit().beep();
							Object[] options = { "Yes", "No"};
							if (JOptionPane.showOptionDialog(null, "The reference in line "+readCounter 
									+ " does not contain Author_1 or Year.\nThe line starts with:\n"+zeile.substring(0,(zeile.length() < 100 ? zeile.length() : 100)) 
									+"\nThis reference can not be added to the literature database! Do you want to cancel reading?", "Error while constructing Literature database", 
									JOptionPane.YES_NO_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[1]) == 0)
								if (readFileLength > 1000000)
									progressWindow.setCancelRequest(true);
								else
								{
									MayLib_Start.this.MayLibFile = "";
									MayLib_Start.this.NameOfMayLibFile ="";
									//MayLib_Start.this.dispose();
									break;
								}
						}
						
						// Author_1 and Year are filled. It is possible to make a reference.
						if ((split[0].trim().length()> 0) && (split[4].trim().length() > 0))
						{
							// Attribute: Author_1
							if (split[0].trim().length() > Libref.getAttributeLength("Author_1"))
								errorAdviceLength("Author_1", readCounter, Libref.getAttributeLength("Author_1"), 
										split[0].trim().length(), split[0].trim().substring(0, 50));
							
							String S_Author_1 = split[0].trim();
							if (S_Author_1.length() > Libref.getAttributeLength("Author_1"))
								S_Author_1 = split[0].trim().substring(0, Libref.getAttributeLength("Author_1"));
	
							// Attribute: Author_2
							if (split[1].trim().length() > Libref.getAttributeLength("Author_2"))
								errorAdviceLength("Author_2", readCounter, Libref.getAttributeLength("Author_2"), 
										split[1].trim().length(), split[1].trim().substring(0, 50));
	
							String S_Author_2 = split[1].trim();
							if (S_Author_2.length() > Libref.getAttributeLength("Author_2"))
								S_Author_2 = split[1].trim().substring(0, Libref.getAttributeLength("Author_2"));
							
							// Attribute: Author_3
							if (split[2].trim().length() > Libref.getAttributeLength("Author_3"))
								errorAdviceLength("Author_3", readCounter, Libref.getAttributeLength("Author_3"), 
										split[2].trim().length(), split[2].trim().substring(0, 50));
							
							String S_Author_3 = split[2].trim();
							if (S_Author_3.length() > Libref.getAttributeLength("Author_3"))
								S_Author_3 = split[2].trim().substring(0, Libref.getAttributeLength("Author_3"));
							
							// Attribute: Author_4
							if (split[3].trim().length() > Libref.getAttributeLength("Author_4"))
								errorAdviceLength("Author_4", readCounter, Libref.getAttributeLength("Author_4"), 
										split[3].trim().length(), split[3].trim().substring(0, 50));
							
							String S_Author_4 = split[3].trim();
							if (S_Author_4.length() > Libref.getAttributeLength("Author_4"))
								S_Author_4 = split[3].trim().substring(0, Libref.getAttributeLength("Author_4"));
							
							// Attribute: Year
							if (split[4].trim().length() > Libref.getAttributeLength("Year"))
								errorAdviceLength("Year", readCounter, Libref.getAttributeLength("Year"), 
										split[4].trim().length(), split[4].trim().substring(0, 10));
							
							String S_Year = split[4].trim();
							if (S_Year.length() > Libref.getAttributeLength("Year"))
								S_Year = split[4].trim().substring(0, Libref.getAttributeLength("Year"));							
							
							// Identifier of the Libref
							String ReadLibrefID = Libref.makeCompareValue(S_Author_1, S_Author_2, S_Author_3, S_Author_4, S_Year);
							
							// If the combination S_Author_1, S_Author_2, S_Author_3, S_Author_4, S_Year already exists,
							// it can not be added again!
							if (LibrefTree.containsKey(ReadLibrefID))
							{
								Toolkit.getDefaultToolkit().beep();
								Object[] options = { "Yes", "No"};
								if (JOptionPane.showOptionDialog(null, "The reference in line "+readCounter 
										+ " contains an already existing combination of Authors and Year.\nThe line starts with:\n"+zeile.substring(0,(zeile.length() < 100 ? zeile.length() : 100)) 
										+"\nThis reference can not be added to the literature database! Do you want to cancel reading?", "Error while constructing Literature database", 
										JOptionPane.YES_NO_OPTION, JOptionPane.ERROR_MESSAGE, null, options, options[1]) == 0)
									if (readFileLength > 1000000)
										progressWindow.setCancelRequest(true);
									else
									{
										MayLib_Start.this.MayLibFile = "";
										MayLib_Start.this.NameOfMayLibFile ="";
										//MayLib_Start.this.dispose();
										break;
									}
							}
							else
							{
								// A new Libref will be created
								Libref ReadLibref = new Libref(S_Author_1, S_Author_2, S_Author_3, S_Author_4, S_Year);
								
								// prove Periodical
								if (split[19].trim().length() > 0)
									ReadLibref.setPeriodical(ReadPeriodical);
								
								// Attribute: Editor
								if (split[5].trim().length() > Libref.getAttributeLength("Editor"))
									errorAdviceLength("Editor", readCounter, Libref.getAttributeLength("Editor"), 
											split[5].trim().length(), split[5].trim().substring(0, 10));
								
								String S_Editor = split[5].trim();
								if (S_Editor.length() > Libref.getAttributeLength("Editor"))
									S_Editor = split[5].trim().substring(0, Libref.getAttributeLength("Editor"));
								
								ReadLibref.setEditor(S_Editor);
								
								// Attribute: Title
								if (split[6].trim().length() > Libref.getAttributeLength("Title"))
									errorAdviceLength("Title", readCounter, Libref.getAttributeLength("Title"), 
											split[6].trim().length(), split[6].trim().substring(0, 100));
								
								String S_Title = split[6].trim();
								if (S_Title.length() > Libref.getAttributeLength("Title"))
									S_Title = split[6].trim().substring(0, Libref.getAttributeLength("Title"));
								
								ReadLibref.setTitle(S_Title);
								
								// Attribute: In_Book_title
								if (split[7].trim().length() > Libref.getAttributeLength("In_Book_title"))
									errorAdviceLength("In_Book_title", readCounter, Libref.getAttributeLength("In_Book_title"), 
											split[7].trim().length(), split[7].trim().substring(0, 100));
								
								String S_In_Book_title = split[7].trim();
								if (S_In_Book_title.length() > Libref.getAttributeLength("In_Book_title"))
									S_In_Book_title = split[7].trim().substring(0, Libref.getAttributeLength("In_Book_title"));
								
								ReadLibref.setIn_Book_title(S_In_Book_title);
								
								String S_Volume = split[8].trim();
								if (S_Volume.length() > Libref.getAttributeLength("Volume"))
									S_Volume = split[8].trim().substring(0, Libref.getAttributeLength("Volume"));
								
								ReadLibref.setVolume(S_Volume);
								
								String S_Pages = split[9].trim();
								if (S_Pages.length() > Libref.getAttributeLength("Pages"))
									S_Pages = split[9].trim().substring(0, Libref.getAttributeLength("Pages"));
								
								ReadLibref.setPages(S_Pages);
								
								String S_Figures = split[10].trim();
								if (S_Figures.length() > Libref.getAttributeLength("Figures"))
									S_Figures = split[10].trim().substring(0, Libref.getAttributeLength("Figures"));
								
								ReadLibref.setFigures(S_Figures);
								
								String S_Number_of_tables = split[11].trim();
								if (S_Number_of_tables.length() > Libref.getAttributeLength("Number_of_tables"))
									S_Number_of_tables = split[11].trim().substring(0, Libref.getAttributeLength("Number_of_tables"));
								
								ReadLibref.setNumber_of_tables(S_Number_of_tables);
								
								String S_Plates = split[12].trim();
								if (S_Plates.length() > Libref.getAttributeLength("Plates"))
									S_Plates = split[12].trim().substring(0, Libref.getAttributeLength("Plates"));
								
								ReadLibref.setPlates(S_Plates);
								
								String S_Bibliographic_data = split[13].trim();
								if (S_Bibliographic_data.length() > Libref.getAttributeLength("Bibliographic_data"))
									S_Bibliographic_data = split[13].trim().substring(0, Libref.getAttributeLength("Bibliographic_data"));
								
								ReadLibref.setBibliographic_data(S_Bibliographic_data);
								
								String S_Editorial = split[14].trim();
								if (S_Editorial.length() > Libref.getAttributeLength("Editorial"))
									S_Editorial = split[14].trim().substring(0, Libref.getAttributeLength("Editorial"));
								
								ReadLibref.setEditorial(S_Editorial);
								
								String S_Type = split[15].trim();
								if (S_Type.length() > Libref.getAttributeLength("Type"))
									S_Type = split[15].trim().substring(0, Libref.getAttributeLength("Type"));
								
								ReadLibref.setType(S_Type);
								
								String S_Keyword_1 = split[16].trim();
								if (S_Keyword_1.length() > Libref.getAttributeLength("Keyword_1"))
									S_Keyword_1 = split[16].trim().substring(0, Libref.getAttributeLength("Keyword_1"));
								
								// A default value is used for empty Keyword_1
								ReadLibref.setKeyword_1(S_Keyword_1.length()>0 ? S_Keyword_1 : "Keyword undefined");
								
								String S_Keyword_2 = split[17].trim();
								if (S_Keyword_2.length() > Libref.getAttributeLength("Keyword_2"))
									S_Keyword_2 = split[17].trim().substring(0, Libref.getAttributeLength("Keyword_2"));
								
								ReadLibref.setKeyword_2(S_Keyword_2);
								
								String S_Keyword_3 = split[18].trim();
								if (S_Keyword_3.length() > Libref.getAttributeLength("Keyword_3"))
									S_Keyword_3 = split[18].trim().substring(0, Libref.getAttributeLength("Keyword_3"));
								
								ReadLibref.setKeyword_3(S_Keyword_3);
								
								String S_Catalogue_Number = split[24].trim();
								if (S_Catalogue_Number.length() > Libref.getAttributeLength("Catalogue_Number"))
									S_Catalogue_Number = split[24].trim().substring(0, Libref.getAttributeLength("Catalogue_Number"));
								
								if (S_Catalogue_Number.length() > 0)
									ReadLibref.setCatalogue_Number(S_Catalogue_Number);
								
								String S_Storing_place = split[25].trim();
								if (S_Storing_place.length() > Libref.getAttributeLength("Storing_place"))
									S_Storing_place = split[25].trim().substring(0, Libref.getAttributeLength("Storing_place"));
								
								ReadLibref.setStoring_place(S_Storing_place);
								
								String S_Remarks = split[26].trim();
								if (S_Remarks.length() > Libref.getAttributeLength("Remarks"))
									S_Remarks = split[26].trim().substring(0, Libref.getAttributeLength("Remarks"));
								
								ReadLibref.setRemarks(S_Remarks);

								// Date_Entry is only used , if it makes sense								
								if (split[27].trim().length() <= Libref.getAttributeLength("Date_Entry") 
										&& Character.isDigit(split[27].trim().charAt(0))
										&& Character.isDigit(split[27].trim().charAt(1)))
								{
									if (split[27].trim().substring(0,2).equals("20")
											&& Character.isDigit(split[27].trim().charAt(2))
											&& Character.isDigit(split[27].trim().charAt(3))
											&& Character.isDigit(split[27].trim().charAt(4))
											&& Character.isDigit(split[27].trim().charAt(5))
										    && split[27].trim().charAt(8) == '_')
										ReadLibref.setDate_Entry(split[27].trim());
									else if (split[27].trim().length() == 10 
											&& split[27].trim().substring(6,8).equals("20")
											&& !Character.isDigit(split[27].trim().charAt(2))
											&& Character.isDigit(split[27].trim().charAt(3))
											&& Character.isDigit(split[27].trim().charAt(4))
											&& !Character.isDigit(split[27].trim().charAt(5)))
										ReadLibref.setDate_Entry(split[27].trim().substring(6,10)+split[27].trim().substring(3,5)+split[27].trim().substring(0,2) +"_00:00");
								}
								
								String S_ISBN = split[28].trim();
								if (S_ISBN.length() > Libref.getAttributeLength("ISBN"))
									S_ISBN = split[28].trim().substring(0, Libref.getAttributeLength("ISBN"));
								
								ReadLibref.setISBN(S_ISBN);
								
								String S_Abstract = split[29].trim();
								if (S_Abstract.length() > Libref.getAttributeLength("Abstract"))
									S_Abstract = split[29].trim().substring(0, Libref.getAttributeLength("Abstract"));
								
								ReadLibref.setAbstract(S_Abstract);
								
								LibrefTree.put(ReadLibref.getCompareValue(), ReadLibref);
								
								//The auxiliary TreeSets are filled
								if (S_Type.length()>0)
									LibrefTypeSet.add(S_Type);
								//LibrefTypes receives a set of standard types in "public ReadFileIntoLib"
								
								if (S_Year.length() <= 4)
									LibrefYearSet.add(S_Year);
								else 
									LibrefYearSet.add(S_Year.substring(0,4));

								if (!S_Author_1.contains("&"))
									LibrefAuthorSet.add(S_Author_1);
								else
									LibrefOtherAuthorsSet.add(S_Author_1);
								
								if (S_Author_2.length() > 0)
								{
									if (!S_Author_2.contains("&"))
										LibrefAuthorSet.add(S_Author_2);
									else
										LibrefOtherAuthorsSet.add(S_Author_2);
								}

								if (S_Author_3.length() > 0)
								{
									if (!S_Author_3.contains("&"))
										LibrefAuthorSet.add(S_Author_3);
									else
										LibrefOtherAuthorsSet.add(S_Author_3);
								}
								
								if (S_Author_4.length()>0)
									LibrefOtherAuthorsSet.add(S_Author_4);

								if (S_Keyword_1.length() > 0)
									LibrefKeywordSet.add(S_Keyword_1);

								if (S_Keyword_2.length() > 0)
									LibrefKeywordSet.add(S_Keyword_2);

								if (S_Keyword_3.length() > 0)
									LibrefKeywordSet.add(S_Keyword_3);
							}						
						}
					}
					
					codeCounter = 30;
					
					if (readFileLength > 1000000 && progressWindow.cancelRequest())
					{
						codeCounter = 40; 
						
						Toolkit.getDefaultToolkit().beep();
						Object[] options = { "Yes", "No"};
						if (JOptionPane.showOptionDialog(null, "Do you want to cancel reading the file " + Dateiname + "?", "Cancel reading", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[1]) == 0)
							break;
						else
							progressWindow.setCancelRequest(false);
					}
					
				}
				
				codeCounter = 50; 
				
			if (br_in != null) br_in.close();	

			}
			catch (Exception ex)
			{
				JOptionPane.showMessageDialog(null, "Error at point " +codeCounter +" in reading the file " + Dateiname + ": " + ex.getMessage(), "I/O Error", JOptionPane.ERROR_MESSAGE);
			}
			
			if (readFileLength > 1000000)
			{
			// Fortschrittsanzeige schlieen
			progressWindow.close();
			}
						
			addPeriodicalCounter = PeriodicalTree.size();
			addLibrefCounter = LibrefTree.size();
			
			statusBar.setMessage( String.format("%d periodicals and %d literature references read sucessfully", addPeriodicalCounter, addLibrefCounter));
			
			JOptionPane.showMessageDialog(null, String.format("%d periodicals and %d literature references read sucessfully", addPeriodicalCounter, addLibrefCounter), "Literature database", JOptionPane.INFORMATION_MESSAGE);

			// activate menus and menuitems:
			menuLibref.setEnabled(true); 
			menuPeriodical.setEnabled(true); 
			miShowAllLibrefs.setEnabled(addLibrefCounter >0); 
			miMostRecent.setEnabled(addLibrefCounter >0);
			miAllRecent.setEnabled(addLibrefCounter >0); 
			miSave.setEnabled(addLibrefCounter >0 || addPeriodicalCounter >0); 
			submenuSaveAs.setEnabled(addLibrefCounter >0 || addPeriodicalCounter >0);
			miSaveAsOther.setEnabled(addLibrefCounter >0 || addPeriodicalCounter >0);
			miSaveAsUCF.setEnabled(addLibrefCounter >0 || addPeriodicalCounter >0); 
			submenuSaveSearch.setEnabled(false); 
			miShowAllPeriodicals.setEnabled(addPeriodicalCounter >0);  
			miShowSelLibrefs.setEnabled(false);  
			miShowSelPeriodicals.setEnabled(false); 
			miTreeLibref.setEnabled(false);  
			miTreeDictionary.setEnabled(false);  
			miTreePeriodical.setEnabled(false);   
			menuReport.setEnabled(addLibrefCounter >0 || addPeriodicalCounter >0); 
			submenuAbstract.setEnabled(addLibrefCounter >0);
			submenuReportType.setEnabled(addLibrefCounter >0 || addPeriodicalCounter >0); 
			miReportAllLibrefs.setEnabled(addLibrefCounter >0);
			miReportAllPeriodicals.setEnabled(addPeriodicalCounter >0);
			miReportSelLibrefs.setEnabled(false);  
			miReportSelPeriodicals.setEnabled(false); 
			miWithoutAbstract.setEnabled(addLibrefCounter >0);  
			mi1000Abstract.setEnabled(addLibrefCounter >0); 
			mi2000Abstract.setEnabled(addLibrefCounter >0);
			mi4000Abstract.setEnabled(addLibrefCounter >0);
			miFullAbstract.setEnabled(addLibrefCounter >0);
			miBasicReport.setEnabled(addLibrefCounter >0 || addPeriodicalCounter >0); 
			miCompleteReport.setEnabled(addLibrefCounter >0 || addPeriodicalCounter >0); 
			miGermanStandardReport.setEnabled(addLibrefCounter >0); 
			miPalaeontologyReport.setEnabled(addLibrefCounter >0); 
			miBullGeosciencesPragueReport.setEnabled(addLibrefCounter >0); 
			
			btnSave.setEnabled(addLibrefCounter >0 || addPeriodicalCounter >0); 
			btnReport.setEnabled(addLibrefCounter >0);
			btnExecLibrefSearch_Table.setEnabled(addLibrefCounter >0);  
			btnExecLibrefSearch_Tree.setEnabled(addLibrefCounter >0);  
			btnExecLibrefSearch_Dictionary.setEnabled(addLibrefCounter >0); 
			btnExecLibrefSearch_Periodical.setEnabled(addPeriodicalCounter >0);
			btnClearLibrefSearch.setVisible(false); 
			
			miWithoutAbstract.setSelected(true);
			miBasicReport.setSelected(true);
			
			// actualize comboboxes
			clearpopulateCboPeriod();
			clearpopulateCboOther();
			
			// fcFile.toString() of the new opened Literature database
			MayLibFile = Dateiname;
			NameOfMayLibFile = fcFile.getName();
					
			MayLib_Start.this.setTitle("MayLib  ( " +NameOfMayLibFile+"  opened )"); 
			
//			//Test:
//			Set <String> SetPerKey = LibrefTree.keySet();
//			
//			for (String s : SetPerKey)
//			{
//				System.out.println(s);				
//			}
//			
//			System.out.println("\n\n***  Ende der Liste  ***");	
			
		}		
	}
	
	private TreeSet<Object> prepareAllLibrefs()
	{	
		TreeSet<Object> ObjectSet = new TreeSet<Object>();
		
		Set<String> keys = LibrefTree.keySet();
			
		for (String s : keys)
		{
			ObjectSet.add(LibrefTree.get(s));
		}
		
		return ObjectSet;
	}
	
	private TreeSet<Object> prepareSelLibrefs()
	{	
		TreeSet<Object> ObjectSet = new TreeSet<Object>();

		Iterator<Libref> i2t = this.QueriedLibrefSet.iterator();
		while (i2t.hasNext())

		{
			Libref DisplayObj = i2t.next();

			ObjectSet.add(DisplayObj);
		}
		
		return ObjectSet;
	}
	
	private void showAllLibrefs()
	{	
		TreeSet<Object> ObjectSet = prepareAllLibrefs();
		
		MayLibTable dlg = new MayLibTable(LibrefHeader, ObjectSet, "Libref", "All literature references of "+NameOfMayLibFile,
				this);
		dlg.showDialog(this);
	}

	private TreeSet<Object> prepareAllPeriodicals()
	{	
		TreeSet<Object> ObjectSet = new TreeSet<Object>();
		
		Set<String> keys = PeriodicalTree.keySet();
			
		for (String s : keys)
		{
			ObjectSet.add(PeriodicalTree.get(s));
		}
		
		return ObjectSet;
	}
	

	private TreeSet<Object> prepareSelPeriodicals()
	{	
		TreeSet<Object> ObjectSet = new TreeSet<Object>();

		Iterator<Periodical> i2t = this.QueriedPeriodicalSet.iterator();
		while (i2t.hasNext())

		{
			Periodical DisplayObj = i2t.next();

			ObjectSet.add(DisplayObj);
		}
		
		return ObjectSet;
	}

	private void showAllPeriodicals()
	{	
		TreeSet<Object> ObjectSet = prepareAllPeriodicals();
		
		MayLibTable dlg = new MayLibTable(PeriodicalHeader, ObjectSet,  "Periodical", "All periodicals of "+NameOfMayLibFile,
				this);
		dlg.showDialog(this);
	}
	

	private void showSelLibrefs()
	{	
		TreeSet<Object> ObjectSet = prepareSelLibrefs();
		
		MayLibTable dlg = new MayLibTable(LibrefHeader, ObjectSet,  "Libref", LibrefQueryCriteria,
				this);
		dlg.showDialog(this);
	}

	private void showSelPeriodicals()
	{	
		TreeSet<Object> ObjectSet = prepareSelPeriodicals();
		
		MayLibTable dlg = new MayLibTable(PeriodicalHeader, ObjectSet, "Periodical", "Selected periodicals: "+ LibrefQueryCriteria,
				this);
		dlg.showDialog(this);
	}
	
	
	private class StatusBar extends JLabel
	{
		public StatusBar()
		{
			this.setBorder(LineBorder.createGrayLineBorder());
		}
		
		public void setMessage(String message)
		{
			setText(" " + message);
		}	
	}
		
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		MayLib_Start f = new MayLib_Start();
		f.Show();
	}

	
	@Override
	public void initFrame()
	{			
		kbFocusManager = KeyboardFocusManager.getCurrentKeyboardFocusManager();
		
		clearpopulateCboPeriod();
		clearpopulateCboOther();
		
		setBackgroundColor("brown");
		
		//Fontsize
		setmyFont(14);
		
		//Windowsize
		execMaximizeWindow("big");
		
		this.menuBar.setVisible(false);
		this.pnlLibrefsearch.setVisible(false);
		
		// special Label
		String fontFamily = btnbackGroundLbl.getFont().getFamily();
		//int fontStyle = Font.BOLD + Font.ITALIC;
		backGroundFont = new Font(fontFamily, Font.BOLD + Font.ITALIC, 24);
		btnbackGroundLbl.setFont(backGroundFont);
		btnbackGroundLbl.setForeground(Color.BLUE);
		btnbackGroundLbl.requestFocusInWindow();
		
		fcFile = new File(System.getProperty("user.dir"));
		///
		miWithoutAbstract.setSelected(true);
		miBasicReport.setSelected(true);
		miRepUnicode.setSelected(true);
		this.strexecRepCharset ="Unicode";
		
		// deactivate menus and menuitems:
		menuLibref.setEnabled(true); 
		menuPeriodical.setEnabled(true); 
		miShowAllLibrefs.setEnabled(false); 
		miMostRecent.setEnabled(false);
		miAllRecent.setEnabled(false); 
		miShowAllPeriodicals.setEnabled(false); 
		miShowSelLibrefs.setEnabled(false);  
		miShowSelPeriodicals.setEnabled(false); 
		miTreeLibref.setEnabled(false);  
		miTreeDictionary.setEnabled(false);  
		miTreePeriodical.setEnabled(false);   
		miSave.setEnabled(false); 
		submenuSaveSearch.setEnabled(false);
		submenuSaveAs.setEnabled(false);
		miSaveAsOther.setEnabled(false);
		miSaveAsUCF.setEnabled(false);   
		menuReport.setEnabled(false); 
		submenuAbstract.setEnabled(false);  
		submenuReportType.setEnabled(false); 
		miReportAllLibrefs.setEnabled(false);  
		miReportAllPeriodicals.setEnabled(false); 
		miReportSelLibrefs.setEnabled(false);  
		miReportSelPeriodicals.setEnabled(false); 
		miWithoutAbstract.setEnabled(false);  
		mi1000Abstract.setEnabled(false);  
		mi2000Abstract.setEnabled(false);  
		mi4000Abstract.setEnabled(false); 
		miFullAbstract.setEnabled(false); 
		miBasicReport.setEnabled(false); 
		miCompleteReport.setEnabled(false); 
		miGermanStandardReport.setEnabled(false); 
		miPalaeontologyReport.setEnabled(false); 
		miBullGeosciencesPragueReport.setEnabled(false); 
		
		btnSave.setEnabled(false);
		btnReport.setEnabled(false);
		btnExecLibrefSearch_Table.setEnabled(false);  
		btnExecLibrefSearch_Tree.setEnabled(false);  
		btnExecLibrefSearch_Dictionary.setEnabled(false); 
		btnExecLibrefSearch_Periodical.setEnabled(false);
		btnClearLibrefSearch.setVisible(false);
		
		// At the end of the init phase we read the config-data
		// Die Konfigurationsdatei muss direkt im Projektverzeichnis liegen.
		appConfigPath = "MayLib_config";  
		ReadProperties(appConfigPath + "\\" +  this.getClass().getName()+ ".config");
		
	}

	@Override
	public void windowActivated(WindowEvent arg0)
	{
		if (this.needpopulateCboPeriod)
			clearpopulateCboPeriod();
		
		if (this.needpopulateCboOther)
			clearpopulateCboOther();
			
		miSave.setEnabled(this.hasChanged);
		btnSave.setEnabled(this.hasChanged);
	}

	@Override
	public void windowClosed(WindowEvent arg0)
	{
		WriteProperties(appConfigPath + "\\" +  this.getClass().getName()+ ".config");
	}

	@Override
	public void windowClosing(WindowEvent arg0)
	{
		// berprfen, ob nderungen noch gespeichert werden mssen
		if (queryExit())
					this.dispose();		
	}

	@Override
	public void windowDeactivated(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowDeiconified(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowIconified(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowOpened(WindowEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource().equals(btnSave))			
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = this.MayLibFile;
			
			if (saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Changes in opened MayLib database saved (File: " + this.lastWrittenFile +").", "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(btnReadUCF))
		{
			if (queryExit())
			{
				this.MayLibFile = null;
				hasChanged = false; 
				lastWrittenFile = null;
				needCleaningInternalLists = true; 
				openFileDialog("UTF-16");
			}
		}
		
		else if (e.getSource().equals(btnNewLibref))
		{
			LibrefDialog dlg = new LibrefDialog(null, this, null, null, null);
			dlg.showDialog(this);
		}
		else if (e.getSource().equals(btnNewPeriodical))
		{
			PeriodicalDialog dlg = new PeriodicalDialog(null, this, null, null, null);
			dlg.showDialog(this);
		}

		else if (e.getSource().equals(btnReport))
		{				
			String Abstract ="1000", ReportType = "GermanStandard", 
					fileExtension = "RPU", Characterset = "UTF-16";
			
			if (this.QueriedLibrefSet.size()>0)
				reportSelLibrefs(Abstract, ReportType, fileExtension, Characterset);
			else
				reportAllLibrefs(Abstract, ReportType, fileExtension, Characterset);		
		}		
		
		else if (e.getSource().equals(btnQuitApp))
		{
			windowClosing(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
		}
				
		else if (e.getSource().equals(miQuit))
			windowClosing(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
		
		
		else if (e.getSource().equals(miNew))
		{
			if (queryExit())
			{
				this.MayLibFile = null;
				hasChanged = false; 
				lastWrittenFile = null;
				cleanInternalLists();
				LibrefDialog dlg = new LibrefDialog(null, this, null, null, null);
				dlg.showDialog(this);
			}
		}
		
		else if (e.getSource().equals(miNewLibref))
		{
			LibrefDialog dlg = new LibrefDialog(null, this, null, null, null);
			dlg.showDialog(this);
		}	
		
		else if (e.getSource().equals(miNewPeriodical))
		{
			PeriodicalDialog dlg = new PeriodicalDialog(null, this, null, null, null);
			dlg.showDialog(this);
		}	
		
		else if (e.getSource().equals(miReadUCF))
		{
			if (queryExit())
			{
				this.MayLibFile = null;
				hasChanged = false; 
				lastWrittenFile = null;
				needCleaningInternalLists = true; 
				openFileDialog("UTF-16");
			}
		}

		else if (e.getSource().equals(miReadOther))
		{
			if (queryExit())
			{
				this.MayLibFile = null;
				hasChanged = false; 
				lastWrittenFile = null;
				needCleaningInternalLists = true; 
				openFileDialog(Default_Charset);
			}
		}

		else if (e.getSource().equals(miReadUnknown))
		{
			if (queryExit())
			{
				this.MayLibFile = null;
				hasChanged = false; 
				lastWrittenFile = null;
				needCleaningInternalLists = true; 
				openFileDialog("UNKNOWN");
			}
		}
		
		else if (e.getSource().equals(miAddUCF))
		{
			openFileDialog("UTF-16");
		}		
		
		else if (e.getSource().equals(miAddOther))
		{	
			openFileDialog(Default_Charset);
		}	
	
		else if (e.getSource().equals(miAddUnknown))
		{	
			openFileDialog("UNKNOWN");
		}			
		
		else if (e.getSource().equals(miMostRecent))
		{
			if (execRecentLibref("Most"))
			{
				showSelLibrefs();
				btnClearLibrefSearch.setVisible(true);
				submenuSaveSearch.setEnabled(true);
			}
		}

		else if (e.getSource().equals(miAllRecent))
		{
			if (execRecentLibref("All"))
			{
				showSelLibrefs();
				btnClearLibrefSearch.setVisible(true);
				submenuSaveSearch.setEnabled(true);
			}
		}

		else if (e.getSource().equals(miShowAllLibrefs))
			showAllLibrefs();
		
		else if (e.getSource().equals(miShowAllPeriodicals))
			showAllPeriodicals();
		
		else if (e.getSource().equals(miShowSelLibrefs))
			showSelLibrefs();

		else if (e.getSource().equals(miTreeLibref))
		{
			LibrefSplitPane dlg = new LibrefSplitPane(this, "Libref");
			dlg.showDialog(this);
		}

		else if (e.getSource().equals(miTreePeriodical))
		{
			LibrefSplitPane dlg = new LibrefSplitPane(this, "Periodical");
			dlg.showDialog(this);
		}

		else if (e.getSource().equals(miTreeDictionary))
		{
			LibrefSplitPane dlg = new LibrefSplitPane(this, "Dictionary");
			dlg.showDialog(this);
		}
		
		else if (e.getSource().equals(miShowSelPeriodicals))
			showSelPeriodicals();

		else if(e.getSource().equals(mi10pt))
		{
				setmyFont(10);
		}

		else if(e.getSource().equals(mi11pt))
		{
				setmyFont(11);
				
		}

		else if(e.getSource().equals(mi12pt))
		{
				setmyFont(12);
		}

		else if(e.getSource().equals(mi13pt))
		{
				setmyFont(13);
		}

		else if(e.getSource().equals(mi14pt))
		{
				setmyFont(14);
		}
		
		else if(e.getSource().equals(mi15pt))
		{
				setmyFont(15);
		}
		
		else if(e.getSource().equals(miMaxNone))
		{
			clearWindowSize();
			execMaximizeWindow("none");
		}
		
		else if(e.getSource().equals(miMaxBig))
		{
			clearWindowSize();
			execMaximizeWindow("big");
		}
		
		else if(e.getSource().equals(miMaxAll))
		{
			clearWindowSize();
			execMaximizeWindow("all");
		}
		
		else if(e.getSource().equals(miBrown))
		{
			setBackgroundColor("brown");
		}
		
		else if(e.getSource().equals(miBlue))
		{
			setBackgroundColor("blue");
		}
		
		else if(e.getSource().equals(miGreen))
		{
			setBackgroundColor("green");
		}
		
		else if(e.getSource().equals(miPink))
		{
			setBackgroundColor("pink");
		}
		
		else if(e.getSource().equals(miYellow))
		{
			setBackgroundColor("yellow");
		}
		
		else if(e.getSource().equals(miGray))
		{
			setBackgroundColor("gray");
		}
		
		else if (e.getSource().equals(miCopyright))	
		{
			JOptionPane.showMessageDialog(null, "MayLib - the textfile-based literature database\nVersion 1.4, Build 20130325_18\nCopyright: Dr. Andreas May, 2012-2013; may_devonian@yahoo.es", "Copyright",
					JOptionPane.INFORMATION_MESSAGE);

		}
		
		else if (e.getSource().equals(miMiniManual))
		{
			MayLibManual dlg = new MayLibManual(this);
			dlg.showDialog(this);
		}	

		else if (e.getSource().equals(miSave))	
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = this.MayLibFile;
			
			if (saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Changes in opened MayLib database saved (File: " + this.lastWrittenFile +").", "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}

		else if (e.getSource().equals(miSaveAsUCF))	
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = null;
			
			if (saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database saved sucessfully in the file " + this.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}

		else if (e.getSource().equals(miSaveAsOther))	
		{
			String fileExtension = "TXT", Characterset = Default_Charset;
			String Dateiname = null;
			
			if (saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database exported sucessfully to the file " + this.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveAsUnknown))	
		{
			String fileExtension = "TXT", Characterset = "UNKNOWN";
			String Dateiname = null;
			
			if (saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database exported sucessfully to the file " + this.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveAsUnknown))	
		{
			String fileExtension = "TXT", Characterset = "UNKNOWN";
			String Dateiname = null;
			
			if (saveMayLib(Dateiname, fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Opened MayLib database exported sucessfully to the file " + this.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveSearchUCF))	
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			
			if (saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Sought literature saved sucessfully in the MayLib file " + this.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}

		else if (e.getSource().equals(miSaveSearchOther))	
		{
			String fileExtension = "TXT", Characterset = Default_Charset;
			
			if (saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Sought literature exported sucessfully to the file " + this.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveSearchUnknown))	
		{
			String fileExtension = "TXT", Characterset = "UNKNOWN";
			
			if (saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Sought literature exported sucessfully to the file " + this.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}
		
		else if (e.getSource().equals(miSaveSearchCSV))	
		{
			String fileExtension = "CSV", Characterset = Default_Charset;
			
			if (saveSearchedMayLib(fileExtension, Characterset))
			{JOptionPane.showMessageDialog(null, "Sought literature exported sucessfully to the CSV file " + this.lastWrittenFile, "Data saved",
					JOptionPane.INFORMATION_MESSAGE);
			}
		}

		else if (e.getSource().equals(miReportAllLibrefs)
				|| e.getSource().equals(miReportAllPeriodicals)
				|| e.getSource().equals(miReportSelLibrefs)
				|| e.getSource().equals(miReportSelPeriodicals))	
		{
			/* Possible values of createReport(TreeSet<Object> ReportTreeSet, String ObjectType, String Headertext, String Abstract, String ReportType, String fileExtension, String Characterset)
			
			 * String ObjectType = Libref, Periodical
			 * String Headertext = null or a prepared text terminating without linefeed (linefeed will be added in the method createReport
			 * String Abstract  = without, 1000, full. Will be ignored, if ObjectType = Periodical
			 * String ReportType = basic, complete 
			 * String fileExtension = RPU, RPT
			 * String Characterset	= "UTF-16", Default_Charset, "UNKNOWN"	
		

			reportAllPeriodicals(String ReportType, String fileExtension, String Characterset)
			*/
			
			String Abstract ="without", ReportType = "basic", fileExtension ="RPT", Characterset =  Default_Charset;
			
			if (miWithoutAbstract.isSelected())
				Abstract ="without";
			else if (mi1000Abstract.isSelected())
				Abstract ="1000";
			else if (mi2000Abstract.isSelected())
				Abstract ="2000";
			else if (mi4000Abstract.isSelected())
				Abstract ="4000";
			else if (miFullAbstract.isSelected())
				Abstract ="full";
				
			if (miBasicReport.isSelected())
				ReportType = "basic";
			else if (miCompleteReport.isSelected())
				ReportType = "complete";
			else if (miGermanStandardReport.isSelected())
				ReportType = "GermanStandard";
			else if (miPalaeontologyReport.isSelected())
				ReportType = "Palaeontology";
			else if (miBullGeosciencesPragueReport.isSelected())
				ReportType = "BullGeosciencesPrague";
			else 
				ReportType = "complete";
			
			if (miRepUnicode.isSelected())
			{
				fileExtension = "RPU";
				Characterset = "UTF-16";
				this.strexecRepCharset = "Unicode"; 
			}
			else if (miRepDefault.isSelected())
			{
				fileExtension ="RPT";
				Characterset =  Default_Charset;
				this.strexecRepCharset = "Default"; 
			}
			else if (miRepUnknown.isSelected())
			{
				fileExtension ="RPT";
				Characterset =  "UNKNOWN";
				this.strexecRepCharset = "Unknown";
			}
			
			if (e.getSource().equals(miReportAllLibrefs))
				reportAllLibrefs(Abstract, ReportType, fileExtension, Characterset);
			else if (e.getSource().equals(miReportAllPeriodicals))
				reportAllPeriodicals(ReportType, fileExtension, Characterset);
			else if (e.getSource().equals(miReportSelLibrefs))
				reportSelLibrefs(Abstract, ReportType, fileExtension, Characterset);
			else if (e.getSource().equals(miReportSelPeriodicals))
				reportSelPeriodicals(ReportType, fileExtension, Characterset);
			else 
			{	
			}
					
		}
		
		else if (e.getSource().equals(btnbackGroundLbl))	
		{
			this.menuBar.setVisible(true);
			this.pnlLibrefsearch.setVisible(true);
			btnbackGroundLbl.setEnabled(false);

			if (MayLibFile == null && hasChanged == false && lastWrittenFile == null)
			{
				needCleaningInternalLists = true; 
				openFileDialog("UTF-16");
			}
			
			this.cboAuthor.requestFocusInWindow();
		}
		
		else if (e.getSource().equals(btnExecLibrefSearch_Table))	
		{
			if (fillQueriedLibrefSet())
			{
				showSelLibrefs();
				submenuSaveSearch.setEnabled(true);
			}
			btnClearLibrefSearch.setVisible(true);
		}
		
		else if (e.getSource().equals(btnExecLibrefSearch_Tree))	
		{
			if (fillQueriedLibrefSet())
			{
				LibrefSplitPane dlg = new LibrefSplitPane(this, "Libref");
				dlg.showDialog(this);
				submenuSaveSearch.setEnabled(true);
			}
			btnClearLibrefSearch.setVisible(true);
		}
		
		else if (e.getSource().equals(btnExecLibrefSearch_Dictionary))	
		{
			if (fillQueriedLibrefSet())
			{
				LibrefSplitPane dlg = new LibrefSplitPane(this, "Dictionary");
				dlg.showDialog(this);
				submenuSaveSearch.setEnabled(true);
			}
			btnClearLibrefSearch.setVisible(true);
		}
		
		else if (e.getSource().equals(btnExecLibrefSearch_Periodical))	
		{
			if (fillQueriedPeriodicals())
			{
				LibrefSplitPane dlg = new LibrefSplitPane(this, "Periodical");
				dlg.showDialog(this);
				submenuSaveSearch.setEnabled(true);
			}
			btnClearLibrefSearch.setVisible(true);
		}
		
		else if (e.getSource().equals(btnClearLibrefSearch))	
		{
			clearLibrefSearch();
		}		
	}
	
	private boolean writeData(String Dateiname, String Characterset, String saveString)
	{
		boolean retvalue = false;
		OutputStreamWriter writer = null;
		
//		System.out.println(Characterset);
//		System.out.println(Dateiname);
//		System.out.println(saveString);
		
		//Define characterset
		if (Characterset.equalsIgnoreCase("UNKNOWN"))
		{
			if (Unknown_Encoding != null && Unknown_Encoding.trim().length() > 0)
			{
				Characterset = Unknown_Encoding;
			}
			else
			{
				Characterset = Default_Charset;
			}
		}
		
		
		try
		{			
			writer = new OutputStreamWriter(new FileOutputStream(Dateiname), Characterset);
	
			writer.write(saveString);
			
			retvalue=true;	
		}
		catch (Exception ex)
		{
			JOptionPane.showMessageDialog(null, "Error in writing the file " + Dateiname + ": " + ex.getMessage(), "I/O Error", JOptionPane.ERROR_MESSAGE);
		}
		
		try
		{
			writer.close();
		}
		catch (IOException e) {}
		
		if (retvalue)
		{
			statusBar.setMessage("Written sucessfully: " + Dateiname);
			this.lastWrittenFile = Dateiname;
			
			// Save the new path
			File f = new File(Dateiname);
			if (f.exists() && f.isFile())
				this.fcFile = f;	
		}
		else 
			this.lastWrittenFile = "Error in writing";

		return retvalue;
	}
	
	private void cleanInternalLists()
	{
		LibrefTree.clear(); 
		PeriodicalTree.clear(); 	
		LibrefTypeSet.clear();
		//LibrefTypes receives a set of standard types in "public ReadFileIntoLib"
		LibrefYearSet.clear();
		LibrefAuthorSet.clear();
		LibrefOtherAuthorsSet.clear();
		LibrefKeywordSet.clear();
		QueriedLibrefSet.clear();
		QueriedPeriodicalSet.clear();
		LibrefQueryCriteria = "";	
		needCleaningInternalLists = false; 
		statusBar.setMessage("Internal lists cleaned. No lists, trees or reports are possible.");
	}
	
	public boolean deletePeriodical(Periodical DelObjekt)
	{	
		
		//First step: We prove if the periodical is used in a Libref.
		// If it is used, it can not be deleted.
				
		Set<String> keys = LibrefTree.keySet();
			
		for (String s : keys)
		{
			Libref ParentLibref = LibrefTree.get(s);
			if (DelObjekt.equals(ParentLibref.getPeriodical()))
			{
				JOptionPane.showMessageDialog(null, "The periodical \""+DelObjekt.toString().substring(0, (DelObjekt.toString().length() < 100 ? DelObjekt.toString().length() : 100))+ 
						"\"\n can not be deleted, because it is used in the literature reference: \n\""
						+ParentLibref.toString().substring(0, (ParentLibref.toString().length() < 100 ? ParentLibref.toString().length() : 100))
						+ "\"!", "Periodical can not be deleted", JOptionPane.ERROR_MESSAGE);
				
				return false;
			}			
		}
			
		PeriodicalTree.remove(DelObjekt.toString());
		
		return true;
	}

	public boolean deleteLibref(Libref DelObjekt)
	{	
		QueriedLibrefSet.remove(DelObjekt);
		LibrefTree.remove(DelObjekt.getCompareValue());
		
		return true;
	}
	
	protected boolean saveMayLib(String Dateiname, String fileExtension, String Characterset)
	{
		boolean retvalue =false;
			
	/*	
		0 Author_1 
		1 Author_2 
		2 Author_3 
		3 Author_4 
		4 Year 
		5 Editor
		6 Title 
		7 In_Book_title 
		8 Volume 
		9 Pages 
		10 Figures 
		11 Number_of_tables 
		12 Plates 
		13 Bibliographic_data 
		14 Editorial 
		15 Type 
		16 Keyword_1 
		17 Keyword_2 
		18 Keyword_3 
		19 Name 
		20 Place 
		21 Abreviated_Name 
		22 ISSN 
		23 Language
		24 Catalogue_Number 
		25 Storing_place 
		26 Remarks 
		27 Date_Entry 
		28 ISBN 
		29 Abstract	
		
		*/
		
		StringBuilder sb = new StringBuilder();
		sb.append("Author_1; Author_2; Author_3; Author_4; Year; Editor; Title; ");
		sb.append("In_Book_title; Volume; Pages; Figures; Number_of_tables; Plates; ");
		sb.append("Bibliographic_data; Editorial; Type; Keyword_1; Keyword_2; Keyword_3; ");
		sb.append("Name; Place; Abreviated_Name; ISSN; Language; ");
		sb.append("Catalogue_Number; Storing_place; Remarks; Date_Entry; ISBN; Abstract").append(lineFeed);
		
		Set<String> keys = LibrefTree.keySet();
		
		for (String str : keys)
		{
			Libref lr = LibrefTree.get(str);
			
			sb.append(lr.getAuthor_1()).append("; ").append(lr.getAuthor_2()).append("; ").append(lr.getAuthor_3()).append("; ");
			sb.append(lr.getAuthor_4()).append("; ").append(lr.getYear()).append("; ").append(lr.getEditor()).append("; ");
			sb.append(lr.getTitle()).append("; ").append(lr.getIn_Book_title()).append("; ").append(lr.getVolume()).append("; ");
			sb.append(lr.getPages()).append("; ").append(lr.getFigures()).append("; ").append(lr.getNumber_of_tables()).append("; ");
			sb.append(lr.getPlates()).append("; ").append(lr.getBibliographic_data()).append("; ").append(lr.getEditorial()).append("; ");
			sb.append(lr.getType()).append("; ").append(lr.getKeyword_1()).append("; ").append(lr.getKeyword_2()).append("; ").append(lr.getKeyword_3()).append("; ");
			if (lr.getPeriodical() != null)
			{
				Periodical pe = lr.getPeriodical();
				sb.append(pe.getName()).append("; ").append(pe.getPlace()).append("; ").append(pe.getAbreviated_Name()).append("; ").append(pe.getISSN()).append("; ").append(pe.getLanguage()).append("; ");
			}
			else
				sb.append(" ; ; ; ; ; ");
				
			
			sb.append(lr.getCatalogue_Number()).append("; ").append(lr.getStoring_place()).append("; ").append(lr.getRemarks()).append("; ").append(lr.getDate_Entry()).append("; ").append(lr.getISBN()).append("; ").append(lr.getAbstract()).append(lineFeed);
		}
		
		// Now Proving if there are periodicals without Libref. Save them explicitely.

		Set<String> keysob = PeriodicalTree.keySet();
			
		for (String sob : keysob)
		{
			Periodical SearchedPeriodical =PeriodicalTree.get(sob);
			Set<String> keysli = LibrefTree.keySet();
			boolean periodicalIsUsed = false;
			
			for (String sli : keysli)
			{
				Periodical LibrefPeriodical = LibrefTree.get(sli).getPeriodical();
				
				if (LibrefPeriodical == SearchedPeriodical)
				{
					 periodicalIsUsed = true; 
					 break;
				}	
			}
			
			if (periodicalIsUsed == false)
			{
				sb.append(" ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ; ");
				sb.append(SearchedPeriodical.getName()).append("; ").append(SearchedPeriodical.getPlace()).append("; ").append(SearchedPeriodical.getAbreviated_Name()).append("; ").append(SearchedPeriodical.getISSN()).append("; ").append(SearchedPeriodical.getLanguage()).append("; ");
				sb.append(" ; ; ; ; ; ").append(lineFeed);
			}
		}
		
		
		sb.append("Created_by_MayLib; Characterset: ").append(Characterset).append("; ");
		
		Date date = new Date(); 
	    SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HH:mm");		
	    sb.append(sdf.format(date)).append(lineFeed);		
		
		// Invoking the definitive writing
		String saveString = sb.toString();
		
		// In case no filename has been defined (=SAVE AS):
		if (Dateiname == null)
		{
			retvalue = (saveDataDialog(fileExtension, Characterset, saveString));
		}
		else
		{
			if (writeData(Dateiname, Characterset, saveString))
				retvalue = true;
			else 
				retvalue = (saveDataDialog(fileExtension, Characterset, saveString));
		}
		
		// Following is necessary to acccept the database as saved
		if (fileExtension.equalsIgnoreCase("UCF") && Characterset.equalsIgnoreCase("UTF-16") && (retvalue))
		{
			this.hasChanged = false;
			this.MayLibFile = this.lastWrittenFile;
			NameOfMayLibFile = fcFile.getName();
			this.setTitle("MayLib  ( " +NameOfMayLibFile+"  opened )");
		}
		
		return retvalue;	
	}
	
	private boolean queryExit()
	{
			
		// Benutzerdefinierten Button Text
		Object[] options = {"Yes", "No", "Cancel"};
		
		if (!this.hasChanged) return true;
		
		int retValue = JOptionPane.showOptionDialog(this, "The literature data have been changed.\nDo you want to save the changes?", "Save the changes?", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[2]);
		
		// Abbrechen ?
		if (retValue == 2) return false;
		
		// Ja - Speichern ?
		if (retValue == 0)
		{
			String fileExtension = "UCF", Characterset = "UTF-16";
			String Dateiname = this.MayLibFile;
			boolean result = saveMayLib(Dateiname, fileExtension, Characterset);
			
			if (result==true)
			{
				JOptionPane.showMessageDialog(null, "Changes in opened MayLib database saved (File: " + this.lastWrittenFile +").", "Data saved",
						JOptionPane.INFORMATION_MESSAGE);	
			}
			
			return result;
		}
		
		// Nein - Nicht speichern
		return true;			
	}
	

	protected boolean createReport(TreeSet<Object> ReportTreeSet, String ObjectType, String Headertext, String Abstract, String ReportType, String fileExtension, String Characterset)
	{
		boolean retvalue =false;
		
		/* Possible values:
		 * String ObjectType = Libref, Periodical
		 * String Headertext = null or a prepared text terminating without linefeed (linefeed will be added in the method createReport
		 * String Abstract  = without, 1000, full. Will be ignored, if ObjectType = Periodical
		 * String ReportType = basic, complete 
		 * String fileExtension = RPU, RPT
		 * String Characterset	= "UTF-16", Default_Charset, "UNKNOWN"	
		*/
		StringBuilder sb = new StringBuilder();

		if (Headertext != null)
			sb.append(Headertext).append(lineFeed).append(lineFeed);

		Iterator<Object> it = ReportTreeSet.iterator();

		while (it.hasNext())
		{
			// The following depends on if it is a Libref or a Periodical
			if (ObjectType.equalsIgnoreCase("Libref"))
			{
				Libref LibrefObj = (Libref) it.next();
				// Now we fill one reference

				if (ReportType.equalsIgnoreCase("basic"))
					sb.append(LibrefObj.toString());
				else if (ReportType.equalsIgnoreCase("complete"))
					sb.append(LibrefObj.expComplete());
				else if (ReportType.equalsIgnoreCase("GermanStandard"))
					sb.append(LibrefObj.expGermanStandard());
				else if (ReportType.equalsIgnoreCase("Palaeontology"))
					sb.append(LibrefObj.expPalaeontology());
				else if (ReportType.equalsIgnoreCase("BullGeosciencesPrague"))
					sb.append(LibrefObj.expBullGeoscPrague());
				else
					sb.append(LibrefObj.expComplete());

				if (!Abstract.equalsIgnoreCase("without"))
				{
					if (LibrefObj.getAbstract().length() > 0)
					{
						sb.append(lineFeed);
						// The LibrefObj.expComplete() ends with an linefeed.
						if (!ReportType.equalsIgnoreCase("complete"))
							sb.append(lineFeed);
					}

					if (Abstract.equals("1000") && LibrefObj.getAbstract().length() > 1000)
						sb.append(LibrefObj.getAbstract().substring(0, 1000));
					else if (Abstract.equals("2000") && LibrefObj.getAbstract().length() > 2000)
						sb.append(LibrefObj.getAbstract().substring(0, 2000));
					else if (Abstract.equals("4000") && LibrefObj.getAbstract().length() > 4000)
						sb.append(LibrefObj.getAbstract().substring(0, 4000));
					else
						sb.append(LibrefObj.getAbstract());

					sb.append(lineFeed).append("------------------------------").append(lineFeed);
				}
					
				
			}
			else
			{
				Periodical PeriodicalObj = (Periodical) it.next();
				// Now we fill one reference
				
				if (ReportType.equalsIgnoreCase("basic"))
					sb.append(PeriodicalObj.toString());
				else if (ReportType.equalsIgnoreCase("complete"))
					sb.append(PeriodicalObj.expComplete());
				else 
					sb.append(PeriodicalObj.expComplete());
			}
			// At the end of the line we make a linefeed
			sb.append(lineFeed);
		}

		sb.append(lineFeed).append("Created_by_MayLib; Characterset: ").append(Characterset).append("; ");

		Date date = new Date(); 
	    SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HH:mm");		
	    sb.append(sdf.format(date)).append(lineFeed);		
		
		// Invoking the definitive writing
		String saveString = sb.toString();
	
		retvalue = (saveDataDialog(fileExtension, Characterset, saveString));
		
		if (retvalue)
		{JOptionPane.showMessageDialog(null, "Report saved in file: " + this.lastWrittenFile +").", "Data saved",
				JOptionPane.INFORMATION_MESSAGE);
		}
		
		return retvalue;	
	}
	
	protected boolean reportAllLibrefs(String Abstract, String ReportType, String fileExtension, String Characterset)
	{
		TreeSet<Object> ReportTreeSet = prepareAllLibrefs(); 
		
		String ObjectType = "Libref";
		String Headertext = "All literature references of "+NameOfMayLibFile;

		return createReport(ReportTreeSet, ObjectType, Headertext, Abstract, ReportType, fileExtension, Characterset);	
	}
	

	protected boolean reportSelLibrefs(String Abstract, String ReportType, String fileExtension, String Characterset)
	{
		TreeSet<Object> ReportTreeSet = prepareSelLibrefs(); 
		
		String ObjectType = "Libref";
		String Headertext = "Selected literature references (Criteria: "+ this.LibrefQueryCriteria+") of "+NameOfMayLibFile;

		return createReport(ReportTreeSet, ObjectType, Headertext, Abstract, ReportType, fileExtension, Characterset);	
	}

	protected boolean reportAllPeriodicals(String ReportType, String fileExtension, String Characterset)
	{
		TreeSet<Object> ReportTreeSet = prepareAllPeriodicals(); 
		
		String ObjectType = "Periodical";
		String Headertext = "All periodicals of "+NameOfMayLibFile;

		return createReport(ReportTreeSet, ObjectType, Headertext, "without", ReportType, fileExtension, Characterset);	
	}

	protected boolean reportSelPeriodicals(String ReportType, String fileExtension, String Characterset)
	{
		TreeSet<Object> ReportTreeSet = prepareSelPeriodicals(); 
		
		String ObjectType = "Periodical";
		String Headertext = "Selected periodicals ("+LibrefQueryCriteria+") of "+NameOfMayLibFile;

		return createReport(ReportTreeSet, ObjectType, Headertext, "without", ReportType, fileExtension, Characterset);	
	}
	private void clearpopulateCboPeriod()
	{
		// Periodical
		cboPeriodicalPreselection ="";
		populatecboPeriodical();
		this.needpopulateCboPeriod = false;
	}
	private void clearpopulateCboOther()
	{	
		// Type

		cboTypePreselection ="";
		populatecboType();

		// Keyword

		cboKeywordPreselection ="";
		populatecboKeyword();
	
		// Year

		cboYearStartModel.removeAllElements();
		cboYearEndModel.removeAllElements();



		Iterator<String> i3t = LibrefYearSet.iterator();
		while (i3t.hasNext())
		{
			String DisplayObj = i3t.next();
			cboYearStartModel.addElement(DisplayObj);
			cboYearEndModel.addElement(DisplayObj);

		}

		cboYearStart.setSelectedIndex(0);
		cboYearEnd.setSelectedIndex(cboYearEndModel.getSize()-1);
		
		// Author

		cboAuthorPreselection ="";
		populatecboAuthor();
		
		this.needpopulateCboOther = false;
	}

	@Override
	public void keyPressed(KeyEvent e)
	{
		
		if (e.getKeyCode() == KeyEvent.VK_ENTER)
		{
			if (e.getSource().equals(btnSave))			
			{
				String fileExtension = "UCF", Characterset = "UTF-16";
				String Dateiname = this.MayLibFile;
				
				if (saveMayLib(Dateiname, fileExtension, Characterset))
				{JOptionPane.showMessageDialog(null, "Changes in opened MayLib database saved (File: " + this.lastWrittenFile +").", "Data saved",
						JOptionPane.INFORMATION_MESSAGE);
				}
			}
			
			else if (e.getSource().equals(btnReadUCF))
			{
				if (queryExit())
				{
					this.MayLibFile = null;
					hasChanged = false; 
					lastWrittenFile = null;
					needCleaningInternalLists = true; 
					openFileDialog("UTF-16");
				}
			}
			
			else if (e.getSource().equals(btnNewLibref))
			{
				LibrefDialog dlg = new LibrefDialog(null, this, null, null, null);
				dlg.showDialog(this);
			}
			else if (e.getSource().equals(btnNewPeriodical))
			{
				PeriodicalDialog dlg = new PeriodicalDialog(null, this, null, null, null);
				dlg.showDialog(this);
			}

			else if (e.getSource().equals(btnReport))
			{				
				String Abstract ="1000", ReportType = "GermanStandard", 
						fileExtension = "RPU", Characterset = "UTF-16";
				
				if (this.QueriedLibrefSet.size()>0)
					reportSelLibrefs(Abstract, ReportType, fileExtension, Characterset);
				else
					reportAllLibrefs(Abstract, ReportType, fileExtension, Characterset);		
			}		
			
			else if (e.getSource().equals(btnQuitApp))
			{
				windowClosing(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
			}

			else if (e.getSource().equals(btnbackGroundLbl))	
			{
				this.menuBar.setVisible(true);
				this.pnlLibrefsearch.setVisible(true);
				btnbackGroundLbl.setEnabled(false);

				if (MayLibFile == null && hasChanged == false && lastWrittenFile == null)
				{
					needCleaningInternalLists = true; 
					openFileDialog("UTF-16");
				}
				
				this.cboAuthor.requestFocusInWindow();
			}
			
			else if (e.getSource().equals(btnExecLibrefSearch_Table))	
			{
				if (fillQueriedLibrefSet())
				{
					showSelLibrefs();
					submenuSaveSearch.setEnabled(true);
				}
				btnClearLibrefSearch.setVisible(true);
			}
			
			else if (e.getSource().equals(btnExecLibrefSearch_Tree))	
			{
				if (fillQueriedLibrefSet())
				{
					LibrefSplitPane dlg = new LibrefSplitPane(this, "Libref");
					dlg.showDialog(this);
					submenuSaveSearch.setEnabled(true);
				}
				btnClearLibrefSearch.setVisible(true);
			}
			
			else if (e.getSource().equals(btnExecLibrefSearch_Dictionary))	
			{
				if (fillQueriedLibrefSet())
				{
					LibrefSplitPane dlg = new LibrefSplitPane(this, "Dictionary");
					dlg.showDialog(this);
					submenuSaveSearch.setEnabled(true);
				}
				btnClearLibrefSearch.setVisible(true);
			}
			
			else if (e.getSource().equals(btnExecLibrefSearch_Periodical))	
			{
				if (fillQueriedPeriodicals())
				{
					LibrefSplitPane dlg = new LibrefSplitPane(this, "Periodical");
					dlg.showDialog(this);
					submenuSaveSearch.setEnabled(true);
				}
				btnClearLibrefSearch.setVisible(true);
			}
			
			else if (e.getSource().equals(btnClearLibrefSearch))	
			{
				clearLibrefSearch();
			}
		    
			else

				kbFocusManager.focusNextComponent();
		}
		
	}

	@Override
	public void keyReleased(KeyEvent arg0)
	{
		// TODO Auto-generated method stub
		
	}

	@Override
	public void keyTyped(KeyEvent e)
	{
		if ((e.getSource() instanceof JComboBox)
				&& (Character.isLetterOrDigit(e.getKeyChar()) || e.getKeyChar() == '-' || e.getKeyChar() == '&'
				|| e.getKeyChar() == ',' || e.getKeyChar() == '.' || e.getKeyChar() == ' '))
		{
			if (e.getSource().equals(cboAuthor))
			{
				cboAuthorPreselection += e.getKeyChar();
				cboAuthor.hidePopup();
				e.consume();
				populatecboAuthor();
				cboAuthor.showPopup();
			}

			else if (e.getSource().equals(cboKeyword))
			{
				cboKeywordPreselection += e.getKeyChar();
				cboKeyword.hidePopup();
				e.consume();
				populatecboKeyword();
				cboKeyword.showPopup();
			}

			else if (e.getSource().equals(cboPeriodical))
			{
				cboPeriodicalPreselection += e.getKeyChar();
				cboPeriodical.hidePopup();
				e.consume();
				populatecboPeriodical();
				cboPeriodical.showPopup();
			}

			else if (e.getSource().equals(cboType))
			{
				cboTypePreselection += e.getKeyChar();
				cboType.hidePopup();
				e.consume();
				populatecboType();
				cboType.showPopup();
			}
		}
		
		else if (e.getSource().equals(btnbackGroundLbl))
		{
			this.menuBar.setVisible(true);
			this.pnlLibrefsearch.setVisible(true);
			btnbackGroundLbl.setEnabled(false);

			if (MayLibFile == null && hasChanged == false && lastWrittenFile == null 
					&& LibrefTree.size() == 0 && PeriodicalTree.size() == 0)
			{
				openFileDialog("UTF-16");
			}
			
			this.cboAuthor.requestFocusInWindow();
		}

	}

	private boolean fillQueriedLibrefSet()
	{
		LibrefQueryCriteria = "";
		QueriedLibrefSet.clear();
		statusBar.setMessage("Search cleaned. No lists, trees or reports on sought literature are possible.");

		Set<String> keys = LibrefTree.keySet();

		for (String s : keys)
		{
			Libref qlib = LibrefTree.get(s);

			if (queryLibrefs(qlib))
				QueriedLibrefSet.add(qlib);
		}

		if (QueriedLibrefSet.size() > 0)
		{
			miShowSelLibrefs.setEnabled(true);
			miReportSelLibrefs.setEnabled(true);
			miTreeLibref.setEnabled(true);  
			miTreeDictionary.setEnabled(true);  
			miTreePeriodical.setEnabled(true);   

			// / Fill the search string

			String qs;
			LibrefQueryCriteria = "";

			if (this.cboAuthor.getSelectedIndex() > 0)
			{
				qs = (String) cboAuthor.getItemAt(cboAuthor.getSelectedIndex());
				LibrefQueryCriteria += "Author = " + qs + "; ";
			}

			if (this.cboKeyword.getSelectedIndex() > 0)
			{
				qs = (String) cboKeyword.getItemAt(cboKeyword.getSelectedIndex());
				LibrefQueryCriteria += "Keyword = " + qs + "; ";
			}

			if (tfKeyword_2.getText().trim().length() > 0)
			{
				qs = tfKeyword_2.getText().trim();
				LibrefQueryCriteria += "Keyword = " + qs + "; ";
			}
			
			if (tfRemarks.getText().trim().length() > 0)
			{
				qs = tfRemarks.getText().trim();
				LibrefQueryCriteria += "Remarks = " + qs + "; ";
			}

			if (this.cboYearStart.getSelectedIndex() > 0)
			{
				qs = (String) cboYearStart.getItemAt(cboYearStart.getSelectedIndex());
				LibrefQueryCriteria += "Year from = " + qs + "; ";
			}

			if (this.cboYearEnd.getSelectedIndex() < (cboYearEndModel.getSize() - 1))
			{
				qs = (String) cboYearEnd.getItemAt(cboYearEnd.getSelectedIndex());
				LibrefQueryCriteria += "Year to = " + qs + "; ";
			}

			if (tfTitlePartSearch.getText().trim().length() > 0)
			{
				if (cboTextSeek.getSelectedIndex() == 0)
				{
				qs = tfTitlePartSearch.getText().trim();
				LibrefQueryCriteria += "Title = " + qs + "; ";
				}
				else if (cboTextSeek.getSelectedIndex() ==1)
				{
				qs = tfTitlePartSearch.getText().trim();
				LibrefQueryCriteria += "Title or abstract = " + qs + "; ";
				}
				
			}
			// end of tfTitlePartSearch.getText
			
			if (tfYearSearch.getText().trim().length() > 0)
			{
				qs = tfYearSearch.getText().trim();
				LibrefQueryCriteria += "Year = " + qs + "...; ";
			}

			if (this.cboType.getSelectedIndex() > 0)
			{
				qs = (String) cboType.getItemAt(cboType.getSelectedIndex());
				LibrefQueryCriteria += "Type = " + qs + "; ";
			}

			if (this.cboPeriodical.getSelectedIndex() > 0)
			{
				Periodical ls = (Periodical) cboPeriodical.getItemAt(cboPeriodical.getSelectedIndex());
				LibrefQueryCriteria += "Periodical = " + ls.toString() + ". ";
			}

			if (LibrefQueryCriteria.trim().length() == 0)
				LibrefQueryCriteria = "All literature references";

			statusBar.setMessage("Search criteria: "+LibrefQueryCriteria);
			
			return true;
		}
		else
		{
			miShowSelLibrefs.setEnabled(false);
			miReportSelLibrefs.setEnabled(false);
			miTreeLibref.setEnabled(false);  
			miTreeDictionary.setEnabled(false);  
			miTreePeriodical.setEnabled(false);   

			JOptionPane.showMessageDialog(null, "This search did not find any matching literature reference!", "No search result",
					JOptionPane.INFORMATION_MESSAGE);
			return false;
		}
	}

	private boolean queryLibrefs(Libref qlib)
	{
		String qs;
				
		if (this.cboAuthor.getSelectedIndex() > 0)
		{				
			 qs = (String)cboAuthor.getItemAt(cboAuthor.getSelectedIndex());
			 
			 if (!qlib.getAuthor_1().contains(qs))
			 { 
				 if (!qlib.getAuthor_2().contains(qs))
				 { 
					 if (!qlib.getAuthor_3().contains(qs))
					 { 
						 if (!qlib.getAuthor_4().contains(qs))
						 { 
							 return false;
						 }
					 }
				 }
			 }
			
		}
		//end of if (this.cboAuthor.getSelectedIndex() > 0)
		
		if (this.cboKeyword.getSelectedIndex() > 0)
		{
			 qs = (String)cboKeyword.getItemAt(cboKeyword.getSelectedIndex());
			 
			 if (!qlib.getKeyword_1().contains(qs))
			 { 
				 if (!qlib.getKeyword_2().contains(qs))
				 { 
					 if (!qlib.getKeyword_3().contains(qs))
					 { 						
							 return false;
					 }
				 }
			 }
			
		}
		//end of if (this.cboKeyword.getSelectedIndex() > 0)
		
		if (tfKeyword_2.getText().trim().length() > 0)
		{
			 qs = tfKeyword_2.getText().trim().toLowerCase();
			 
			 if (!qlib.getKeyword_1().toLowerCase().contains(qs))
			 { 
				 if (!qlib.getKeyword_2().toLowerCase().contains(qs))
				 { 
					 if (!qlib.getKeyword_3().toLowerCase().contains(qs))
					 { 						
							 return false;						
					 }
				 }
			 }
		}
		//end of tfKeyword_2.getText
		
		
		if (this.cboYearStart.getSelectedIndex() > 0)
		{
			 qs = (String)cboYearStart.getItemAt(cboYearStart.getSelectedIndex());
			 
			 if (qlib.getYear().compareToIgnoreCase(qs) < 0)
			 { 
				 return false;
			 }
			
		}

		if (this.cboYearEnd.getSelectedIndex() < (cboYearEndModel.getSize()-1))
		{
			 qs = (String)cboYearEnd.getItemAt(cboYearEnd.getSelectedIndex()) + "";
			 
			 if (qlib.getYear().compareToIgnoreCase(qs) > 0)
			 { 
				 return false;
			 }
			
		}
		
		if (tfTitlePartSearch.getText().trim().length() > 0)
		{
			 qs = tfTitlePartSearch.getText().trim().toLowerCase();
			 
			 if (!qlib.getTitle().toLowerCase().contains(qs))
			 { 
				 if (!qlib.getIn_Book_title().toLowerCase().contains(qs))
				 { 
					 if (cboTextSeek.getSelectedIndex() == 0)
						{
							return false;
						}
						else if (cboTextSeek.getSelectedIndex() ==1)
						{
							if (!qlib.getAbstract().toLowerCase().contains(qs))
								return false;
						}
							 
				 }
			 }
		}
		
		//end of tfTitlePartSearch.getText
		
		if (tfRemarks.getText().trim().length() > 0)
		{
			 qs = tfRemarks.getText().trim().toLowerCase();
			 
			 if (!qlib.getRemarks().toLowerCase().contains(qs))
			 { 
							 return false;
			 }
		}
		
		//end of tfRemarks.getText
		
		if (tfYearSearch.getText().trim().length() > 0)
		{
			 qs = tfYearSearch.getText().trim().toLowerCase();
			 
			 if (!qlib.getYear().toLowerCase().startsWith(qs))
			 { 
							 return false;
			 }
		}
		
		if (this.cboType.getSelectedIndex() > 0)
		{
			 qs = (String)cboType.getItemAt(cboType.getSelectedIndex());
			 
			 if (!qlib.getType().contains(qs))						
							 return false;				
		}
		

		if (this.cboPeriodical.getSelectedIndex() > 0)
		{
			 if (qlib.getPeriodical() == null)
				 return false;	
			
			 Periodical ls = (Periodical)cboPeriodical.getItemAt(cboPeriodical.getSelectedIndex());
			 
			 if (!qlib.getPeriodical().equals(ls))						
					return false;				
		}
	
		return true;
	}
	
	private void populatecboAuthor()
	{
		// Author

		cboAuthorModel.removeAllElements();

		cboAuthorModel.addElement("  (no Filter) ");

		Iterator<String> i4t = LibrefAuthorSet.iterator();
		while (i4t.hasNext())

		{
			String DisplayObj = i4t.next();
			
			if (DisplayObj.toLowerCase().startsWith(cboAuthorPreselection.toLowerCase()))
				cboAuthorModel.addElement(DisplayObj);
		}

		cboAuthorModel.addElement("-------------------");

		Iterator<String> i5t = LibrefOtherAuthorsSet.iterator();
		while (i5t.hasNext())

		{
			String DisplayObj = i5t.next();
			if (DisplayObj.toLowerCase().startsWith(cboAuthorPreselection.toLowerCase()))
				cboAuthorModel.addElement(DisplayObj);
		}

		if (cboAuthorModel.getSize() > 2 && cboAuthorPreselection.trim().length() > 0)
			cboAuthor.setSelectedIndex(1);
		else if (cboAuthorModel.getSize() < 3 && cboAuthorPreselection.trim().length() > 0)
		{
			cboAuthorPreselection = "";
			populatecboAuthor();
		}
		else
			cboAuthor.setSelectedIndex(0);	
	}
	
	private void populatecboKeyword()
	{
		// Keyword

		cboKeywordModel.removeAllElements();

		cboKeywordModel.addElement("  (no Filter) ");

		Iterator<String> i4t = LibrefKeywordSet.iterator();
		while (i4t.hasNext())

		{
			String DisplayObj = i4t.next();
			
			if (DisplayObj.toLowerCase().startsWith(cboKeywordPreselection.toLowerCase()))
				cboKeywordModel.addElement(DisplayObj);
		}

		if (cboKeywordModel.getSize() > 1 && cboKeywordPreselection.trim().length() > 0)
			cboKeyword.setSelectedIndex(1);
		else if (cboKeywordModel.getSize() < 2 && cboKeywordPreselection.trim().length() > 0)
		{
			cboKeywordPreselection = "";
			populatecboKeyword();
		}
		else
			cboKeyword.setSelectedIndex(0);	
	}
	
	private void populatecboType()
	{
		// Type

		cboTypeModel.removeAllElements();

		cboTypeModel.addElement("  (no Filter) ");

		Iterator<String> i4t = LibrefTypeSet.iterator();
		while (i4t.hasNext())

		{
			String DisplayObj = i4t.next();
			
			if (DisplayObj.toLowerCase().startsWith(cboTypePreselection.toLowerCase()))
				cboTypeModel.addElement(DisplayObj);
		}

		if (cboTypeModel.getSize() > 1 && cboTypePreselection.trim().length() > 0)
			cboType.setSelectedIndex(1);
		else if (cboTypeModel.getSize() < 2 && cboTypePreselection.trim().length() > 0)
		{
			cboTypePreselection = "";
			populatecboType();
		}
		else
			cboType.setSelectedIndex(0);	
	}
	
	private boolean fillQueriedPeriodicals()
	{
		LibrefQueryCriteria = "";
		String qs = "";
		QueriedLibrefSet.clear();
		QueriedPeriodicalSet.clear();
		statusBar.setMessage("Search cleaned. No lists, trees or reports on sought data are possible.");

		if (tfPerPeriodical.getText().trim().length() > 0)
		{
			qs = tfPerPeriodical.getText().trim().toLowerCase();
			LibrefQueryCriteria = "Periodical = "+ qs;

			Set<String> keype = PeriodicalTree.keySet();

			for (String s : keype)
			{
				Periodical qper = PeriodicalTree.get(s);

				if (qper.getName().toLowerCase().contains(qs))
					QueriedPeriodicalSet.add(qper);
			}
		}
		else
		{
			LibrefQueryCriteria = "All periodicals";

			Set<String> keype = PeriodicalTree.keySet();

			for (String s : keype)
			{
				Periodical qper = PeriodicalTree.get(s);
				QueriedPeriodicalSet.add(qper);
			}
		}

		Set<String> keys = LibrefTree.keySet();

		for (String s2 : keys)
		{
			Libref qlib = LibrefTree.get(s2);
			
			if (qlib.getPeriodical() != null)
			{
				Periodical pertest = qlib.getPeriodical();

				if (QueriedPeriodicalSet.contains(pertest))
					QueriedLibrefSet.add(qlib);
			}
		}

		if (QueriedPeriodicalSet.size() > 0)
		{
			miShowSelPeriodicals.setEnabled(true);
			miReportSelPeriodicals.setEnabled(true);
			statusBar.setMessage("Search criteria: "+LibrefQueryCriteria);
		}
			
		if (QueriedLibrefSet.size() > 0)
		{
			miShowSelLibrefs.setEnabled(true);
			miReportSelLibrefs.setEnabled(true);
			miTreeLibref.setEnabled(true);  
			miTreeDictionary.setEnabled(true);  
			miTreePeriodical.setEnabled(true);   
			
			return true;
		}
		else
		{
			miShowSelLibrefs.setEnabled(false);
			miReportSelLibrefs.setEnabled(false);
			miTreeLibref.setEnabled(false);  
			miTreeDictionary.setEnabled(false);  
			miTreePeriodical.setEnabled(false);   

			JOptionPane.showMessageDialog(null, "This search did not find any matching literature reference!", "No search result",
					JOptionPane.INFORMATION_MESSAGE);
			return false;
		}
	}
	
	private void populatecboPeriodical()
	{
		// Periodical

		cboPeriodicalModel.removeAllElements();
		cboPeriodicalModel.addElement("  (no Filter) ");
		
		Set<String> keys = PeriodicalTree.keySet();
		
		for (String s : keys)
		{
			Periodical listper = PeriodicalTree.get(s);
			if (listper.getName().toLowerCase().startsWith(cboPeriodicalPreselection.toLowerCase()))
			   cboPeriodicalModel.addElement( listper);
		}

		if (cboPeriodicalModel.getSize() > 1 && cboPeriodicalPreselection.trim().length() > 0)
			cboPeriodical.setSelectedIndex(1);
		else if (cboPeriodicalModel.getSize() < 2 && cboPeriodicalPreselection.trim().length() > 0)
		{
			cboPeriodicalPreselection = "";
			populatecboPeriodical();
		}
		else
			cboPeriodical.setSelectedIndex(0);	
	}
	
	private void clearLibrefSearch()
	{
		QueriedLibrefSet.clear();
		QueriedPeriodicalSet.clear();
		LibrefQueryCriteria = "";	
		tfKeyword_2.setText("");
		tfTitlePartSearch.setText("");
		tfRemarks.setText("");
		tfPerPeriodical.setText("");
		tfYearSearch.setText("");
		
		clearpopulateCboPeriod();
		clearpopulateCboOther();
		
		btnClearLibrefSearch.setVisible(false);
		miShowSelLibrefs.setEnabled(false);
		miShowSelPeriodicals.setEnabled(false);
		miReportSelLibrefs.setEnabled(false);
		miReportSelPeriodicals.setEnabled(false);
		submenuSaveSearch.setEnabled(false);
		miTreeLibref.setEnabled(false);  
		miTreeDictionary.setEnabled(false);  
		miTreePeriodical.setEnabled(false);  
		
		statusBar.setMessage("Search cleaned. No lists, trees or reports on sought data are possible.");
	}
	

	protected boolean saveSearchedMayLib(String fileExtension, String Characterset)
	{
		boolean retvalue =false;
			
	/*	
		0 Author_1 
		1 Author_2 
		2 Author_3 
		3 Author_4 
		4 Year 
		5 Editor
		6 Title 
		7 In_Book_title 
		8 Volume 
		9 Pages 
		10 Figures 
		11 Number_of_tables 
		12 Plates 
		13 Bibliographic_data 
		14 Editorial 
		15 Type 
		16 Keyword_1 
		17 Keyword_2 
		18 Keyword_3 
		19 Name 
		20 Place 
		21 Abreviated_Name 
		22 ISSN 
		23 Language
		24 Catalogue_Number 
		25 Storing_place 
		26 Remarks 
		27 Date_Entry 
		28 ISBN 
		29 Abstract	
		
		*/
		
		StringBuilder sb = new StringBuilder();
		sb.append("Author_1; Author_2; Author_3; Author_4; Year; Editor; Title; ");
		sb.append("In_Book_title; Volume; Pages; Figures; Number_of_tables; Plates; ");
		sb.append("Bibliographic_data; Editorial; Type; Keyword_1; Keyword_2; Keyword_3; ");
		sb.append("Name; Place; Abreviated_Name; ISSN; Language; ");
		sb.append("Catalogue_Number; Storing_place; Remarks; Date_Entry; ISBN; Abstract").append(lineFeed);
		
		
		Iterator<Libref> i2t = this.QueriedLibrefSet.iterator();
		while (i2t.hasNext())
		{
			Libref lr = i2t.next();
			
			sb.append(lr.getAuthor_1()).append("; ").append(lr.getAuthor_2()).append("; ").append(lr.getAuthor_3()).append("; ");
			sb.append(lr.getAuthor_4()).append("; ").append(lr.getYear()).append("; ").append(lr.getEditor()).append("; ");
			sb.append(lr.getTitle()).append("; ").append(lr.getIn_Book_title()).append("; ").append(lr.getVolume()).append("; ");
			sb.append(lr.getPages()).append("; ").append(lr.getFigures()).append("; ").append(lr.getNumber_of_tables()).append("; ");
			sb.append(lr.getPlates()).append("; ").append(lr.getBibliographic_data()).append("; ").append(lr.getEditorial()).append("; ");
			sb.append(lr.getType()).append("; ").append(lr.getKeyword_1()).append("; ").append(lr.getKeyword_2()).append("; ").append(lr.getKeyword_3()).append("; ");
			if (lr.getPeriodical() != null)
			{
				Periodical pe = lr.getPeriodical();
				sb.append(pe.getName()).append("; ").append(pe.getPlace()).append("; ").append(pe.getAbreviated_Name()).append("; ").append(pe.getISSN()).append("; ").append(pe.getLanguage()).append("; ");
			}
			else
				sb.append(" ; ; ; ; ; ");
				
			
			sb.append(lr.getCatalogue_Number()).append("; ").append(lr.getStoring_place()).append("; ").append(lr.getRemarks()).append("; ").append(lr.getDate_Entry()).append("; ").append(lr.getISBN()).append("; ");
			
			if (fileExtension.equalsIgnoreCase("CSV"))
			{
				String absss = lr.getAbstract();
				if (absss.length() > 20000)
					absss = lr.getAbstract().substring(0, 20000);
				
				sb.append(absss);
			}
			else 
				sb.append(lr.getAbstract());
			
			sb.append(lineFeed);
		}
		
		
		sb.append(lineFeed).append(this.LibrefQueryCriteria).append("; ").append("Created_by_MayLib; Characterset: ").append(Characterset).append("; ");
		
		Date date = new Date(); 
	    SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HH:mm");		
	    sb.append(sdf.format(date)).append(lineFeed);		
		
		// Invoking the definitive writing
		String saveString = sb.toString();
		
		retvalue = (saveDataDialog(fileExtension, Characterset, saveString));
		
		return retvalue;	
	}	
	
	private void setBackgroundColor(String strbackgroundcolor)
	{
		if (strbackgroundcolor.equalsIgnoreCase("brown"))
		{
			this.BackGroundColor = new Color(255, 195, 119);
			this.miBrown.setSelected(true);
		}
		else if (strbackgroundcolor.equalsIgnoreCase("blue"))
		{
			this.BackGroundColor = new Color(192, 223, 255);
			this.miBlue.setSelected(true);
		}
		else if (strbackgroundcolor.equalsIgnoreCase("pink"))
		{
			this.BackGroundColor = new Color(255, 203, 200);
			this.miPink.setSelected(true);
		}
		else if (strbackgroundcolor.equalsIgnoreCase("yellow"))
		{
			this.BackGroundColor = new Color(233, 255, 79);
			this.miYellow.setSelected(true);
		}
		else if (strbackgroundcolor.equalsIgnoreCase("green"))
		{
			this.BackGroundColor = new Color(150, 255, 140);
			this.miGreen.setSelected(true);
		}
		else if (strbackgroundcolor.equalsIgnoreCase("gray")||strbackgroundcolor.equalsIgnoreCase("grey"))
		{
			this.BackGroundColor = new Color(225,225,225);
			this.miGray.setSelected(true);
		}
		else
		{
			strbackgroundcolor = "gray";
			this.BackGroundColor = new Color(225,225,225);
			this.miGray.setSelected(true);
		}
		
		this.strBackGroundColor = strbackgroundcolor;
		this.getContentPane().setBackground(this.BackGroundColor);
		this.pnlLibrefsearch.setBackground(this.BackGroundColor);

	}
	
	private void ReadProperties(String Dateiname)
	{

		int x = 0;
		int y = 0;
		int width = -1;
		int height = -1;
		String property;
		String propMaximizeWindow ="";
		String propstrBackGroundColor ="";
		int propfontSize =-1;
		String propMayLibFile ="";
		String propUnknown_Encoding ="";
		String propstrexecRepCharset ="";
		
		Reader reader = null;

		try
		{
			reader = new FileReader(Dateiname);
			Properties prop = new Properties();
			prop.load(reader);

			property = prop.getProperty("Location.X");
			if (property != null) x = Integer.parseInt(property);
			property = prop.getProperty("Location.Y");
			if (property != null) y = Integer.parseInt(property);
			property = prop.getProperty("Width");
			if (property != null) width = Integer.parseInt(property);
			property = prop.getProperty("Height");
			if (property != null) height  = Integer.parseInt(property);
			
			property = prop.getProperty("MaximizeWindow");
			if (property != null) propMaximizeWindow = property;
			property = prop.getProperty("strBackGroundColor");
			if (property != null) propstrBackGroundColor = property;
			property = prop.getProperty("fontSize");
			if (property != null) propfontSize = Integer.parseInt(property);
			property = prop.getProperty("MayLibFile");
			if (property != null) propMayLibFile = property;
			property = prop.getProperty("Unknown_Encoding");
			if (property != null) propUnknown_Encoding = property;	
			property = prop.getProperty("strexecRepCharset");
			if (property != null) propstrexecRepCharset = property;	
			
			property = prop.getProperty("LibrefDialog_X");
			if (property != null)  LibrefDialog_X= Integer.parseInt(property);
			property = prop.getProperty("LibrefDialog_Y");
			if (property != null)  LibrefDialog_Y= Integer.parseInt(property);
			property = prop.getProperty("LibrefDialog_Width");
			if (property != null)  LibrefDialog_Width= Integer.parseInt(property);
			property = prop.getProperty("LibrefDialog_Height");
			if (property != null)  LibrefDialog_Height= Integer.parseInt(property);
			property = prop.getProperty("LibrefSplitPane_X");
			if (property != null)  LibrefSplitPane_X= Integer.parseInt(property);
			property = prop.getProperty("LibrefSplitPane_Y");
			if (property != null)  LibrefSplitPane_Y= Integer.parseInt(property);
			property = prop.getProperty("LibrefSplitPane_Width");
			if (property != null)  LibrefSplitPane_Width= Integer.parseInt(property);
			property = prop.getProperty("LibrefSplitPane_Height");
			if (property != null)  LibrefSplitPane_Height= Integer.parseInt(property);
			property = prop.getProperty("MayLibTable_X");
			if (property != null)  MayLibTable_X= Integer.parseInt(property);
			property = prop.getProperty("MayLibTable_Y");
			if (property != null)  MayLibTable_Y= Integer.parseInt(property);
			property = prop.getProperty("MayLibTable_Width");
			if (property != null)  MayLibTable_Width= Integer.parseInt(property);
			property = prop.getProperty("MayLibTable_Height");
			if (property != null)  MayLibTable_Height= Integer.parseInt(property);
			property = prop.getProperty("PeriodicalDialog_X");
			if (property != null)  PeriodicalDialog_X= Integer.parseInt(property);
			property = prop.getProperty("PeriodicalDialog_Y");
			if (property != null)  PeriodicalDialog_Y= Integer.parseInt(property);
			property = prop.getProperty("PeriodicalDialog_Width");
			if (property != null)  PeriodicalDialog_Width= Integer.parseInt(property);
			property = prop.getProperty("PeriodicalDialog_Height");
			if (property != null)  PeriodicalDialog_Height= Integer.parseInt(property);		
			
		}
		catch (IOException ex) 	{}
		finally
		{
			// Die close_Methode wirft eine Ausnahmebedingung.
			// Deshalb muss sie in einer try-catch-Anweisung formuliert
			// werden.
			try
			{
				reader.close();
			}
			catch (Exception ex) {	}
		}
		
		// at first font, backgroundcolor, MaximizeWindow, 
		// because MaximizeWindow affects position and size of the window
		if (propfontSize > 7 && propfontSize < 20)
			setmyFont(propfontSize);
		
		if (propstrBackGroundColor.trim().length() > 2)
			setBackgroundColor(propstrBackGroundColor.trim());
		
		if (propMaximizeWindow.trim().length() > 2)
			execMaximizeWindow(propMaximizeWindow.trim());	
		
		if (propstrexecRepCharset.trim().length() > 2)
			execRepCharset(strexecRepCharset.trim());
		
		// later actual size and position of the window
		if (width == -1) width = this.getWidth();
		if (height == -1) height = this.getHeight();
		
		this.setBounds(x, y, width, height);
		
		//finally file and encoding
		
		if (propMayLibFile.trim().length() > 2)
		{
		  // Prove the existence
			File f = new File(propMayLibFile.trim());
			
			if (f.exists() && f.isFile())
			{
				this.fcFile = f;
						
				statusBar.setMessage("Reading "+propMayLibFile.trim());
				// Thread zum Einlesen der Postleitzahlen verwenden.
				Thread t = new Thread(new ReadFileIntoLib(f, "UTF-16"));
				t.start();	
			}
		}
		
		if (propUnknown_Encoding.trim().length() > 2)
			this.Unknown_Encoding = propUnknown_Encoding.trim();			

	}
	
	private void WriteProperties(String Dateiname)
	{
		Writer writer = null;
		
		File f = new File(Dateiname);
		f = new File(f.getParent());
		
		if (!f.exists())
			f.mkdirs();

		Properties prop = new Properties();

		prop.setProperty("Location.X", String.valueOf(this.getLocation().x));
		prop.setProperty("Location.Y", String.valueOf(this.getLocation().y));
		prop.setProperty("Width", String.valueOf(this.getWidth()));
		prop.setProperty("Height", String.valueOf(this.getHeight()));
		prop.setProperty("MaximizeWindow", this.MaximizeWindow);
		prop.setProperty("strBackGroundColor", this.strBackGroundColor);
		prop.setProperty("fontSize", String.valueOf(this.fontSize));
		prop.setProperty("MayLibFile", ((this.MayLibFile != null) ? this.MayLibFile : " "));
		prop.setProperty("Unknown_Encoding", ((this.Unknown_Encoding != null) ? this.Unknown_Encoding : " "));
		prop.setProperty("strexecRepCharset", this.strexecRepCharset);
		
		prop.setProperty("LibrefDialog_X", String.valueOf(this.LibrefDialog_X));
		prop.setProperty("LibrefDialog_Y", String.valueOf(this.LibrefDialog_Y));
		prop.setProperty("LibrefDialog_Width", String.valueOf(this.LibrefDialog_Width));
		prop.setProperty("LibrefDialog_Height", String.valueOf(this.LibrefDialog_Height));
		prop.setProperty("LibrefSplitPane_X", String.valueOf(this.LibrefSplitPane_X));
		prop.setProperty("LibrefSplitPane_Y", String.valueOf(this.LibrefSplitPane_Y));
		prop.setProperty("LibrefSplitPane_Width", String.valueOf(this.LibrefSplitPane_Width));
		prop.setProperty("LibrefSplitPane_Height", String.valueOf(this.LibrefSplitPane_Height));
		prop.setProperty("MayLibTable_X", String.valueOf(this.MayLibTable_X));
		prop.setProperty("MayLibTable_Y", String.valueOf(this.MayLibTable_Y));
		prop.setProperty("MayLibTable_Width", String.valueOf(this.MayLibTable_Width));
		prop.setProperty("MayLibTable_Height", String.valueOf(this.MayLibTable_Height));
		prop.setProperty("PeriodicalDialog_X", String.valueOf(this.PeriodicalDialog_X));
		prop.setProperty("PeriodicalDialog_Y", String.valueOf(this.PeriodicalDialog_Y));
		prop.setProperty("PeriodicalDialog_Width", String.valueOf(this.PeriodicalDialog_Width));
		prop.setProperty("PeriodicalDialog_Height", String.valueOf(this.PeriodicalDialog_Height));
		
		try
		{
			writer = new FileWriter(Dateiname);
			prop.store(writer, null);
		}
		catch (IOException ex)
		{
		}
		finally
		{
			// Die close_Methode wirft eine Ausnahmebedingung.
			// Deshalb muss sie in einer try-catch-Anweisung formuliert
			// werden.
			try
			{
				writer.close();
			}
			catch (Exception ex) {	}
		}
	}	
	
	private boolean execRecentLibref(String strMostAll)
	{
		LibrefQueryCriteria = "";
		QueriedLibrefSet.clear();
		statusBar.setMessage("Search cleaned. No lists, trees or reports on sought literature are possible.");

		String Recentdate =" ";
		String qlibdate =" ";
		
		Set<String> keys = LibrefTree.keySet();

		for (String s : keys)
		{
			Libref qlib = LibrefTree.get(s);

			// DateFormat("yyyyMMdd_HH:mm") -- a correct date is 14 characters
			// long
			if (qlib.getDate_Entry().length() > 13)
			{

				if (strMostAll.equalsIgnoreCase("Most"))
					qlibdate = qlib.getDate_Entry().substring(0, 14);
				else
					qlibdate = qlib.getDate_Entry().substring(0, 7);  // a time span of 10 days

				if (qlibdate.compareToIgnoreCase(Recentdate) > 0)
				{
					Recentdate = qlibdate;
					QueriedLibrefSet.clear();
					QueriedLibrefSet.add(qlib);
				}

				else if (qlibdate.compareToIgnoreCase(Recentdate) == 0)
				{

					QueriedLibrefSet.add(qlib);
				}

			}
		}
		
		if (QueriedLibrefSet.size() > 0)
		{
			miShowSelLibrefs.setEnabled(true);
			miReportSelLibrefs.setEnabled(true);
			miTreeLibref.setEnabled(true);  
			miTreeDictionary.setEnabled(true);  
			miTreePeriodical.setEnabled(true);   

			LibrefQueryCriteria = "Recent literature references (created "+Recentdate+
					((strMostAll.equalsIgnoreCase("All")) ? "..." : "")+	")";

			statusBar.setMessage("Search criteria: "+LibrefQueryCriteria);
			
			return true;
		}
		else
		{
			miShowSelLibrefs.setEnabled(false);
			miReportSelLibrefs.setEnabled(false);
			miTreeLibref.setEnabled(false);  
			miTreeDictionary.setEnabled(false);  
			miTreePeriodical.setEnabled(false);   

			JOptionPane.showMessageDialog(null, "This search did not find any matching literature reference!", "No search result",
					JOptionPane.INFORMATION_MESSAGE);
			return false;
		}
	}
	
	private void execMaximizeWindow(String MaximizeWindowType)
	{
		if (MaximizeWindowType.equalsIgnoreCase("none"))
		{
			this.MaximizeWindow = "none";
			this.setBounds(10, 10, 800, 480);
			this.miMaxNone.setSelected(true);
			// makeFrameFullSize()
		}

		else if (MaximizeWindowType.equalsIgnoreCase("all"))
		{
			// Windowsize
			this.MaximizeWindow = "all";
			this.miMaxAll.setSelected(true);
			makeFrameFullSize();
		}

		else
		{
			// Windowsize
			this.MaximizeWindow = "big";
			this.setBounds(10, 10, 800, 480);
			this.miMaxBig.setSelected(true);
			// makeFrameFullSize()
		}
	}
	
	protected void execRepCharset(String strexecRepCharset)
	{
		if (strexecRepCharset.equalsIgnoreCase("Unicode"))
		{
		this.strexecRepCharset = "Unicode"; 
		miRepUnicode.setSelected(true);
		}
		else if (strexecRepCharset.equalsIgnoreCase("Default"))
		{
		this.strexecRepCharset = "Default"; 
		miRepDefault.setSelected(true);
		}
		else if (strexecRepCharset.equalsIgnoreCase("Unknown"))
		{
		this.strexecRepCharset = "Unknown"; 
		miRepUnknown.setSelected(true);
		}

		else 
		{
			this.strexecRepCharset = "Unicode"; 
			miRepUnicode.setSelected(true);
		}
			
	}
	
	private void clearWindowSize()
	{
		LibrefDialog_X=0;
		LibrefDialog_Y=0;
		LibrefDialog_Width=-1;
		LibrefDialog_Height=-1;
		LibrefSplitPane_X=0;
		LibrefSplitPane_Y=0;
		LibrefSplitPane_Width=-1;
		LibrefSplitPane_Height=-1;
		MayLibTable_X=0;
		MayLibTable_Y=0;
		MayLibTable_Width=-1;
		MayLibTable_Height=-1;
		PeriodicalDialog_X=0;
		PeriodicalDialog_Y=0;
		PeriodicalDialog_Width=-1;
		PeriodicalDialog_Height=-1;
	}
}

	
